--------------------------------------------------------------------------------
-- Module Tool: Tool_01.lua
-- Name: PEST: Pattern Editor Specific Templates
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- INSTRUMENTS INFO
--------------------------------------------------------------------------------

--[[ Instruments------------------------------------------------------

<< SYMPHONY ORCHESTRA______________
String family--
  solo_string, first_violins, second_violins, violas, cellos, basses

Woodwind family--
  flute, piccolo, oboe, english_horn, clarinet, bass_clarinet, bassoon, recorder, contrabassoon, saxophone, bagpipe, harmonica, shakuhachi, cornet

Brass family--
  trumpet, french_horn, trombone, tuba

Keyboard and Harp--
  piano, organ, synthesizer, harp, harpsichord, celesta, accordion

Percussion family--
  timpani, snare_drum, bass_drum, tenor_drumbs, cymbals, congas, tubular bells, triangle, tambourine, xylophone, glockenspiel, wooden-block, claves, chimes, marimba, vibraphone (vibes), maracas, castanets...

Voice Types--
  soprano, mezzo-soprano, alto (contralto) | countertenor, tenor, baritone, bass

Chorus--
  mixed_voices, women's_voices, men's_voices, children's_voices


<< ROCK/POP/HEAVY BAND______________
  voice 1, voice 2, voices, chorus, 
  acoustic guitarr, electric guitarr 1, electric guitarr 2, bass guitar, contrabass guitar
  drum kit: high-hat, tom-tom, cymbal, drumsticks, snare_drum, bass_drum
  piano, synthesizer
]]


--------------------------------------------------------------------------------
-- GROUP SETTINGS AND TRACK SETTINGS
--------------------------------------------------------------------------------

--Colors (16 x 9): AQ , BK , BL , BR , GL , GY , GR , OR , PL , PN , PS , RD , SK , VL , WH , YL

CR_AQ00={ 0x2C,0xB2,0xA2 } CR_AQ01={ 0x27,0x9E,0x90 } CR_AQ02={ 0x22,0x89,0x7D } CR_AQ03={ 0x1D,0x75,0x6B } CR_AQ04={ 0x18,0x60,0x58 } CR_AQ05={ 0x13,0x4C,0x45 } CR_AQ06={ 0x0E,0x38,0x33 } CR_AQ07={ 0x08,0x23,0x20 } CR_AQ08={ 0x03,0x0F,0x0D }
CR_BK00={ 0x00,0x00,0x00 } CR_BK01={ 0x0A,0x0A,0x0A } CR_BK02={ 0x14,0x14,0x14 } CR_BK03={ 0x1E,0x1E,0x1E } CR_BK04={ 0x28,0x28,0x28 } CR_BK05={ 0x33,0x33,0x33 } CR_BK06={ 0x3D,0x3D,0x3D } CR_BK07={ 0x47,0x47,0x47 } CR_BK08={ 0x51,0x51,0x51 }
CR_BL00={ 0x00,0x60,0xFF } CR_BL01={ 0x00,0x57,0xE5 } CR_BL02={ 0x00,0x4E,0xCC } CR_BL03={ 0x00,0x44,0xB2 } CR_BL04={ 0x00,0x3A,0x99 } CR_BL05={ 0x00,0x30,0x7F } CR_BL06={ 0x00,0x27,0x66 } CR_BL07={ 0x00,0x1D,0x4C } CR_BL08={ 0x00,0x13,0x33 }
CR_BR00={ 0xAD,0x5C,0x11 } CR_BR01={ 0x99,0x51,0x0F } CR_BR02={ 0x84,0x46,0x0D } CR_BR03={ 0x70,0x3C,0x0B } CR_BR04={ 0x60,0x33,0x09 } CR_BR05={ 0x4C,0x28,0x07 } CR_BR06={ 0x38,0x1E,0x05 } CR_BR07={ 0x23,0x13,0x03 } CR_BR08={ 0x0F,0x08,0x01 }
CR_GL00={ 0xFF,0xB5,0x23 } CR_GL01={ 0xE5,0xA0,0x20 } CR_GL02={ 0xCC,0x8E,0x1C } CR_GL03={ 0xB2,0x7C,0x18 } CR_GL04={ 0x99,0x6A,0x15 } CR_GL05={ 0x7F,0x59,0x11 } CR_GL06={ 0x66,0x47,0x0E } CR_GL07={ 0x4C,0x35,0x0A } CR_GL08={ 0x33,0x23,0x07 }
CR_GY00={ 0x80,0x80,0x80 } CR_GY01={ 0x70,0x70,0x70 } CR_GY02={ 0x60,0x60,0x60 } CR_GY03={ 0x51,0x51,0x51 } CR_GY04={ 0x42,0x42,0x42 } CR_GY05={ 0x33,0x33,0x33 } CR_GY06={ 0x23,0x23,0x23 } CR_GY07={ 0x19,0x19,0x19 } CR_GY08={ 0x0F,0x0F,0x0F }
CR_GR00={ 0x00,0xFF,0x00 } CR_GR01={ 0x00,0xE5,0x00 } CR_GR02={ 0x00,0xCC,0x00 } CR_GR03={ 0x00,0xB2,0x00 } CR_GR04={ 0x00,0x99,0x00 } CR_GR05={ 0x00,0x7F,0x00 } CR_GR06={ 0x00,0x66,0x00 } CR_GR07={ 0x00,0x4C,0x00 } CR_GR08={ 0x00,0x33,0x00 }
CR_OR00={ 0xFF,0x80,0x00 } CR_OR01={ 0xE5,0x72,0x00 } CR_OR02={ 0xCC,0x66,0x00 } CR_OR03={ 0xB2,0x59,0x00 } CR_OR04={ 0x99,0x4C,0x00 } CR_OR05={ 0x7F,0x3F,0x00 } CR_OR06={ 0x66,0x33,0x00 } CR_OR07={ 0x4C,0x26,0x00 } CR_OR08={ 0x33,0x19,0x00 }
CR_PL00={ 0xFF,0xA8,0xE3 } CR_PL01={ 0xE5,0x97,0xCC } CR_PL02={ 0xCC,0x86,0xB6 } CR_PL03={ 0xB2,0x75,0x97 } CR_PL04={ 0x99,0x64,0x88 } CR_PL05={ 0x7F,0x54,0x71 } CR_PL06={ 0x66,0x43,0x5B } CR_PL07={ 0x4C,0x32,0x44 } CR_PL08={ 0x33,0x21,0x2D }
CR_PN00={ 0xFF,0x00,0xAA } CR_PN01={ 0xE5,0x00,0x99 } CR_PN02={ 0xCC,0x00,0x88 } CR_PN03={ 0xB2,0x00,0x77 } CR_PN04={ 0x99,0x00,0x66 } CR_PN05={ 0x7F,0x00,0x55 } CR_PN06={ 0x66,0x00,0x44 } CR_PN07={ 0x4C,0x00,0x33 } CR_PN08={ 0x33,0x00,0x22 }
CR_PS00={ 0x80,0xFF,0x95 } CR_PS01={ 0x75,0xE5,0x85 } CR_PS02={ 0x68,0xCC,0x77 } CR_PS03={ 0x5B,0xB2,0x68 } CR_PS04={ 0x4E,0x99,0x59 } CR_PS05={ 0x41,0x7F,0x4A } CR_PS06={ 0x34,0x66,0x3B } CR_PS07={ 0x27,0x4C,0x2C } CR_PS08={ 0x1A,0x33,0x1D }
CR_RD00={ 0xFF,0x00,0x00 } CR_RD01={ 0xE5,0x00,0x00 } CR_RD02={ 0xCC,0x00,0x00 } CR_RD03={ 0xB2,0x00,0x00 } CR_RD04={ 0x99,0x00,0x00 } CR_RD05={ 0x7F,0x00,0x00 } CR_RD06={ 0x66,0x00,0x00 } CR_RD07={ 0x4C,0x00,0x00 } CR_RD08={ 0x33,0x00,0x00 }
CR_SK00={ 0x00,0xCB,0xFF } CR_SK01={ 0x00,0xB7,0xE5 } CR_SK02={ 0x00,0xA3,0xCC } CR_SK03={ 0x00,0x9B,0xC1 } CR_SK04={ 0x00,0x8E,0xB2 } CR_SK05={ 0x00,0x7A,0x99 } CR_SK06={ 0x00,0x65,0x7F } CR_SK07={ 0x00,0x51,0x66 } CR_SK08={ 0x00,0x3D,0x4C }
CR_VL00={ 0x8C,0x00,0xFF } CR_VL01={ 0xA8,0x00,0xE5 } CR_VL02={ 0x95,0x00,0xCC } CR_VL03={ 0x82,0x00,0xB2 } CR_VL04={ 0x70,0x00,0x99 } CR_VL05={ 0x5D,0x00,0x7F } CR_VL06={ 0x4A,0x00,0x66 } CR_VL07={ 0x38,0x00,0x4C } CR_VL08={ 0x25,0x00,0x33 }
CR_WH00={ 0xFF,0xFF,0xFF } CR_WH01={ 0xEA,0xEA,0xEA } CR_WH02={ 0xD6,0xD6,0xD6 } CR_WH03={ 0xC1,0xC1,0xC1 } CR_WH04={ 0xAD,0xAD,0xAD } CR_WH05={ 0x99,0x99,0x99 } CR_WH06={ 0x84,0x84,0x84 } CR_WH07={ 0x70,0x70,0x70 } CR_WH08={ 0x5B,0x5B,0x5B }
CR_YL00={ 0xFF,0xFF,0x00 } CR_YL01={ 0xE5,0xE5,0x00 } CR_YL02={ 0xCC,0xCC,0x00 } CR_YL03={ 0xB2,0xB2,0x00 } CR_YL04={ 0x99,0x99,0x00 } CR_YL05={ 0x7F,0x7F,0x00 } CR_YL06={ 0x66,0x66,0x00 } CR_YL07={ 0x4C,0x4C,0x00 } CR_YL08={ 0x33,0x33,0x00 }


--group_setting

  --song.tracks[ song.selected_track_index     ].collapsed              = true --from the group collapse FXg only
  --song.tracks[ song.selected_track_index - 1 ].group_parent.collapsed = true --from the track son collapse FXg only
  --song.tracks[ song.selected_track_index     ].group_collapsed        = true --from the group collapse entire group

local group = {}
  group.orchestra_big    = { name='SYMPHONY ORCHESTRA BIG GROUP'    , color= CR_GL00, color_blend=55 }
  group.orchestra_little = { name='SYMPHONY ORCHESTRA LITTLE GROUP' , color= CR_GL00, color_blend=55 }
  group.band             = { name='BAND GROUP'                      , color= CR_GY00, color_blend=55 }

  group.strings        = { name='STRING GROUP'         , color= CR_RD00, color_blend=30 } --RD     --collapsed = true or group_collapsed = true --collapse entire group
  group.woodwinds      = { name='WOODWINDS GROUP'      , color= CR_WH00, color_blend=30 } --WH
  group.brass          = { name='BRASS GROUP'          , color= CR_GL00, color_blend=30 } --GL
  group.keyboards      = { name='KEYBOARDS GROUP'      , color= CR_GR00, color_blend=30 } --GR
    group.pianos       = { name='PIANOS GROUP'         , color= CR_GR00, color_blend=30 } --GR
    group.synthesizers = { name='SYNTHESIZERS GROUP'   , color= CR_GR00, color_blend=30 } --GR
  group.voices         = { name='VOICES GROUP'         , color= CR_VL00, color_blend=30 } --VL
  group.chorus         = { name='CHORUS GROUP'         , color= CR_PN00, color_blend=30 } --PN
  group.percussion     = { name='PERCUSSION GROUP'     , color= CR_BL00, color_blend=30 } --BL
    group.percussion1  = { name='PERCUSSION I GROUP'   , color= CR_BL00, color_blend=30 } --BL
    group.percussion2  = { name='PERCUSSION II GROUP'  , color= CR_BL00, color_blend=30 } --BL
    group.percussion3  = { name='PERCUSSION III GROUP' , color= CR_BL00, color_blend=30 } --BL
  group.bigpercussion  = { name='PERCUSSION III GROUP' , color= CR_AQ00, color_blend=30 } --AQ
  --- ---
  group.voices2         = { name='VOICES GROUP'        , color= CR_PL00, color_blend=30 }
  group.guitars        = { name='GUITARS GROUP'        , color= CR_GY00, color_blend=30 }
  group.drum_kit       = { name='DRUM KIT GROUP'       , color= CR_AQ00, color_blend=30 }
  --- ---
  group.xxx            = { name='STRING GROUP'         , color= CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color= CR_RD00, color_blend=30 }
  group.xxx            = { name='STRING GROUP'         , color= CR_RD00, color_blend=30 }


--track_setting
local track = {}                --'___________' -- ideal size           --color_blend=00-100

--SYMPHONY ORCHESTRA INSTRUMENTS-----------------------------------------------------------------
----Strings
  track.solostring     = { name='Solo String'    , color= CR_RD01, color_blend=15 }
  track.violins        = { name='Violins'        , color= CR_RD02, color_blend=15 }
  track.firstviolins   = { name='1st Violins'    , color= CR_RD03, color_blend=15 }
  track.secondviolins  = { name='2nd Violins'    , color= CR_RD04, color_blend=15 }
  track.violas         = { name='Violas'         , color= CR_RD05, color_blend=15 }
  track.cellos         = { name='Cellos'         , color= CR_RD06, color_blend=15 }
  track.basses         = { name='Basses'         , color= CR_RD07, color_blend=15 }
----Woodwinds
  track.solowoodwind   = { name='Solo Woodwind'  , color= CR_WH01, color_blend=15 }
  track.flute          = { name='Flute'          , color= CR_WH02, color_blend=15 }
  track.oboe           = { name='Oboe'           , color= CR_WH03, color_blend=15 }
  track.piccolo        = { name='Piccolo'        , color= CR_WH04, color_blend=15 }
  track.englishhorn    = { name='English Horn'   , color= CR_WH05, color_blend=15 }
  --
  track.bassclarinet   = { name='Bass Clarinet'  , color= CR_WH01, color_blend=15 }
  track.clarinet       = { name='Clarinet'       , color= CR_WH02, color_blend=15 }
  track.contrabasson   = { name='Contrabasson'   , color= CR_WH03, color_blend=15 }
  track.basson         = { name='Basson'         , color= CR_WH04, color_blend=15 }
  --
  track.bagpipe        = { name='Bagpipe'        , color= CR_WH01, color_blend=15 }
  track.shakuhachi     = { name='Shakuhachi'     , color= CR_WH02, color_blend=15 }
  track.cornet         = { name='Cornet'         , color= CR_WH03, color_blend=15 }
  track.harmonica      = { name='Harmonica'      , color= CR_WH04, color_blend=15 }
----Brass
  track.solobrass      = { name='Solo Brass'     , color= CR_GL01, color_blend=15 }
  track.trumpets       = { name='Trumpets'       , color= CR_GL02, color_blend=15 }
  track.trombones      = { name='Trombones'      , color= CR_GL03, color_blend=15 }
  track.tuba           = { name='Tuba'           , color= CR_GL04, color_blend=15 }
  track.frenchhorns    = { name='French Horns'   , color= CR_GL05, color_blend=15 }
  track.saxophone      = { name='Saxophone'      , color= CR_GL06, color_blend=15 }
----Keyboards
  track.harp           = { name='Harp'           , color= CR_GR01, color_blend=15 }
  track.piano          = { name='Piano'          , color= CR_GR02, color_blend=15 }
  track.pianol         = { name='Piano Left'     , color= CR_GR03, color_blend=15 }
  track.pianoc         = { name='Piano Center'   , color= CR_GR04, color_blend=15 }
  track.pianor         = { name='Piano Right'    , color= CR_GR05, color_blend=15 }
  track.piano1         = { name='Piano 1'        , color= CR_GR03, color_blend=15 }
  track.piano2         = { name='Piano 2'        , color= CR_GR04, color_blend=15 }
  track.piano3         = { name='Piano 3'        , color= CR_GR05, color_blend=15 }
  track.synthesizer    = { name='Synthesizer'    , color= CR_GR03, color_blend=15 }
  track.synthesizer1   = { name='Synth 1'        , color= CR_GR04, color_blend=15 }
  track.synthesizer2   = { name='Synth 2'        , color= CR_GR05, color_blend=15 }
  track.synthesizer3   = { name='Synth 3'        , color= CR_GR06, color_blend=15 }
  track.organ          = { name='Organ'          , color= CR_GR04, color_blend=15 }
  track.harpsichord    = { name='Harpsichord'    , color= CR_GR05, color_blend=15 }
  track.celesta        = { name='Celesta'        , color= CR_GR06, color_blend=15 }
  track.accordion      = { name='Accordion'      , color= CR_GR07, color_blend=15 }
----Voices
  track.soloist        = { name='Soloist'        , color= CR_VL01, color_blend=15 }
  track.soprano        = { name='Soprano'        , color= CR_VL02, color_blend=15 }
  track.mezzosoprano   = { name='Mezzo-Soprano'  , color= CR_VL03, color_blend=15 }
  track.contralto      = { name='Contralto'      , color= CR_VL04, color_blend=15 }
  track.countertenor   = { name='Countertenor'   , color= CR_VL05, color_blend=15 }
  track.tenor          = { name='Tenor'          , color= CR_VL06, color_blend=15 }
  track.baritone       = { name='Baritone'       , color= CR_VL07, color_blend=15 }
  track.bassvoice      = { name='Bass Voice'     , color= CR_VL08, color_blend=15 }
----Chorus
  track.mixedvoices    = { name='Mixed Voices'   , color= CR_PN01, color_blend=15 }
  track.womenvoices    = { name='Women Voices'   , color= CR_PN02, color_blend=15 }
  track.menvoices      = { name='Men Voices'     , color= CR_PN03, color_blend=15 }
  track.childrenvoices = { name='Children Voices', color= CR_PN04, color_blend=15 }
----Percussion
  track.tubularbells   = { name='Tubular Bells'  , color= CR_BL01, color_blend=15 }
  track.vibraphone     = { name='Vibraphone'     , color= CR_BL02, color_blend=15 }
  track.xylophone      = { name='Xylophone'      , color= CR_BL03, color_blend=15 }
  track.glockenspiel   = { name='Glockenspiel'   , color= CR_BL04, color_blend=15 }
  track.marimba        = { name='Marimba'        , color= CR_BL05, color_blend=15 }
  track.hammer         = { name='Hammer'         , color= CR_BL06, color_blend=15 }
  track.triangle       = { name='Triangle'       , color= CR_BL07, color_blend=15 }
  track.chimes         = { name='Chimes'         , color= CR_BL08, color_blend=15 }
  --
  track.maracas        = { name='Maracas'        , color= CR_BL01, color_blend=15 }
  track.castanets      = { name='Castanets'      , color= CR_BL02, color_blend=15 }
  track.woodenblock    = { name='Wooden-block'   , color= CR_BL03, color_blend=15 }
  track.claves         = { name='Claves'         , color= CR_BL04, color_blend=15 }
  track.tambourine     = { name='Tambourine'     , color= CR_BL05, color_blend=15 }
  --
  track.cymbals        = { name='Cymbals'        , color= CR_BL01, color_blend=15 }
  track.snaredrum      = { name='Snare Drum'     , color= CR_BL02, color_blend=15 }
  track.gong           = { name='Gong'           , color= CR_BL03, color_blend=15 }
  track.timpani        = { name='Timpani'        , color= CR_BL04, color_blend=15 }
  track.congas         = { name='Congas'         , color= CR_BL05, color_blend=15 }
  track.tenordrum      = { name='Tenor Drum'     , color= CR_BL06, color_blend=15 }
  track.bassdrum       = { name='Bass Drum'      , color= CR_BL07, color_blend=15 }
  --
  track.bigbass        = { name='Big Bass'       , color= CR_AQ01, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ02, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ03, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ04, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ05, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ06, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ07, color_blend=15 }
  track.bigbass        = { name='Big Bass'       , color= CR_AQ08, color_blend=15 }

--BAND POP/ROCK/HEAVY INSTRUMENTS-----------------------------------------------------------------
-----Voices
  track.voice1           = { name='Voice 1'           , color= CR_PL01, color_blend=15 }
  track.voice2           = { name='Voice 2'           , color= CR_PL02, color_blend=15 }
  track.voices           = { name='Voices'            , color= CR_PL03, color_blend=15 }
-----Guitars
  track.acousticguitar   = { name='Acoustic Guitar'   , color= CR_GY01, color_blend=15 }
  track.electricguitar1  = { name='Electric Guitar I' , color= CR_GY02, color_blend=15 }
  track.electricguitar2  = { name='Electric Guitar II', color= CR_GY03, color_blend=15 }  
  track.bassguitar       = { name='Bass Guitar'       , color= CR_GY04, color_blend=15 }
  track.contrabassguitar = { name='Contrabass Guitar' , color= CR_GY05, color_blend=15 }
----Keyboards
  --track.piano          = { name='Piano'             , color= CR_RD06, color_blend=15 }
  --track.synthesizer1   = { name='Synth I'           , color= CR_RD06, color_blend=15 }
  --track.synthesizer2   = { name='Synth II'          , color= CR_RD06, color_blend=15 }
  --track.synthesizer3   = { name='Synth III'         , color= CR_RD06, color_blend=15 }    
---- Drum Kit
  track.bassdrum2        = { name='Bass Drum'         , color= CR_AQ01, color_blend=15 }
  track.floortom         = { name='Floor Tom'         , color= CR_AQ02, color_blend=15 }
  track.snaredrum2       = { name='Snare Drum'        , color= CR_AQ03, color_blend=15 }
  track.hangingtombs     = { name='Hanging Tombs'     , color= CR_AQ04, color_blend=15 }
  track.hihat            = { name='Hi-hat'            , color= CR_AQ05, color_blend=15 }
  track.crashcymbal      = { name='Crash Cymbal'      , color= CR_AQ01, color_blend=15 }
  track.ridecymbal       = { name='Ride Cymbal'       , color= CR_AQ02, color_blend=15 }
  track.splashcymbal     = { name='Splash Cymbal'     , color= CR_AQ03, color_blend=15 }
  track.chinacymbal      = { name='China Cymbal'      , color= CR_AQ04, color_blend=15 }

--ELECTRONIC/NEW AGE INSTRUMENTS------------------------------------------------------------------
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }
  track.xxx              = { name='xxx          ', color= CR_RD06, color_blend=15 }

  --- ---
  group.x00              = { name='ggg          ', color= CR_AQ00, color_blend=30 }
  track.x01              = { name='xxx          ', color= CR_AQ01, color_blend=15 }
  track.x02              = { name='xxx          ', color= CR_AQ02, color_blend=15 }
  track.x03              = { name='xxx          ', color= CR_AQ03, color_blend=15 }
  track.x04              = { name='xxx          ', color= CR_AQ04, color_blend=15 }
  track.x05              = { name='xxx          ', color= CR_AQ05, color_blend=15 }
  track.x06              = { name='xxx          ', color= CR_AQ06, color_blend=15 }
  track.x07              = { name='xxx          ', color= CR_AQ07, color_blend=15 }
  track.x08              = { name='xxx          ', color= CR_AQ08, color_blend=15 }

  


--------------------------------------------------------------------------------
-- CHECKBOX & VALUEBOX CONTROL
--------------------------------------------------------------------------------
function show_trntc(i) --valuebox visible_note_columns (1-12)
  for n,v in pairs(track) do
    v.visible_note_columns = i
  end
end

function show_trvol(i) --checkbox volume_column_visible (True/False)
  for n,v in pairs(track) do
    v.volume_column_visible = i
  end
end

function show_trpan(i) --checkbox panning_column_visible (True/False)
  for n,v in pairs(track) do
    v.panning_column_visible = i
  end
end

function show_trdly(i) --checkbox delay_column_visible (True/False)
  for n,v in pairs(track) do
    v.delay_column_visible = i
  end
end

function show_trsfx(i) --checkbox sample_effects_column_visible (True/False)
  for n,v in pairs(track) do
    v.sample_effects_column_visible = i
  end
end

function show_trfxt(i) --valuebox visible_effect_columns (0-8)
  for n,v in pairs(track) do
    v.visible_effect_columns = i
  end
end

--[[

function show_grfxg(i) --group_collapsed (True/False)
  for n,v in pairs(group) do
    --v.group_collapsed = i
    v.collapsed = i
  end
end

]]

VALUEBOX_PEST_TRNTC = vb:valuebox { id = 'vbox_pest_trntc', value = 1, notifier = function(i) show_trntc(i) end, width = 50, height = 22, min = 1, max = 12, tooltip = 'Note column track.\n[Range = 1 to 12]' }
--CHECKBOX_PEST_TRVOL = vb:checkbox { id = 'cbox_pest_trvol', value = true,   notifier = function(i) show_trvol(i) end, tooltip = 'Volume Column Track' }
--CHECKBOX_PEST_TRPAN = vb:checkbox { id = 'cbox_pest_trpan', value = false,  notifier = function(i) show_trpan(i) end, tooltip = 'Panning Column Track' }
--CHECKBOX_PEST_TRDLY = vb:checkbox { id = 'cbox_pest_trdly', value = false,  notifier = function(i) show_trdly(i) end, tooltip = 'Delay Column Track' }
--CHECKBOX_PEST_TRSFX = vb:checkbox { id = 'cbox_pest_trsfx', value = false,  notifier = function(i) show_trsfx(i) end, tooltip = 'Sfx Column Track' }
VALUEBOX_PEST_TRFXT = vb:valuebox { id = 'vbox_pest_trfxt', value = 0,      notifier = function(i) show_trfxt(i) end, width = 50, height = 22, min = 0, max = 8, tooltip = 'Effect column track.\n[Range = 0 to 8]' }

--CHECKBOX_PEST_GRFXG = vb:checkbox { id = 'cbox_pest_grfxg', value = false,  notifier = function(i) show_grfxg(i) end, tooltip = 'GXtg Column Group' }

--[[
BUTTONCHECK_PEST_TRVOL = vb:button {
  id = 'expand_button',
  width = 40,
  height = 24,
  text = 'VOL',
  color = {00 , 60 , 00 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
      vb.views['cbox_pest_trvol'].value = true
      vb.views['expand_button'].color = { 00 , 60 , 00 }
      --vb.views['expand_button'].text = 'VOL'
      --settings.popout_visible.value = true
      --settings.popout_height.value = 134
      else
      vb.views['cbox_pest_trvol'].value = false
      vb.views['expand_button'].color = { 60 , 00 , 00 }
      --vb.views['expand_button'].text = 'VOL'
      -- settings.popout_visible.value = false
      -- settings.popout_height.value = 1
    end
  end
}
]]

vb:checkbox { id = 'cbox_pest_trvol', notifier = function(i) show_trvol(i) end, value = true } --Buttoncheck VOL
BUTTONCHECK_PEST_TRVOL = vb:button {
  id = 'beck_pest_trvol',
  width = 40,
  height = 22,
  text = 'VOL',
  color = { 0x00,0x70,0x00 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00,0x70,0x00 }
      else
       vb.views['cbox_pest_trvol'].value = false
       vb.views['beck_pest_trvol'].color = { 0x40,0x00,0x00 }
    end
  end,
  tooltip = 'Show/hide the volume column.'
}

vb:checkbox { id = 'cbox_pest_trpan', notifier = function(i) show_trpan(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRPAN = vb:button {
  id = 'beck_pest_trpan',
  width = 40,
  height = 22,
  text = 'PAN',
  color = { 0x40,0x00,0x00 },
  notifier = function()
    if vb.views['cbox_pest_trpan'].value == false then
       vb.views['cbox_pest_trpan'].value = true
       vb.views['beck_pest_trpan'].color = { 0x00,0x70,0x00 }
      else
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x40,0x00,0x00 }
    end
  end,
  tooltip = 'Show/hide the panniing column.'
}

vb:checkbox { id = 'cbox_pest_trdly', notifier = function(i) show_trdly(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRDLY = vb:button {
  id = 'beck_pest_trdly',
  width = 40,
  height = 22,
  text = 'DLY',
  color = { 0x40,0x00,0x00 },
  notifier = function()
    if vb.views['cbox_pest_trdly'].value == false then
       vb.views['cbox_pest_trdly'].value = true
       vb.views['beck_pest_trdly'].color = { 0x00,0x70,0x00 }
      else
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x40,0x00,0x00 }
    end
  end,
  tooltip = 'Show/hide the delay column.'
}

vb:checkbox { id = 'cbox_pest_trsfx', notifier = function(i) show_trsfx(i) end, value = false } --Buttoncheck VOL
BUTTONCHECK_PEST_TRSFX = vb:button {
  id = 'beck_pest_trsfx',
  width = 40,
  height = 22,
  text = 'sFX',
  color = { 0x40,0x00,0x00 },
  notifier = function()
    if vb.views['cbox_pest_trsfx'].value == false then
       vb.views['cbox_pest_trsfx'].value = true
       vb.views['beck_pest_trsfx'].color = { 0x00,0x70,0x00 }
      else
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x40,0x00,0x00 }
    end
  end,
  tooltip = 'Show/hide the sample effects column.'
}

DEFAULT_PEST_PARAM = vb:button {
  id = 'def_pest_param',
  width = 30,
  height = 22,
  text = 'DF',
  tooltip = 'Default values configuration.',
  color = { 0x00,0x20,0x50 },
  notifier = function()
    if vb.views['cbox_pest_trvol'].value == false then
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00,0x70,0x00 }
       else
       vb.views['cbox_pest_trvol'].value = true
       vb.views['beck_pest_trvol'].color = { 0x00,0x70,0x00 }
    end

    if vb.views['cbox_pest_trpan'].value == true then
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x40,0x00,0x00 }
       else
       vb.views['cbox_pest_trpan'].value = false
       vb.views['beck_pest_trpan'].color = { 0x40,0x00,0x00 }
    end       
    if vb.views['cbox_pest_trdly'].value == true then
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x40,0x00,0x00 }
       else
       vb.views['cbox_pest_trdly'].value = false
       vb.views['beck_pest_trdly'].color = { 0x40,0x00,0x00 }
    end
    if vb.views['cbox_pest_trsfx'].value == true then
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x40,0x00,0x00 }
       else
       vb.views['cbox_pest_trsfx'].value = false
       vb.views['beck_pest_trsfx'].color = { 0x40,0x00,0x00 }       
    end
    
    if vb.views['vbox_pest_trntc'].value > 0 then
       vb.views['vbox_pest_trntc'].value = 1
       else
       vb.views['vbox_pest_trntc'].value = 1
    end
    if vb.views['vbox_pest_trfxt'].value >= 0 then
       vb.views['vbox_pest_trfxt'].value = 0
       else
       vb.views['vbox_pest_trfxt'].value = 0
    end
    vb.views['PEST_CB_JUMP'].value = false
    vb.views['PEST_CB_RTIME'].value = false
    vb.views['PEST_VB_CBLEND_TRACK'].value = 15
    vb.views['PEST_VB_CBLEND_SGROUP'].value = 30
    vb.views['PEST_VB_CBLEND_GROUP'].value = 55
  end
}

--Rename track with color
function rename_color( song, sti, name )
  song = renoise.song()
  sti = song.selected_track_index
  name = song.tracks[sti].name
  if vb.views['PEST_TEXTFIELD_RENAME'].text == '' then else
    song.tracks[sti].name = vb.views['PEST_TEXTFIELD_RENAME'].text
  end
  if ( song.tracks[ sti ].type == renoise.Track.TRACK_TYPE_SEQUENCER ) then -- <--REVIEW!!! ???
  --Symphony orchestra
    if name == 'Solo String'     or name == 'solo string'     or name == 'SOLO STRING'     then song.tracks[sti].color = CR_RD01 end
    if name == 'Violins'         or name == 'violins'         or name == 'VIOLINS'         then song.tracks[sti].color = CR_RD02 end
    if name == '1st Violins'     or name == '1st violins'     or name == '1ST VIOLINS'     then song.tracks[sti].color = CR_RD03 end
    if name == '2nd Violins'     or name == '2nd violins'     or name == '2ND VIOLINS'     then song.tracks[sti].color = CR_RD04 end
    if name == 'Violas'          or name == 'violas'          or name == 'VIOLAS'          then song.tracks[sti].color = CR_RD05 end
    if name == 'Cellos'          or name == 'cellos'          or name == 'CELLOS'          then song.tracks[sti].color = CR_RD06 end
    if name == 'Basses'          or name == 'basses'          or name == 'BASSES'          then song.tracks[sti].color = CR_RD07 end
    if name == 'Solo Woodwind'   or name == 'solo woodwind'   or name == 'SOLO WOODWIND'   then song.tracks[sti].color = CR_WH01 end
    if name == 'Flute'           or name == 'flute'           or name == 'FLUTE'           then song.tracks[sti].color = CR_WH02 end
    if name == 'Oboe'            or name == 'oboe'            or name == 'OBOE'            then song.tracks[sti].color = CR_WH03 end
    if name == 'Piccolo'         or name == 'piccolo'         or name == 'PICCOLO'         then song.tracks[sti].color = CR_WH04 end
    if name == 'English Horn'    or name == 'english horn'    or name == 'ENGLISH HORN'    then song.tracks[sti].color = CR_WH05 end
    if name == 'Bass Clarinet'   or name == 'bass clarinet'   or name == 'BASS CLARINET'   then song.tracks[sti].color = CR_WH01 end
    if name == 'Clarinet'        or name == 'clarinet'        or name == 'CLARINET'        then song.tracks[sti].color = CR_WH02 end
    if name == 'Contrabasson'    or name == 'contrabasson'    or name == 'CONTRABASSON'    then song.tracks[sti].color = CR_WH03 end
    if name == 'Basson'          or name == 'basson'          or name == 'BASSON'          then song.tracks[sti].color = CR_WH04 end
    if name == 'Bagpipe'         or name == 'bagpipe'         or name == 'BAGPIPE'         then song.tracks[sti].color = CR_WH01 end
    if name == 'Shakuhachi'      or name == 'shakuhachi'      or name == 'SHAKUHACHI'      then song.tracks[sti].color = CR_WH02 end
    if name == 'Cornet'          or name == 'cornet'          or name == 'CORNET'          then song.tracks[sti].color = CR_WH03 end
    if name == 'Harmonica'       or name == 'harmonica'       or name == 'HARMONICA'       then song.tracks[sti].color = CR_WH04 end
    if name == 'Solo Brass'      or name == 'solo brass'      or name == 'SOLO BRASS'      then song.tracks[sti].color = CR_GL01 end
    if name == 'Trumpets'        or name == 'trumpets'        or name == 'TRUMPETS'        then song.tracks[sti].color = CR_GL02 end
    if name == 'Trombones'       or name == 'trombones'       or name == 'TROMBONES'       then song.tracks[sti].color = CR_GL03 end
    if name == 'Tuba'            or name == 'tuba'            or name == 'TUBA'            then song.tracks[sti].color = CR_GL04 end
    if name == 'French Horns'    or name == 'french horns'    or name == 'FRENCH HORNS'    then song.tracks[sti].color = CR_GL05 end
    if name == 'Saxophone'       or name == 'saxophone'       or name == 'SAXOPHONE'       then song.tracks[sti].color = CR_GL06 end
    if name == 'Harp'            or name == 'harp'            or name == 'HARP'            then song.tracks[sti].color = CR_GR01 end
    if name == 'Piano'           or name == 'piano'           or name == 'PIANO'           then song.tracks[sti].color = CR_GR02 end
    if name == 'Piano Left'      or name == 'piano left'      or name == 'PIANO LEFT'      then song.tracks[sti].color = CR_GR03 end
    if name == 'Piano Center'    or name == 'piano center'    or name == 'PIANO CENTER'    then song.tracks[sti].color = CR_GR04 end
    if name == 'Piano Right'     or name == 'piano right'     or name == 'PIANO RIGHT'     then song.tracks[sti].color = CR_GR05 end
    if name == 'Piano 1'         or name == 'piano 1'         or name == 'PIANO 1'         then song.tracks[sti].color = CR_GR03 end
    if name == 'Piano 2'         or name == 'piano 2'         or name == 'PIANO 2'         then song.tracks[sti].color = CR_GR04 end
    if name == 'Piano 3'         or name == 'piano 3'         or name == 'PIANO 3'         then song.tracks[sti].color = CR_GR05 end
    if name == 'Synthesizer'     or name == 'synthesizer'     or name == 'SYNTHESIZER'     then song.tracks[sti].color = CR_GR03 end
    if name == 'Synth 1'         or name == 'synth 1'         or name == 'SYNTH 1'         then song.tracks[sti].color = CR_GR04 end
    if name == 'Synth 2'         or name == 'synth 2'         or name == 'SYNTH 2'         then song.tracks[sti].color = CR_GR05 end
    if name == 'Synth 3'         or name == 'synth 3'         or name == 'SYNTH 3'         then song.tracks[sti].color = CR_GR06 end
    if name == 'Organ'           or name == 'organ'           or name == 'ORGAN'           then song.tracks[sti].color = CR_GR04 end
    if name == 'Harpsichord'     or name == 'harpsichord'     or name == 'HARPSICHORD'     then song.tracks[sti].color = CR_GR05 end
    if name == 'Celesta'         or name == 'celesta'         or name == 'CELESTA'         then song.tracks[sti].color = CR_GR06 end
    if name == 'Accordion'       or name == 'accordion'       or name == 'ACCORDION'       then song.tracks[sti].color = CR_GR07 end
    if name == 'Soprano'         or name == 'soprano'         or name == 'SOPRANO'         then song.tracks[sti].color = CR_VL01 end
    if name == 'Mezzo-Soprano'   or name == 'mezzo-soprano'   or name == 'MEZZO-SOPRANO'   then song.tracks[sti].color = CR_VL02 end
    if name == 'Contralto'       or name == 'contralto'       or name == 'CONTRALTO'       then song.tracks[sti].color = CR_VL03 end
    if name == 'Countertenor'    or name == 'countertenor'    or name == 'COUNTERTENOR'    then song.tracks[sti].color = CR_VL04 end
    if name == 'Tenor'           or name == 'tenor'           or name == 'TENOR'           then song.tracks[sti].color = CR_VL05 end
    if name == 'Baritone'        or name == 'baritone'        or name == 'BARITONE'        then song.tracks[sti].color = CR_VL06 end
    if name == 'Bass Voice'      or name == 'bass voice'      or name == 'BASS VOICE'      then song.tracks[sti].color = CR_VL07 end
    if name == 'Mixed Voices'    or name == 'mixed voices'    or name == 'MIXED VOICES'    then song.tracks[sti].color = CR_PN01 end
    if name == 'Women Voices'    or name == 'women voices'    or name == 'WOMEN VOICES'    then song.tracks[sti].color = CR_PN02 end
    if name == 'Men Voices'      or name == 'men voices'      or name == 'MEN VOICES'      then song.tracks[sti].color = CR_PN03 end
    if name == 'Children Voices' or name == 'children voices' or name == 'CHILDREN VOICES' then song.tracks[sti].color = CR_PN04 end
    if name == 'Tubular Bells'   or name == 'tubular bells'   or name == 'TUBULAR BELLS'   then song.tracks[sti].color = CR_BL01 end
    if name == 'Vibraphone'      or name == 'vibraphone'      or name == 'VIBRAPHONE'      then song.tracks[sti].color = CR_BL02 end
    if name == 'Xylophone'       or name == 'xylophone'       or name == 'XYLOPHONE'       then song.tracks[sti].color = CR_BL03 end
    if name == 'Glockenspiel'    or name == 'glockenspiel'    or name == 'GLOCKENSPIEL'    then song.tracks[sti].color = CR_BL04 end
    if name == 'Marimba'         or name == 'marimba'         or name == 'MARIMBA'         then song.tracks[sti].color = CR_BL05 end
    if name == 'Hammer'          or name == 'hammer'          or name == 'HAMMER'          then song.tracks[sti].color = CR_BL06 end
    if name == 'Triangle'        or name == 'triangle'        or name == 'TRIANGLE'        then song.tracks[sti].color = CR_BL07 end
    if name == 'Chimes'          or name == 'chimes'          or name == 'CHIMES'          then song.tracks[sti].color = CR_BL08 end
    if name == 'Maracas'         or name == 'maracas'         or name == 'MARACAS'         then song.tracks[sti].color = CR_BL01 end
    if name == 'Castanets'       or name == 'castanets'       or name == 'CASTANETS'       then song.tracks[sti].color = CR_BL02 end
    if name == 'Wooden-block'    or name == 'wooden-block'    or name == 'WOODEN-BLOCK'    then song.tracks[sti].color = CR_BL03 end
    if name == 'Claves'          or name == 'claves'          or name == 'CLAVES'          then song.tracks[sti].color = CR_BL04 end
    if name == 'Tambourine'      or name == 'tambourine'      or name == 'TAMBOURINE'      then song.tracks[sti].color = CR_BL05 end
    if name == 'Cymbals'         or name == 'cymbals'         or name == 'CYMBALS'         then song.tracks[sti].color = CR_BL01 end
    if name == 'Snare Drum'      or name == 'snare drum'      or name == 'SNARE DRUM'      then song.tracks[sti].color = CR_BL02 end
    if name == 'Gong'            or name == 'gong'            or name == 'GONG'            then song.tracks[sti].color = CR_BL03 end
    if name == 'Timpani'         or name == 'timpani'         or name == 'TIMPANI'         then song.tracks[sti].color = CR_BL04 end
    if name == 'Congas'          or name == 'congas'          or name == 'CONGAS'          then song.tracks[sti].color = CR_BL05 end
    if name == 'Tenor Drum'      or name == 'tenor drum'      or name == 'TENOR DRUM'      then song.tracks[sti].color = CR_BL06 end
    if name == 'Bass Drum'       or name == 'bass drum'       or name == 'BASS DRUM'       then song.tracks[sti].color = CR_BL07 end

  --Band
                    --if name == '' or name == '' or name == '' then song.tracks[sti].color = CR_BL07 end
  --Electronic
  
    song.tracks[sti].color_blend = 15
  end
  vb.views['PEST_TEXTFIELD_RENAME'].text = ''
  if vb.views['PEST_CB_JUMP'].value == true then
    if song.selected_track_index < song.sequencer_track_count then
      song.selected_track_index = sti + 1
    end
  else
  end
end
PEST_TEXTFIELD_RENAME = vb:textfield { id ='PEST_TEXTFIELD_RENAME', align = 'center', width = 180, height = 22, 
  text ='Rename Track (include color).', notifier = function() rename_color() end, tooltip = 'Rename the selected track.\nUse the predefined names for rename the track and your associated color.'
}

PEST_CB_JUMP = vb:row { 
  vb:bitmap { bitmap = 'icons/jump-ico.bmp', mode = 'body_color', height = 22 },
  vb:vertical_aligner { mode = 'distribute',
    vb:checkbox { id = 'PEST_CB_JUMP', value = false, tooltip = 'Jump next track/group to Rename.' }
  }
}

--Clone track
function clone_track( song, sid, ssid, nmt, clt, cbt, ncl, vol, pan, dly, sfx, fxt )
  song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then --IF TRACK
    sid = song.selected_track_index
    ssid = song.tracks[ sid ]
    nmt = ssid.name                           print ( "nmt:" , nmt )
    clt = ssid.color                          print ( "clt:" , clt )
    cbt = ssid.color_blend                    print ( "cbt:" , cbt )
    --- ---
    ncl = ssid.visible_note_columns           print ( "ncl:" , ncl )
    vol = ssid.volume_column_visible          print ( "vol:" , vol )
    pan = ssid.panning_column_visible         print ( "pan:" , pan )
    dly = ssid.delay_column_visible           print ( "dly:" , dly )
    sfx = ssid.sample_effects_column_visible  print ( "sfx:" , sfx )
    fxt = ssid.visible_effect_columns         print ( "fxt:" , fxt )
    
    song:insert_track_at(sid + 1)
    ssid = song.tracks[ sid + 1] --redefine ssid
    ssid.name = nmt --ssid.name = "#"..nmt --ssid.name = nmt.." Clone"
    ssid.color = clt
    ssid.color_blend = cbt
    --- ---
    ssid.visible_note_columns = ncl
    ssid.volume_column_visible = vol
    ssid.panning_column_visible = pan
    ssid.delay_column_visible = dly
    ssid.sample_effects_column_visible = sfx
    ssid.visible_effect_columns = fxt
  
    song.selected_track_index = sid + 1
  else
   --content else
  end
end
PEST_BT_CLONE_TRACK = vb:button { id = 'PEST_BT_CLONE_TRACK', width = 32, height = 22, bitmap = 'icons/clone-tr-ico.bmp', color = { 0x00,0x40,0x40 },
  notifier = function() clone_track() end, tooltip = 'Clone track (without notes).'
}


--Expand Pattern Editor
function expand_pattern_editor( app )
  app = renoise.app()
  if ( app.window.upper_frame_is_visible == true or
       app.window.lower_frame_is_visible == true or
       app.window.pattern_matrix_is_visible == true or
       app.window.pattern_advanced_edit_is_visible == true or
       app.window.disk_browser_is_visible == true ) then
    app.window.upper_frame_is_visible = false
    app.window.lower_frame_is_visible = false
    app.window.pattern_matrix_is_visible = false
    app.window.pattern_advanced_edit_is_visible = false
    app.window.disk_browser_is_visible = false
    else
    app.window.upper_frame_is_visible = true
    app.window.lower_frame_is_visible = true
    app.window.pattern_matrix_is_visible = true
    app.window.pattern_advanced_edit_is_visible = true
    --app.window.disk_browser_is_visible = true
  end
end
PEST_BT_EXPAND_PATT_EDITOR = vb:button { id = 'PEST_BT_EXPAND_PATT_EDITOR',  width = 32, height = 22, bitmap = 'icons/show-patt-editor-ico.bmp', color = { 0x70,0x20,0xB0 },
  notifier = function() expand_pattern_editor() end, tooltip = 'Expand pattern editor.'
}


--------------------------------------------------------------------------------
-- REARM BACKGROUND BLEND (COLOR BLEND)
--------------------------------------------------------------------------------
--Rearm color blend        --song.tracks[].members[]  --song.tracks[].group_parent
function pest_fn_rearm_cblend( song, sti, selected_track, a, b, c, t, value )
  song = renoise.song()
  a = vb.views['PEST_VB_CBLEND_TRACK'].value
  b = vb.views['PEST_VB_CBLEND_SGROUP'].value
  c = vb.views['PEST_VB_CBLEND_GROUP'].value
  for i = #song.tracks, 1, -1 do
    --if track or send
    if ( song.tracks[ i ].type == renoise.Track.TRACK_TYPE_SEQUENCER or song.tracks[ i ].type == renoise.Track.TRACK_TYPE_SEND ) then
      song.tracks[ i ].color_blend = a
    end
    --if master
    if ( song.tracks[ i ].type == renoise.Track.TRACK_TYPE_MASTER ) then
      song.tracks[ i ].color_blend = c
    end
    --if group and subgroup
    if ( song.tracks[ i ].type == renoise.Track.TRACK_TYPE_GROUP ) then
      --if group
      if not song.tracks[ i ].group_parent then --if selected track does not have group_parent
        song.tracks[ i ].color_blend = c
      end
      --if subgroup
      if song.tracks[ i ].group_parent then --if selected track have group_parent
        song.tracks[ i ].color_blend = b
      end
    end
  end 
end

PEST_VB_CBLEND_TRACK = vb:row { vb:text { text = ' Tr', height = 22 },
  vb:valuebox { id = 'PEST_VB_CBLEND_TRACK',   width = 50, height = 22, min = 0, max = 99, value = 15,
  notifier = function() if vb.views['PEST_CB_RTIME'].value == true then pest_fn_rearm_cblend() end end, tooltip = 'Value of background blend to tracks & sends.\n[Default value = 15]' }
}
PEST_VB_CBLEND_SGROUP = vb:row { vb:text { text = ' SGr', height = 22 },
  vb:valuebox { id = 'PEST_VB_CBLEND_SGROUP', width = 50, height = 22, min = 0, max = 99, value = 30,
  notifier = function() if vb.views['PEST_CB_RTIME'].value == true then pest_fn_rearm_cblend() end end, tooltip = 'Value of background blend to subgroups.\n[Default value = 30]' }
}
PEST_VB_CBLEND_GROUP = vb:row { vb:text { text = ' Gr', height = 22 },
  vb:valuebox { id = 'PEST_VB_CBLEND_GROUP',   width = 50, height = 22, min = 0, max = 99, value = 55,
  notifier = function() if vb.views['PEST_CB_RTIME'].value == true then pest_fn_rearm_cblend() end end, tooltip = 'Value of background blend to groups (parents) & master.\n[Default value = 55]' }
}
PEST_BT_CBLEND = vb:button { id = 'PEST_BT_CBLEND',  width = 49, height = 22, text = 'Blend', color = { 0x00,0x40,0x70 },
  notifier = function() pest_fn_rearm_cblend() end, tooltip = 'Rearm the background blend to all tracks.'
}

PEST_CB_RTIME = vb:row {
  vb:text { text = ' RT', height = 22 },
  vb:vertical_aligner { mode = 'distribute',
    vb:checkbox { id = 'PEST_CB_RTIME', value = false, 
      notifier = function()
        if vb.views['PEST_CB_RTIME'].value == true then
          vb.views['PEST_BT_CBLEND'].color = { 0x40,0x00,0x00 } vb.views['PEST_BT_CBLEND'].active = false
          else
          vb.views['PEST_BT_CBLEND'].color = { 0x00,0x40,0x70 } vb.views['PEST_BT_CBLEND'].active = true
        end
      end,
      tooltip = 'Rearm in real time the background blend to type of track.\nTr = tracks & sends.\nSGr = subgroups.\nGr = groups (parents) & master.'
    }
  }
}


--------------------------------------------------------------------------------
-- INSERT GROUP, INSERT TRACK/S & ADD TRACKS TO GROUP
--------------------------------------------------------------------------------
--Insert Group Only
function in_gr( sti , group_setting )
  local song = renoise.song()
  local sti = song.selected_track_index + 1
  song:insert_group_at( sti )
  for parameter_name , parameter_value in pairs( group_setting ) do
    song:track( sti )[ parameter_name ] = parameter_value
  end
  song:select_next_track()
end
--Collapse Group (FXg only)
function coll_gr( song )
  song = renoise.song()
  song.tracks[ song.selected_track_index ].collapsed = true -- collapse the FXg in group selected
  --song.tracks[ song.selected_track_index - 1 ].group_parent.collapsed = true  -- collapse FXg in group parent
  --song.tracks[ song.selected_track_index ].group_collapsed = true -- collapse all group
end

--Insert Track Only
function in_tr( sti , track_setting )
  local song = renoise.song()
  local sti = song.selected_track_index + 1
  song:insert_track_at( sti ) --insert a track
  local tr = song:track( sti ) --define "tr"
  tr.visible_note_columns, tr.volume_column_visible, tr.panning_column_visible, tr.delay_column_visible, tr.sample_effects_column_visible, tr.visible_effect_columns = 1, T, F, F, F, 0  --config global parameters tr (checkboxes)
  for parameter_name, parameter_value in pairs( track_setting ) do -- config specific parameters tr ( name, color, color_blend )
    song:track( sti )[ parameter_name ] = parameter_value
  end
  song.selected_track_index = sti --select the track
end

--Insert Tracks in Group
function in_tr_gr_x1( song, sti ) -- x01
  song = renoise.song()
  sti = song.selected_track_index
  song:add_track_to_group( sti - 1, sti )
end

function in_tr_gr_x2( song, sti ) -- x02
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 2 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x3( song, sti ) -- x03
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 3 do
    song:add_track_to_group( sti - i, sti )
  end  
end

function in_tr_gr_x4( song, sti ) -- x04
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 4 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x5( song, sti ) -- x05
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 5 do
    song:add_track_to_group( sti - i, sti )
  end
end


function in_tr_gr_x6( song, sti ) -- x06
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 6 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x7( song, sti ) -- x07
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 7 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x8( song, sti ) -- x08
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 8 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x9( song, sti ) -- x09
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 9 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x10( song, sti ) -- x10
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 10 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x11( song, sti ) -- x11
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 11 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x12( song, sti ) -- x12
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 12 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x13( song, sti ) -- x13
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 13 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x14( song, sti ) -- x14
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 14 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x15( song, sti ) -- x15
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 15 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x16( song, sti ) -- x16
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 16 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x17( song, sti ) -- x17
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 17 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x18( song, sti ) -- x18
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 18 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x19( song, sti ) -- x19
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 19 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x20( song, sti ) -- x20
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 20 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x21( song, sti ) -- x21
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 21 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x22( song, sti ) -- x22
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 22 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x23( song, sti ) -- x23
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 23 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x24( song, sti ) -- x24
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 24 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x25( song, sti ) -- x25
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 25 do
    song:add_track_to_group( sti - i, sti )
  end
end

function in_tr_gr_x26( song, sti ) -- x26
  song = renoise.song()
  sti = song.selected_track_index
  for i = 1, 26 do
    song:add_track_to_group( sti - i, sti )
  end
end

--Insert Group with members (all tracks) in Main Group

function in_gr_mgr ( song, sti, m )
  song = renoise.song()
  sti = song.selected_track_index
  m = #song.tracks[sti].members --#selected_track.members
  print('m: ', m)
  song:add_track_to_group( sti - 1 - m, sti )
end  


--------------------------------------------------------------------------------
-- FUNCTIONS FOR POPUPS (Per Indiviual - Per Groups - Per All)
--------------------------------------------------------------------------------
--Symphony Orchestra Instruments (Per Individual - A01)
--Strings
function pest_fn_A01_01( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.solostring )
end

function pest_fn_A01_02( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.violins )
end

function pest_fn_A01_03( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.firstviolins )
end

function pest_fn_A01_04( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.secondviolins )
end

function pest_fn_A01_05( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.violas )
end

function pest_fn_A01_06( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.cellos )
end

function pest_fn_A01_07( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basses )
end
--Woodwinds
function pest_fn_A01_08( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.solowoodwind )
end

function pest_fn_A01_09( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.flute )
end

function pest_fn_A01_10( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.oboe )
end

function pest_fn_A01_11( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piccolo )
end

function pest_fn_A01_12( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.englishhorn )
end

function pest_fn_A01_13( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassclarinet )
end

function pest_fn_A01_14( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.clarinet )
end

function pest_fn_A01_15( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contrabasson )
end

function pest_fn_A01_16( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basson )
end

function pest_fn_A01_17( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bagpipe )
end

function pest_fn_A01_18( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.shakuhachi )
end



function pest_fn_A01_19( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.cornet )
end

function pest_fn_A01_20(song, sti)
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.harmonica )
end
--Brasses
function pest_fn_A01_21( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.solobrass )
end

function pest_fn_A01_22( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.trumpets )
end

function pest_fn_A01_23( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.trombones )
end

function pest_fn_A01_24( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tuba )
end

function pest_fn_A01_25( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.frenchhorns )
end

function pest_fn_A01_26( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.saxophone )
end
--Keyboard
function pest_fn_A01_27( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.harp )
end

function pest_fn_A01_28( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piano )
end

function pest_fn_A01_29( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer )
end

function pest_fn_A01_30( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.organ )
end

function pest_fn_A01_31( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.harpsichord )
end

function pest_fn_A01_32( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.celesta )
end

function pest_fn_A01_33( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.accordion )
end
--Voices
function pest_fn_A01_34( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.soloist )
end

function pest_fn_A01_35( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.soprano )
end

function pest_fn_A01_36( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.mezzosoprano )
end

function pest_fn_A01_37( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contralto )
end

function pest_fn_A01_38( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.countertenor )
end

function pest_fn_A01_39( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tenor )
end

function pest_fn_A01_40( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.baritone )
end

function pest_fn_A01_41( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassvoice )
end
--Chorus
function pest_fn_A01_42( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.mixedvoices )
end

function pest_fn_A01_43( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.womenvoices )
end

function pest_fn_A01_44( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.menvoices )
end

function pest_fn_A01_45( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.childrenvoices )
end
--Percussion
function pest_fn_A01_46( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tubularbells )
end

function pest_fn_A01_47( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.vibraphone )
end

function pest_fn_A01_48( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.xylophone )
end

function pest_fn_A01_49( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.glockenspiel )
end

function pest_fn_A01_50( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.marimba )
end

function pest_fn_A01_51( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.hammer )
end

function pest_fn_A01_52( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.triangle )
end

function pest_fn_A01_53( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.chimes )
end

function pest_fn_A01_54( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.maracas )
end

function pest_fn_A01_55( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.castanets )
end

function pest_fn_A01_56( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.woodenblock )
end

function pest_fn_A01_57( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.claves )
end

function pest_fn_A01_58( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tambourine )
end

function pest_fn_A01_59( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.cymbals )
end

function pest_fn_A01_60( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.snaredrum )
end

function pest_fn_A01_61( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.gong )
end

function pest_fn_A01_62( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.timpani )
end

function pest_fn_A01_63( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.congas )
end

function pest_fn_A01_64( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tenordrum )
end

function pest_fn_A01_65( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassdrum )
end

-----------------------------------------------------------------------------------

--Symphony Orchestra Sections
function pest_fn_A02_01( song, sti ) --Strings Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basses )
  in_tr( sti , track.cellos )
  in_tr( sti , track.violas )
  in_tr( sti , track.secondviolins )
  in_tr( sti , track.firstviolins )
  in_tr( sti , track.solostring )
  in_gr( sti , group.strings )
  in_tr_gr_x6()
  coll_gr()
end
function pest_fn_A02_01_little( song, sti ) --Strings Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basses )
  in_tr( sti , track.cellos )
  in_tr( sti , track.violas )
  in_tr( sti , track.violins )
  in_gr( sti , group.strings )
  in_tr_gr_x4()
  coll_gr()
end
--- --- ---
function pest_fn_A02_02( song, sti ) --Strings Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basses )
  in_tr( sti , track.basses )
  in_tr( sti , track.cellos )
  in_tr( sti , track.cellos )
  in_tr( sti , track.violas )
  in_tr( sti , track.violas )
  in_tr( sti , track.secondviolins )
  in_tr( sti , track.secondviolins )
  in_tr( sti , track.firstviolins )
  in_tr( sti , track.firstviolins )
  in_tr( sti , track.solostring )
  in_tr( sti , track.solostring )
  in_gr( sti , group.strings )
  in_tr_gr_x12()
  coll_gr()
end
--- --- ---
function pest_fn_A02_03( song, sti ) --Woodwinds Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.harmonica )
  in_tr( sti , track.cornet )
  in_tr( sti , track.shakuhachi )
  in_tr( sti , track.bagpipe )
  in_tr( sti , track.basson )  
  in_tr( sti , track.contrabasson )
  in_tr( sti , track.clarinet )
  in_tr( sti , track.bassclarinet )
  in_tr( sti , track.englishhorn )
  in_tr( sti , track.piccolo )
  in_tr( sti , track.oboe )
  in_tr( sti , track.flute )
  in_tr( sti , track.solowoodwind )
  in_gr( sti , group.woodwinds )
  in_tr_gr_x13()
  coll_gr()
end
function pest_fn_A02_03_little( song, sti ) --Woodwinds Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.basson )  
  in_tr( sti , track.contrabasson )
  in_tr( sti , track.clarinet )
  in_tr( sti , track.bassclarinet )
  in_tr( sti , track.englishhorn )
  in_tr( sti , track.piccolo )
  in_tr( sti , track.oboe )
  in_tr( sti , track.flute )
  in_gr( sti , group.woodwinds )
  in_tr_gr_x8()
  coll_gr()
end
--- --- ---
function pest_fn_A02_04( song, sti ) --Woodwinds Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.harmonica )
  in_tr( sti , track.cornet )
  in_tr( sti , track.shakuhachi )
  in_tr( sti , track.shakuhachi )
  in_tr( sti , track.bagpipe )
  in_tr( sti , track.bagpipe )
  in_tr( sti , track.basson )
  in_tr( sti , track.basson )
  in_tr( sti , track.contrabasson )
  in_tr( sti , track.contrabasson )
  in_tr( sti , track.clarinet )
  in_tr( sti , track.clarinet )
  in_tr( sti , track.bassclarinet )
  in_tr( sti , track.bassclarinet )
  in_tr( sti , track.englishhorn )
  in_tr( sti , track.englishhorn )
  in_tr( sti , track.piccolo )
  in_tr( sti , track.piccolo )
  in_tr( sti , track.oboe )
  in_tr( sti , track.oboe )
  in_tr( sti , track.flute )
  in_tr( sti , track.flute )
  in_tr( sti , track.solowoodwind )
  in_tr( sti , track.solowoodwind )
  in_gr( sti , group.woodwinds )
  in_tr_gr_x24()
  coll_gr()
end
--- --- ---
function pest_fn_A02_05( song, sti ) --Strings + Woodwinds
  pest_fn_A02_01()
  pest_fn_A02_03()
end
--- --- ---
function pest_fn_A02_06( song, sti ) --Brass Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.saxophone )
  in_tr( sti , track.frenchhorns )
  in_tr( sti , track.tuba )
  in_tr( sti , track.trombones )
  in_tr( sti , track.trumpets )
  in_tr( sti , track.solobrass )
  in_gr( sti , group.brass )
  in_tr_gr_x6()
  coll_gr()
end
function pest_fn_A02_06_little( song, sti ) --Brass little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.frenchhorns )
  in_tr( sti , track.tuba )
  in_tr( sti , track.trombones )
  in_tr( sti , track.trumpets )
  in_gr( sti , group.brass )
  in_tr_gr_x4()
  coll_gr()
end
--- --- ---
function pest_fn_A02_07( song, sti ) --Brass Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.saxophone )
  in_tr( sti , track.saxophone )
  in_tr( sti , track.frenchhorns )
  in_tr( sti , track.frenchhorns )
  in_tr( sti , track.tuba )
  in_tr( sti , track.tuba )
  in_tr( sti , track.trombones )
  in_tr( sti , track.trombones )
  in_tr( sti , track.trumpets )
  in_tr( sti , track.trumpets )
  in_tr( sti , track.solobrass )
  in_tr( sti , track.solobrass )
  in_gr( sti , group.brass )
  in_tr_gr_x12()
  coll_gr()
end
--- --- ---
function pest_fn_A02_08() --Strings + Brass
  pest_fn_A02_01()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_09() --Woodwinds + Brass
  pest_fn_A02_03()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_10( song, sti ) --Keyboards Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.accordion )
  in_tr( sti , track.celesta )
  in_tr( sti , track.harpsichord )
  in_tr( sti , track.organ )
  in_tr( sti , track.synthesizer )
  in_tr( sti , track.piano )
  in_tr( sti , track.harp )
  in_gr( sti , group.keyboards )
  in_tr_gr_x7()
  coll_gr()
end
function pest_fn_A02_10_little( song, sti ) --Keyboards Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer )
  in_tr( sti , track.piano )
  in_tr( sti , track.harp )
  in_gr( sti , group.keyboards )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_11( song, sti ) --Keyboards Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.accordion )
  in_tr( sti , track.accordion )
  in_tr( sti , track.celesta )
  in_tr( sti , track.celesta )
  in_tr( sti , track.harpsichord )
  in_tr( sti , track.harpsichord )
  in_tr( sti , track.organ )
  in_tr( sti , track.organ )
  in_tr( sti , track.synthesizer )
  in_tr( sti , track.synthesizer )
  in_tr( sti , track.piano )
  in_tr( sti , track.piano )
  in_tr( sti , track.harp )
  in_tr( sti , track.harp )
  in_gr( sti , group.keyboards )
  in_tr_gr_x14()
  coll_gr()
end
--- --- ---
function pest_fn_A02_12() --Keyboards + Strings
  pest_fn_A02_10()
  pest_fn_A02_01()
end
--- --- ---
function pest_fn_A02_13() --Keyboards + Woodwinds
  pest_fn_A02_10()
  pest_fn_A02_03()
end
--- --- ---
function pest_fn_A02_14() --Keyboards + Brass
  pest_fn_A02_10()
  pest_fn_A02_06()
end
--- --- ---
function pest_fn_A02_15( song, sti ) --Strings + Pianos
  pest_fn_A02_01()
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piano3 )
  in_tr( sti , track.piano2 )
  in_tr( sti , track.piano1 )
  in_gr( sti , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_16( song, sti ) --Woodwindws + Pianos
  pest_fn_A02_01()
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piano3 )
  in_tr( sti , track.piano2 )
  in_tr( sti , track.piano1 )
  in_gr( sti , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_17( song, sti ) --Brass + Pianos
  pest_fn_A02_06()
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piano3 )
  in_tr( sti , track.piano2 )
  in_tr( sti , track.piano1 )
  in_gr( sti , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_18( song, sti ) --Triple Piano (Panning ±20)
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.pianor )
  song.selected_track.prefx_panning.value = 0.70 --(L = 0.00, C = 0.50 R = 1; 101 values)
  in_tr( sti , track.pianoc )
  in_tr( sti , track.pianol )
  song.selected_track.prefx_panning.value = 0.30
  in_gr( sti , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_19( song, sti ) --Synths + Pianos
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer3 )
  in_tr( sti , track.synthesizer2 )
  in_tr( sti , track.synthesizer1 )
  in_gr( sti , group.synthesizers )
  in_tr_gr_x3()
  coll_gr()
  --
  sti = song.selected_track_index
  in_tr( sti , track.piano3 )
  in_tr( sti , track.piano2 )
  in_tr( sti , track.piano1 )
  in_gr( sti , group.pianos )
  in_tr_gr_x3()
  coll_gr()
end
--- --- ---
function pest_fn_A02_20( song, sti ) --Voices Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassvoice )
  in_tr( sti , track.baritone )
  in_tr( sti , track.tenor )
  in_tr( sti , track.countertenor )
  in_tr( sti , track.contralto )
  in_tr( sti , track.mezzosoprano )
  in_tr( sti , track.soprano )
  in_tr( sti , track.soloist )
  in_gr( sti , group.voices )
  in_tr_gr_x8()
  coll_gr()
end
function pest_fn_A02_20_little( song, sti ) --Voices Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassvoice )
  in_tr( sti , track.tenor )
  in_tr( sti , track.soprano )
  in_tr( sti , track.soloist )
  in_gr( sti , group.voices )
  in_tr_gr_x4()
  coll_gr()
end
--- --- ---
function pest_fn_A02_21( song, sti ) --Voices Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassvoice )
  in_tr( sti , track.bassvoice )
  in_tr( sti , track.baritone )
  in_tr( sti , track.baritone )
  in_tr( sti , track.tenor )
  in_tr( sti , track.tenor )
  in_tr( sti , track.countertenor )
  in_tr( sti , track.countertenor )
  in_tr( sti , track.contralto )
  in_tr( sti , track.contralto )
  in_tr( sti , track.mezzosoprano )
  in_tr( sti , track.mezzosoprano )
  in_tr( sti , track.soprano )
  in_tr( sti , track.soprano )
  in_tr( sti , track.soloist )
  in_tr( sti , track.soloist )
  in_gr( sti , group.voices2 )
  in_tr_gr_x16()
  coll_gr()
end
--- --- ---
function pest_fn_A02_22( song, sti ) --Chorus Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.childrenvoices )
  in_tr( sti , track.menvoices )
  in_tr( sti , track.womenvoices )
  in_tr( sti , track.mixedvoices )
  in_gr( sti , group.chorus )
  in_tr_gr_x4()
  coll_gr()
end
--- --- ---
function pest_fn_A02_23( song, sti ) --Chorus Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.childrenvoices )
  in_tr( sti , track.childrenvoices )
  in_tr( sti , track.menvoices )
  in_tr( sti , track.menvoices )
  in_tr( sti , track.womenvoices )
  in_tr( sti , track.womenvoices )
  in_tr( sti , track.mixedvoices )
  in_tr( sti , track.mixedvoices )
  in_gr( sti , group.chorus )
  in_tr_gr_x8()
  coll_gr()
end
--- --- ---
function pest_fn_A02_24() --Voices + Chorus
  pest_fn_A02_20()
  pest_fn_A02_22()
end
--- --- ---
function pest_fn_A02_25( song, sti ) --Percussion Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassdrum )
  in_tr( sti , track.tenordrum )
  in_tr( sti , track.congas )
  in_tr( sti , track.timpani )
  in_tr( sti , track.gong )
  in_tr( sti , track.snaredrum )
  in_tr( sti , track.cymbals )
  --
  in_tr( sti , track.tambourine )
  in_tr( sti , track.claves )
  in_tr( sti , track.woodenblock )
  in_tr( sti , track.castanets )
  in_tr( sti , track.maracas )
  --
  in_tr( sti , track.chimes )
  in_tr( sti , track.triangle )
  in_tr( sti , track.hammer )
  in_tr( sti , track.marimba )
  in_tr( sti , track.glockenspiel )
  in_tr( sti , track.xylophone )
  in_tr( sti , track.vibraphone )
  in_tr( sti , track.tubularbells )
  in_gr( sti , group.percussion )
  in_tr_gr_x20()
  coll_gr()
end
function pest_fn_A02_25_little( song, sti ) --Percussion Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassdrum )
  in_tr( sti , track.congas )
  in_tr( sti , track.timpani )
  in_tr( sti , track.snaredrum )
  in_tr( sti , track.cymbals )
  --
  in_tr( sti , track.tambourine )
  in_tr( sti , track.claves )
  --
  in_tr( sti , track.chimes )
  in_tr( sti , track.triangle )
  in_tr( sti , track.marimba )
  in_tr( sti , track.xylophone )
  in_gr( sti , group.percussion )
  in_tr_gr_x11()
  coll_gr()
end
--- --- ---
function pest_fn_A02_26( song, sti ) --Percussion Expanded I
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.chimes )
  in_tr( sti , track.chimes )
  in_tr( sti , track.triangle )
  in_tr( sti , track.triangle )
  in_tr( sti , track.hammer )
  in_tr( sti , track.hammer )
  in_tr( sti , track.marimba )
  in_tr( sti , track.marimba )
  in_tr( sti , track.glockenspiel )
  in_tr( sti , track.glockenspiel )
  in_tr( sti , track.xylophone )
  in_tr( sti , track.xylophone )
  in_tr( sti , track.vibraphone )
  in_tr( sti , track.vibraphone )
  in_tr( sti , track.tubularbells )
  in_tr( sti , track.tubularbells )
  in_gr( sti , group.percussion1 )
  in_tr_gr_x16()
  coll_gr()
end
--- --- ---
function pest_fn_A02_27( song, sti ) --Percussion Expanded II
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.tambourine )
  in_tr( sti , track.tambourine )
  in_tr( sti , track.claves )
  in_tr( sti , track.claves )
  in_tr( sti , track.woodenblock )
  in_tr( sti , track.woodenblock )
  in_tr( sti , track.castanets )
  in_tr( sti , track.castanets )
  in_tr( sti , track.maracas )
  in_tr( sti , track.maracas )
  in_gr( sti , group.percussion2 )
  in_tr_gr_x10()
  coll_gr()
end
--- --- ---
function pest_fn_A02_28( song, sti ) --Percussion Expanded III
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassdrum )
  in_tr( sti , track.bassdrum )
  in_tr( sti , track.tenordrum )
  in_tr( sti , track.tenordrum )
  in_tr( sti , track.congas )
  in_tr( sti , track.congas )
  in_tr( sti , track.timpani )
  in_tr( sti , track.timpani )
  in_tr( sti , track.gong )
  in_tr( sti , track.gong )
  in_tr( sti , track.snaredrum )
  in_tr( sti , track.snaredrum )
  in_tr( sti , track.cymbals )
  in_tr( sti , track.cymbals )
  in_gr( sti , group.percussion3 )
  in_tr_gr_x14()
  coll_gr()
end
--- --- ---
function pest_fn_A02_29( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.strings )
end
--- --- ---
function pest_fn_A02_30( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.woodwinds )
end
--- --- ---
function pest_fn_A02_31( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.brass )
end
--- --- ---
function pest_fn_A02_32( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.keyboards )
end
--- --- ---
function pest_fn_A02_33( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.voices )
end
--- --- ---
function pest_fn_A02_34( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.chorus )
end
--- --- ---
function pest_fn_A02_35( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.percussion )
end

function pest_fn_A02_36( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.orchestra_big )
end

function pest_fn_A02_37( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.orchestra_little )
end

-----------------------------------------------------------------------------------

--Symphony Orchestra Big
function pest_fn_A03_01( song, sti )
  pest_fn_A02_25()
  pest_fn_A02_22()
  pest_fn_A02_20()
  pest_fn_A02_10()
  pest_fn_A02_06()
  pest_fn_A02_03()
  pest_fn_A02_01()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.orchestra_big )
  for i = 1, 7 do in_gr_mgr() end
  coll_gr()
end

--Symphony Orchestra Little
function pest_fn_A03_02( song, sti )
  pest_fn_A02_25_little()
  pest_fn_A02_22()
  pest_fn_A02_20_little()
  pest_fn_A02_10_little()
  pest_fn_A02_06_little()
  pest_fn_A02_03_little()
  pest_fn_A02_01_little()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.orchestra_little )
  for i = 1, 7 do in_gr_mgr() end
  coll_gr()
end

--Symphony Orchestra Little + Triple Piano
function pest_fn_A03_03( song, sti )
  pest_fn_A02_25_little()
  pest_fn_A02_22()
  pest_fn_A02_20_little()
  pest_fn_A02_10_little()
  pest_fn_A02_06_little()
  pest_fn_A02_03_little()
  pest_fn_A02_01_little()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.orchestra_little )
  for i = 1, 7 do in_gr_mgr() end
  coll_gr()
  pest_fn_A02_18() --Triple Piano
end

--Symphony Orchestra Little + Synths + Pianos
function pest_fn_A03_04( song, sti )
  pest_fn_A02_25_little()
  pest_fn_A02_22()
  pest_fn_A02_20_little()
  pest_fn_A02_10_little()
  pest_fn_A02_06_little()
  pest_fn_A02_03_little()
  pest_fn_A02_01_little()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.orchestra_little )
  for i = 1, 7 do in_gr_mgr() end
  coll_gr()
  pest_fn_A02_19() --Synths + Pianos
end

function pest_fn_A03_05()
  --content
  end
function pest_fn_A03_06()
  --content
end
function pest_fn_A03_07()
  --content
end


-----------------------------------------------------------------------------------
--Band Pop/Rock/Heavy (Per Individual - B01)
--Voices
function pest_fn_B01_01( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voice1 )
end
function pest_fn_B01_02( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voice2 )
end
function pest_fn_B01_03( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voices )
end
--Guitars
function pest_fn_B01_04( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.acousticguitar )
end
function pest_fn_B01_05( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.electricguitar1 )
end
function pest_fn_B01_06( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.electricguitar2 )
end
function pest_fn_B01_07( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassguitar )
end
function pest_fn_B01_08( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contrabassguitar )
end
--Keyboards
function pest_fn_B01_09( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.piano )
end
function pest_fn_B01_10( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer1 )
end
function pest_fn_B01_11( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer2 )
end
function pest_fn_B01_12( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer3 )
end
--Drum Kit
function pest_fn_B01_13( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.bassdrum2 )
end
function pest_fn_B01_14( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.floortom )
end
function pest_fn_B01_15( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.snaredrum2 )
end
function pest_fn_B01_16( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.hangingtombs )
end
function pest_fn_B01_17( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.hihat )
end
function pest_fn_B01_18( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.crashcymbal )
end
function pest_fn_B01_19( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.ridecymbal )
end
function pest_fn_B01_20( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.splashcymbal )
end
function pest_fn_B01_21( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.chinacymbal )
end

-----------------------------------------------------
--Band Pop/Rock/Heavy Sections
function pest_fn_B02_01( song, sti ) --Voices Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voices )
  in_tr( sti , track.voice2 )
  in_tr( sti , track.voice1 )
  in_gr( sti , group.voices2 )
  in_tr_gr_x3()
  coll_gr()
end

function pest_fn_B02_01_little( song, sti ) --Voices Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voice2 )
  in_tr( sti , track.voice1 )
  in_gr( sti , group.voices2 )
  in_tr_gr_x2()
  coll_gr()
end

function pest_fn_B02_02( song, sti ) --Voices Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.voices )
  in_tr( sti , track.voices )
  in_tr( sti , track.voice2 )
  in_tr( sti , track.voice2 )
  in_tr( sti , track.voice1 )
  in_tr( sti , track.voice1 )
  in_gr( sti , group.voices2 )
  in_tr_gr_x6()
  coll_gr()
end

function pest_fn_B02_03( song, sti ) --Guitars Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contrabassguitar )
  in_tr( sti , track.bassguitar )
  in_tr( sti , track.electricguitar2 )
  in_tr( sti , track.electricguitar1 )
  in_tr( sti , track.acousticguitar )
  in_gr( sti , group.guitars )
  in_tr_gr_x5()
  coll_gr()
end

function pest_fn_B02_03_little( song, sti ) --Guitars Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contrabassguitar )
  in_tr( sti , track.bassguitar )
  in_tr( sti , track.electricguitar1 )
  in_gr( sti , group.guitars )
  in_tr_gr_x3()
  coll_gr()
end

function pest_fn_B02_04( song, sti ) --Guitars Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.contrabassguitar )
  in_tr( sti , track.contrabassguitar )
  in_tr( sti , track.bassguitar )
  in_tr( sti , track.bassguitar )
  in_tr( sti , track.electricguitar2 )
  in_tr( sti , track.electricguitar2 )
  in_tr( sti , track.electricguitar1 )
  in_tr( sti , track.electricguitar1 )
  in_tr( sti , track.acousticguitar )
  in_tr( sti , track.acousticguitar )
  in_gr( sti , group.guitars )
  in_tr_gr_x10()
  coll_gr()
end

function pest_fn_B02_05( song, sti ) --Keyboards Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer3 )
  in_tr( sti , track.synthesizer2 )
  in_tr( sti , track.synthesizer1 )
  in_tr( sti , track.piano )
  in_gr( sti , group.keyboards )
  in_tr_gr_x4()
  coll_gr()
end

function pest_fn_B02_05_little( song, sti ) --Keyboards Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer1 )
  in_tr( sti , track.piano )
  in_gr( sti , group.keyboards )
  in_tr_gr_x2()
  coll_gr()
end

function pest_fn_B02_06( song, sti ) --Keyboards Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.synthesizer3 )
  in_tr( sti , track.synthesizer3 )
  in_tr( sti , track.synthesizer2 )
  in_tr( sti , track.synthesizer2 )
  in_tr( sti , track.synthesizer1 )
  in_tr( sti , track.synthesizer1 )
  in_tr( sti , track.piano )
  in_tr( sti , track.piano )
  in_gr( sti , group.keyboards )
  in_tr_gr_x8()
  coll_gr()
end

function pest_fn_B02_07( song, sti ) --Drum Kit Basic
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.chinacymbal )
  in_tr( sti , track.splashcymbal )
  in_tr( sti , track.ridecymbal )
  in_tr( sti , track.crashcymbal )
  in_tr( sti , track.hihat )
  in_tr( sti , track.hangingtombs )
  in_tr( sti , track.snaredrum2 )
  in_tr( sti , track.floortom )
  in_tr( sti , track.bassdrum2 )
  in_gr( sti , group.drum_kit )
  in_tr_gr_x9()
  coll_gr()
end

function pest_fn_B02_07_little( song, sti ) --Drum Kit Little
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.crashcymbal )
  in_tr( sti , track.hihat )
  in_tr( sti , track.snaredrum2 )
  in_tr( sti , track.bassdrum2 )
  in_gr( sti , group.drum_kit )
  in_tr_gr_x4()
  coll_gr()
end



function pest_fn_B02_08( song, sti ) --Drum Kit Expanded
  song = renoise.song()
  sti = song.selected_track_index
  in_tr( sti , track.chinacymbal )
  in_tr( sti , track.chinacymbal )
  in_tr( sti , track.splashcymbal )
  in_tr( sti , track.splashcymbal )
  in_tr( sti , track.ridecymbal )
  in_tr( sti , track.ridecymbal )
  in_tr( sti , track.crashcymbal )
  in_tr( sti , track.crashcymbal )
  in_tr( sti , track.hihat )
  in_tr( sti , track.hihat )
  in_tr( sti , track.hangingtombs )
  in_tr( sti , track.hangingtombs )
  in_tr( sti , track.snaredrum2 )
  in_tr( sti , track.snaredrum2 )
  in_tr( sti , track.floortom )
  in_tr( sti , track.floortom )
  in_tr( sti , track.bassdrum2 )
  in_tr( sti , track.bassdrum2 )
  in_gr( sti , group.drum_kit )
  in_tr_gr_x18()
  coll_gr()
end

function pest_fn_B02_09( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.voices )
end

function pest_fn_B02_10( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.guitars )
end

function pest_fn_B02_11( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.keyboards )
end

function pest_fn_B02_12( song, sti )
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti , group.drum_kit )
end


-----------------------------------------------------
function pest_fn_B03_01( song, sti )
  pest_fn_B02_07()
  pest_fn_B02_05()
  pest_fn_B02_03()
  pest_fn_B02_01()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.band )
  for i = 1, 4 do in_gr_mgr() end
  coll_gr()
end

function pest_fn_B03_02( song, sti )
  pest_fn_B02_07_little()
  pest_fn_B02_05_little()
  pest_fn_B02_03_little()
  pest_fn_B02_01_little()
  --- ---
  song = renoise.song()
  sti = song.selected_track_index
  in_gr( sti, group.band )
  for i = 1, 4 do in_gr_mgr() end
  coll_gr()
end

function pest_fn_B03_03()
  --content
end


-----------------------------------------------------
function pest_fn_C01_01()
  --content
end
function pest_fn_C01_02()
  --content
  end
function pest_fn_C01_03()
  --content
end
-----------------------------------------------------
function pest_fn_C02_01()
  --content
end
function pest_fn_C02_02()
  --content
  end
function pest_fn_C02_03()
  --content
end
-----------------------------------------------------
function pest_fn_C03_01()
  --content
end
function pest_fn_C03_02()
  --content
  end
function pest_fn_C03_03()
  --content
end


STATUS = "GT16-Colors PEST:  your selected template has been inserted in pattern editor."
STATUS2 = "GT16-Colors PEST:  your selected group has been inserted in pattern editor."
SELECT = "⚠ GT16-Colors PEST:  please, select before a option from the list!!!" 
WARTING = "⚠ GT16-Colors PEST:  please, select before a track or group in pattern editor, pattern matrix or mixer!!!" 


--Group A (A01)
function pest_fn_A01( popup ) --( 62 of 70 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then app:show_status( SELECT )
  elseif popup == 3 then pest_fn_A01_01()
  elseif popup == 4 then pest_fn_A01_02()
  elseif popup == 5 then pest_fn_A01_03()
  elseif popup == 6 then pest_fn_A01_04()
  elseif popup == 7 then pest_fn_A01_05()
  elseif popup == 8 then pest_fn_A01_06()
  elseif popup == 9 then pest_fn_A01_07()
  elseif popup ==10 then app:show_status( SELECT )
  elseif popup ==11 then pest_fn_A01_08()
  elseif popup ==12 then pest_fn_A01_09()
  elseif popup ==13 then pest_fn_A01_10()
  elseif popup ==14 then pest_fn_A01_11()
  elseif popup ==15 then pest_fn_A01_12()
  elseif popup ==16 then pest_fn_A01_13()
  elseif popup ==17 then pest_fn_A01_14()
  elseif popup ==18 then pest_fn_A01_15()
  elseif popup ==19 then pest_fn_A01_16()
  elseif popup ==20 then pest_fn_A01_17()
  elseif popup ==21 then pest_fn_A01_18()
  elseif popup ==22 then pest_fn_A01_19()
  elseif popup ==23 then pest_fn_A01_20()
  elseif popup ==24 then app:show_status( SELECT )
  elseif popup ==25 then pest_fn_A01_21()
  elseif popup ==26 then pest_fn_A01_22()
  elseif popup ==27 then pest_fn_A01_23()
  elseif popup ==28 then pest_fn_A01_24()
  elseif popup ==29 then pest_fn_A01_25()
  elseif popup ==30 then pest_fn_A01_26()
  elseif popup ==31 then app:show_status( SELECT )
  elseif popup ==32 then pest_fn_A01_27()
  elseif popup ==33 then pest_fn_A01_28()
  elseif popup ==34 then pest_fn_A01_29()
  elseif popup ==35 then pest_fn_A01_30()
  elseif popup ==36 then pest_fn_A01_31()
  elseif popup ==37 then pest_fn_A01_32()
  elseif popup ==38 then pest_fn_A01_33()
  elseif popup ==39 then app:show_status( SELECT )
  elseif popup ==40 then pest_fn_A01_34()
  elseif popup ==41 then pest_fn_A01_35()
  elseif popup ==42 then pest_fn_A01_36()
  elseif popup ==43 then pest_fn_A01_37()
  elseif popup ==44 then pest_fn_A01_38()
  elseif popup ==45 then pest_fn_A01_39()
  elseif popup ==46 then pest_fn_A01_40()
  elseif popup ==47 then pest_fn_A01_41()
  elseif popup ==48 then app:show_status( SELECT )
  elseif popup ==49 then pest_fn_A01_42()
  elseif popup ==50 then pest_fn_A01_43()
  elseif popup ==51 then pest_fn_A01_44()
  elseif popup ==52 then pest_fn_A01_45()
  elseif popup ==53 then app:show_status( SELECT )
  elseif popup ==54 then pest_fn_A01_46()
  elseif popup ==55 then pest_fn_A01_47()
  elseif popup ==56 then pest_fn_A01_48()
  elseif popup ==57 then pest_fn_A01_49()
  elseif popup ==58 then pest_fn_A01_50()
  elseif popup ==59 then pest_fn_A01_51()
  elseif popup ==60 then pest_fn_A01_52()
  elseif popup ==61 then pest_fn_A01_53()
  elseif popup ==62 then pest_fn_A01_54()
  elseif popup ==63 then pest_fn_A01_55()
  elseif popup ==64 then pest_fn_A01_56()
  elseif popup ==65 then pest_fn_A01_57()
  elseif popup ==66 then pest_fn_A01_58()
  elseif popup ==67 then pest_fn_A01_59()
  elseif popup ==68 then pest_fn_A01_60()
  elseif popup ==69 then pest_fn_A01_61()
  elseif popup ==70 then pest_fn_A01_62()
  elseif popup ==71 then pest_fn_A01_63()
  elseif popup ==72 then pest_fn_A01_64()
  elseif popup ==73 then pest_fn_A01_65()
  end
end
--Group A (A02)
function pest_fn_A02( popup ) --( 24 of 25 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_A02_01()
  elseif popup == 3 then pest_fn_A02_02()
  elseif popup == 4 then pest_fn_A02_03()
  elseif popup == 5 then pest_fn_A02_04()
  elseif popup == 6 then pest_fn_A02_05()
  elseif popup == 7 then pest_fn_A02_06()
  elseif popup == 8 then pest_fn_A02_07()
  elseif popup == 9 then pest_fn_A02_08()
  elseif popup ==10 then pest_fn_A02_09()
  elseif popup ==11 then pest_fn_A02_10()
  elseif popup ==12 then pest_fn_A02_11()
  elseif popup ==13 then pest_fn_A02_12()
  elseif popup ==14 then pest_fn_A02_13()
  elseif popup ==15 then pest_fn_A02_14()
  elseif popup ==16 then pest_fn_A02_15()
  elseif popup ==17 then pest_fn_A02_16()
  elseif popup ==18 then pest_fn_A02_17()
  elseif popup ==19 then pest_fn_A02_18()
  elseif popup ==20 then pest_fn_A02_19()
  elseif popup ==21 then pest_fn_A02_20()
  elseif popup ==22 then pest_fn_A02_21()
  elseif popup ==23 then pest_fn_A02_22()
  elseif popup ==24 then pest_fn_A02_23()
  elseif popup ==25 then pest_fn_A02_24()
  elseif popup ==26 then pest_fn_A02_25()
  elseif popup ==27 then pest_fn_A02_26()
  elseif popup ==28 then pest_fn_A02_27()
  elseif popup ==29 then pest_fn_A02_28()
  elseif popup ==30 then app:show_status( SELECT )
  elseif popup ==31 then pest_fn_A02_29()
  elseif popup ==32 then pest_fn_A02_30()
  elseif popup ==33 then pest_fn_A02_31()
  elseif popup ==34 then pest_fn_A02_32()
  elseif popup ==35 then pest_fn_A02_33()
  elseif popup ==36 then pest_fn_A02_34()
  elseif popup ==37 then pest_fn_A02_35()
  elseif popup ==38 then pest_fn_A02_36()
  elseif popup ==39 then pest_fn_A02_37()
  end
end
--Group A (A03)
function pest_fn_A03( popup ) -- ( 03 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_A03_01()
  elseif popup == 3 then pest_fn_A03_02()
  elseif popup == 4 then pest_fn_A03_03()
  elseif popup == 5 then pest_fn_A03_04()
  end
end


--- --- --- ---
--Group B
function pest_fn_B01( popup ) --( 62 of 70 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then app:show_status( SELECT )
  elseif popup == 3 then pest_fn_B01_01()
  elseif popup == 4 then pest_fn_B01_02()
  elseif popup == 5 then pest_fn_B01_03()
  elseif popup == 6 then app:show_status( SELECT )
  elseif popup == 7 then pest_fn_B01_04()
  elseif popup == 8 then pest_fn_B01_05()
  elseif popup == 9 then pest_fn_B01_06()
  elseif popup ==10 then pest_fn_B01_07()
  elseif popup ==11 then pest_fn_B01_08()
  elseif popup ==12 then app:show_status( SELECT )
  elseif popup ==13 then pest_fn_B01_09()
  elseif popup ==14 then pest_fn_B01_10()
  elseif popup ==15 then pest_fn_B01_11()
  elseif popup ==16 then pest_fn_B01_12()
  elseif popup ==17 then app:show_status( SELECT )
  elseif popup ==18 then pest_fn_B01_13()
  elseif popup ==19 then pest_fn_B01_14()
  elseif popup ==20 then pest_fn_B01_15()
  elseif popup ==21 then pest_fn_B01_16()
  elseif popup ==22 then pest_fn_B01_17()
  elseif popup ==23 then pest_fn_B01_18()
  elseif popup ==24 then pest_fn_B01_19()
  elseif popup ==25 then pest_fn_B01_20()
  elseif popup ==26 then pest_fn_B01_21()
  end
end

function pest_fn_B02( popup ) -- ( 03 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_B02_01()
  elseif popup == 3 then pest_fn_B02_02()
  elseif popup == 4 then pest_fn_B02_03()
  elseif popup == 5 then pest_fn_B02_04()
  elseif popup == 6 then pest_fn_B02_05()
  elseif popup == 7 then pest_fn_B02_06()
  elseif popup == 8 then pest_fn_B02_07()
  elseif popup == 9 then pest_fn_B02_08()
  elseif popup ==10 then app:show_status( SELECT )
  elseif popup ==11 then pest_fn_B02_09()
  elseif popup ==12 then pest_fn_B02_10()
  elseif popup ==13 then pest_fn_B02_11()
  elseif popup ==14 then pest_fn_B02_12()
  end
end

function pest_fn_B03( popup ) -- ( 03 )
  local app = renoise.app()
  if     popup == 1 then app:show_status( SELECT )
  elseif popup == 2 then pest_fn_B03_01()
  elseif popup == 3 then pest_fn_B03_02()
  end
end


--Group C
function pest_fn_C01( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C01_01()
  elseif popup == 2 then pest_fn_C01_02()
  elseif popup == 3 then pest_fn_C01_03()
  end
end

function pest_fn_C02( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C02_01()
  elseif popup == 2 then pest_fn_C02_02()
  elseif popup == 3 then pest_fn_C02_03()
  end
end

function pest_fn_C03( popup ) -- ( 03 )
  if     popup == 1 then pest_fn_C03_01()
  elseif popup == 2 then pest_fn_C03_02()
  elseif popup == 3 then pest_fn_C03_03()
  end
end


--------------------------------------------------------------------------------
-- BUTTON INSERT FUNCTIONS OF POPUPS
--------------------------------------------------------------------------------

--Group A
function pest_A01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A01 ( PEST_PP_A01.value )
    else renoise.app():show_status( WARTING )
  end
end

function pest_A02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A02 ( PEST_PP_A02.value )
    else renoise.app():show_status( WARTING )
  end
end

function pest_A03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_A03 ( PEST_PP_A03.value )
    else renoise.app():show_status( WARTING )
  end
end
--Group B
function pest_B01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B01 ( PEST_PP_B01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_B02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B02 ( PEST_PP_B02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_B03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_B03 ( PEST_PP_B03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end
--Group C
function pest_C01()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C01 ( PEST_PP_C01.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_C02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C02 ( PEST_PP_C02.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end

function pest_C03()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_C03 ( PEST_PP_C03.value )
    renoise.app():show_status( STATUS )
    else renoise.app():show_status( WARTING )
  end
end


--------------------------------------------------------------------------------
-- PRINCIPAL POPUPS
--------------------------------------------------------------------------------
--Group A
PEST_PP_A01 = vb:popup { id = 'PEST_PP_A01', width = 199, height = 24, value = 1, items = {
    ' ORCHESTRA INSTRUMENTS ↷',
    '  Strings ↷',
    '     01. Solo String',
    '     02. Violins',
    '     03. First Violins',
    '     04. Second Violins',
    '     05. Violas',
    '     06. Cellos',
    '     07. Basses',
    '  Woodwinds ↷',
    '     01. Solo Woodwind',
    '     02. Flute',
    '     03. Oboe',
    '     04. Piccolo',
    '     05. English Horn',
    '     06. Bass Clarinet',
    '     07. Clarinet',
    '     08. Contrabasson',
    '     09. Basson',
    '     10. Bagpipe',
    '     11. Shakuhachi',
    '     12. Cornet',
    '     13. Harmonica',
    '  Brass ↷',
    '     01. Solo Brass',
    '     02. Trumpets',
    '     03. Trombones',
    '     04. Tuba',
    '     05. French Horns',
    '     06. Saxophone',
    '  Keyboards ↷',
    '     01. Harp',
    '     02. Piano',
    '     03. Synthesizer',
    '     04. Organ',
    '     05. Harpsichord',
    '     06. Celesta',
    '     07. Accordion',
    '  Voices ↷',
    '     01. Soloist',
    '     02. Soprano',
    '     03. Mezzo-Soprano',
    '     04. Alto (Voice)',
    '     05. Countertenor',
    '     06. Tenor',
    '     07. Baritone',
    '     08. Bass (Voice)',
    '  Chorus ↷',
    '     01. Mixed Voices',
    '     02. Women Voices',
    '     03. Men Voices',
    '     04. Children Voices',
    '  Percussion ↷',
    '     01. Tubular Bells',
    '     02. Vibraphone',
    '     03. Xylophone',
    '     04. Glockenspiel',
    '     05. Marimba',
    '     06. Hammer',
    '     07. Triangle',
    '     08. Chimes',
    '     09. Maracas',
    '     10. Castanets',
    '     11. Wooden-block',
    '     12. Claves',
    '     13. Tambourine',
    '     14. Cymbals',
    '     15. Snare Drum',
    '     16. Gong',
    '     17. Timpani',
    '     18. Congas',
    '     19. Tenor Drum',
    '     20. Bass Drum'
  },
  notifier = function( popup )
    if popup == 1 or popup == 2 or popup == 10 or popup == 24 or popup == 31 or popup == 39 or popup == 48 or popup == 53 then
      vb.views['PEST_BT_A01'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_A01'].active = false
      else 
      vb.views['PEST_BT_A01'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_A01'].active = true 
    end
  end
}
PEST_PP_A02 = vb:popup { id = 'PEST_PP_A02', width = 192, height = 24, value = 1, items = {
    ' ORCHESTRA SECTIONS ↷',
    '    01. Strings Basic',
    '    02. Strings Expanded',
    '    03. Woodwinds Basic',    
    '    04. Woodwinds Expanded',
    '    05. Strings + Woodwinds',
    '    06. Brass Basic',
    '    07. Brass Expanded',
    '    08. Strings + Brass',
    '    09. Woodwinds + Brass',
    '    10. Keyboards Basic',
    '    11. Keyboards Expanded',
    '    12. Keyboards + Strings',
    '    13. Keyboards + Woodwinds',
    '    14. Keyboards + Brass',
    '    15. Strings + Pianos',
    '    16. Woodwinds + Pianos',
    '    17. Brasses + Pianos',
    '    18. Triple Piano (Panning ±20)',
    '    19. Synths + Pianos',
    '    20. Voices Basic',
    '    21. Voices Expanded',
    '    22. Chorus Basic',
    '    23. Chorus Expannded',
    '    24. Voices + Chorus',
    '    25. Percussion Basic',
    '    26. Percussion Expanded I',
    '    27. Percussion Expanded II',
    '    28. Percussion Expanded III',
    ' ORCHESTRA SECTIONS (Empty) ↷',
    '    01. Strings Group',
    '    02. Woodwinds Group',
    '    03. Brass Group',
    '    04. Keyboards Group',
    '    05. Voices Group',
    '    06. Chorus Group',
    '    07. Percussion Group',
    '    08. Orchestra Big',
    '    09. Orchestra Little'
  },
  notifier = function( popup )
    if popup == 1 or popup == 30 then
      vb.views['PEST_BT_A02'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_A02'].active = false
      else 
      vb.views['PEST_BT_A02'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_A02'].active = true 
    end
  end
} 
PEST_PP_A03 = vb:popup { id = 'PEST_PP_A03', width = 192, height = 24, value = 1, items = {
    ' SYMPHONY ORCHESTRA ↷',
    '    01. SO Big',
    '    02. SO Little',
    '    03. SO Little + Triple Piano',
    '    04. SO Little + Synths + Pianos',
  },
  notifier = function( popup )
    if popup == 1 then
      vb.views['PEST_BT_A03'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_A03'].active = false
      else 
      vb.views['PEST_BT_A03'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_A03'].active = true 
    end
  end
}

--Group B
PEST_PP_B01 = vb:popup { id = 'PEST_PP_B01', width = 199, height = 24, value = 1, items = {
    ' BAND INSTRUMENTS ↷',
    '  Voices ↷',
    '    01. Voice I ',
    '    02. Voice II',
    '    03. Voices',
    '  Guitars ↷',
    '    01. Acoustic Guitar',
    '    02. Electric Guitar I',
    '    03. Electric Guitar II',
    '    04. Bass Guitar',
    '    05. Contrabass Guitar',
    '  Keyboards ↷',
    '    01. Piano',
    '    02. Synth I',
    '    03. Synth II',
    '    04. Synth III',
    '  Drum Kit ↷',
    '    01. Bass Drum',
    '    02. Floor Tom',
    '    03. Snare Drum',
    '    04. Hanging Tombs',
    '    05. Hi-hat',
    '    06. Crash Cymbal',
    '    07. Ride Cymbal',
    '    08. Splash Cymbal',
    '    09. China Cymbal'    
  },
  notifier = function( popup )
    if popup == 1 or popup == 2 or popup == 6 or popup == 12 or popup == 17 then
      vb.views['PEST_BT_B01'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_B01'].active = false
      else 
      vb.views['PEST_BT_B01'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_B01'].active = true 
    end
  end
}  


PEST_PP_B02 = vb:popup { id = 'PEST_PP_B02', width = 192, height = 24, value = 1, items = {
    ' BAND SECTIONS ↷',
    '    01. Voices Basic',
    '    02. Voices Expanded',
    '    03. Guitars Basic',
    '    04. Guitars Expanded',
    '    05. Keyboards Basic',
    '    06. Keyboards Expanded',
    '    07. Drum Kit Basic',
    '    08. Drum Kit Expanded',
    ' BAND SECTIONS (Empty) ↷',
    '    01. Voices Group',
    '    02. Guitars Group',
    '    03. Keyboards Group',
    '    04. Drum Kit Group'
  },
  notifier = function( popup )
    if popup == 1 or popup == 10 then
      vb.views['PEST_BT_B02'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_B02'].active = false
      else 
      vb.views['PEST_BT_B02'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_B02'].active = true 
    end
  end
} 
PEST_PP_B03 = vb:popup { id = 'PEST_PP_B03', width = 192, height = 24, value = 1, items = {
    ' BAND POP/ROCK/HEAVY ↷',
    '    01. Band Big',
    '    02. Band Little'
  },
  notifier = function( popup )
    if popup == 1 then
      vb.views['PEST_BT_B03'].color = PEST_CR_BT_RD
      vb.views['PEST_BT_B03'].active = false
      else 
      vb.views['PEST_BT_B03'].color = PEST_CR_BT_BL
      vb.views['PEST_BT_B03'].active = true 
    end
  end
}

--Group C
PEST_PP_C01 = vb:popup { id = 'PEST_PP_C01', width = 199, height = 24, value = 1, items = {
    ' ELECTRONIC INSTRUMENTS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}  

PEST_PP_C02 = vb:popup { id = 'PEST_PP_C02', width = 192, height = 24, value = 1, items = {
    ' ELECTRONIC SECTIONS ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}
PEST_PP_C03 = vb:popup { id = 'PEST_PP_C03', width = 192, height = 24, value = 1, items = {
    ' ELECTRONIC/NEW AGE ↷',
    '    01. ',
    '    02. ',
    '    03. ',    
    '    04. ',
    '    05. ',
    '    06. ',
    '    07. '
  }
}


--------------------------------------------------------------------------------
-- CONFIGURE GROUP WITH UNTIL 8 TRACKS INCLUDING PROPERTIES
--------------------------------------------------------------------------------

--Matrix 16 colors (4x4)
PEST_CR_AQ_CFG = { 044,178,162 }
PEST_CR_BK_CFG = { 000,000,000 }
PEST_CR_BL_CFG = { 000,096,255 }
PEST_CR_BR_CFG = { 173,092,017 }

PEST_CR_GL_CFG = { 255,181,035 }
PEST_CR_GY_CFG = { 128,128,128 }
PEST_CR_GR_CFG = { 000,180,000 }--
PEST_CR_OR_CFG = { 255,128,000 }

PEST_CR_PL_CFG = { 255,168,227 }
PEST_CR_PN_CFG = { 255,000,170 }
PEST_CR_PS_CFG = { 128,255,149 }
PEST_CR_RD_CFG = { 255,000,000 }

PEST_CR_SK_CFG = { 000,203,255 }
PEST_CR_VL_CFG = { 140,000,255 }
PEST_CR_WH_CFG = { 255,255,255 }
PEST_CR_YL_CFG = { 255,255,000 }

PEST_BT_GR_COLOR_01 = vb:button { id = 'PEST_BT_GR_COLOR_01', color = PEST_CR_AQ_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 1 end, tooltip = 'Select aqua color.' }
PEST_BT_GR_COLOR_02 = vb:button { id = 'PEST_BT_GR_COLOR_02', color = PEST_CR_BK_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 2 end, tooltip = 'Select black color.' }
PEST_BT_GR_COLOR_03 = vb:button { id = 'PEST_BT_GR_COLOR_03', color = PEST_CR_BL_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 3 end, tooltip = 'Select blue color.' }
PEST_BT_GR_COLOR_04 = vb:button { id = 'PEST_BT_GR_COLOR_04', color = PEST_CR_BR_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 4 end, tooltip = 'Select brown color.' }
PEST_BT_GR_COLOR_05 = vb:button { id = 'PEST_BT_GR_COLOR_05', color = PEST_CR_GL_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 5 end, tooltip = 'Select gold color.' }
PEST_BT_GR_COLOR_06 = vb:button { id = 'PEST_BT_GR_COLOR_06', color = PEST_CR_GY_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 6 end, tooltip = 'Select grey color.' }
PEST_BT_GR_COLOR_07 = vb:button { id = 'PEST_BT_GR_COLOR_07', color = PEST_CR_GR_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 7 end, tooltip = 'Select green color.' }
PEST_BT_GR_COLOR_08 = vb:button { id = 'PEST_BT_GR_COLOR_08', color = PEST_CR_OR_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 8 end, tooltip = 'Select orange color.' }
PEST_BT_GR_COLOR_09 = vb:button { id = 'PEST_BT_GR_COLOR_09', color = PEST_CR_PL_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value = 9 end, tooltip = 'Select pale pink color.' }
PEST_BT_GR_COLOR_10 = vb:button { id = 'PEST_BT_GR_COLOR_10', color = PEST_CR_PN_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =10 end, tooltip = 'Select pink color.' }
PEST_BT_GR_COLOR_11 = vb:button { id = 'PEST_BT_GR_COLOR_11', color = PEST_CR_PS_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =11 end, tooltip = 'Select pistachio color.' }
PEST_BT_GR_COLOR_12 = vb:button { id = 'PEST_BT_GR_COLOR_12', color = PEST_CR_RD_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =12 end, tooltip = 'Select red color.' }
PEST_BT_GR_COLOR_13 = vb:button { id = 'PEST_BT_GR_COLOR_13', color = PEST_CR_SK_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =13 end, tooltip = 'Select sky blue color.' }
PEST_BT_GR_COLOR_14 = vb:button { id = 'PEST_BT_GR_COLOR_14', color = PEST_CR_VL_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =14 end, tooltip = 'Select violet color.' }
PEST_BT_GR_COLOR_15 = vb:button { id = 'PEST_BT_GR_COLOR_15', color = PEST_CR_WH_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =15 end, tooltip = 'Select white color.' }
PEST_BT_GR_COLOR_16 = vb:button { id = 'PEST_BT_GR_COLOR_16', color = PEST_CR_YL_CFG, width = 22, height = 13, notifier = function() vb.views['PEST_PP_GR_COLOR'].value =16 end, tooltip = 'Select yellow color.' }

PEST_BT_GR_COLORS = vb:column { id = 'PEST_BT_GR_COLORS', style = 'panel', margin = 2,
  vb:row { PEST_BT_GR_COLOR_01, PEST_BT_GR_COLOR_02, PEST_BT_GR_COLOR_03, PEST_BT_GR_COLOR_04 },
  vb:row { PEST_BT_GR_COLOR_05, PEST_BT_GR_COLOR_06, PEST_BT_GR_COLOR_07, PEST_BT_GR_COLOR_08 },
  vb:row { PEST_BT_GR_COLOR_09, PEST_BT_GR_COLOR_10, PEST_BT_GR_COLOR_11, PEST_BT_GR_COLOR_12 },
  vb:row { PEST_BT_GR_COLOR_13, PEST_BT_GR_COLOR_14, PEST_BT_GR_COLOR_15, PEST_BT_GR_COLOR_16 },
}

--Function change color of selected track
function pest_fn_change_clr( song, sti, i )
  song = renoise.song()
  sti = song.selected_track_index
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) or (song.selected_track.type == renoise.Track.TRACK_TYPE_MASTER) then
    song.tracks[ sti ].color = vb.views['PEST_BT_GR_COLOR'].color
  else
    i = vb.views['PEST_BT_TR_CONFIG'].value
    song.tracks[ sti ].color = pest_fn_select_clr_tr( i )
  end
end


--Vertical button for selected color
PEST_BT_GR_COLOR = vb:button { id = 'PEST_BT_GR_COLOR', color = PEST_CR_AQ_CFG, width = 12, height = 56, notifier = function() pest_fn_change_clr() end, tooltip = 'Selected main color to insert group with tracks.\nor\nChange color of selected track. Use the valuebox [0-8] for color gradient.' }


--Function for select specific color for group
function pest_fn_select_clr( popup ) -- ( 03 )
  if     popup == 1 then vb.views['PEST_BT_GR_COLOR'].color = { 044,178,162 }
  elseif popup == 2 then vb.views['PEST_BT_GR_COLOR'].color = { 000,000,000 }
  elseif popup == 3 then vb.views['PEST_BT_GR_COLOR'].color = { 000,096,255 }
  elseif popup == 4 then vb.views['PEST_BT_GR_COLOR'].color = { 173,092,017 }
  
  elseif popup == 5 then vb.views['PEST_BT_GR_COLOR'].color = { 255,181,035 }
  elseif popup == 6 then vb.views['PEST_BT_GR_COLOR'].color = { 128,128,128 }
  elseif popup == 7 then vb.views['PEST_BT_GR_COLOR'].color = { 000,255,000 }
  elseif popup == 8 then vb.views['PEST_BT_GR_COLOR'].color = { 255,128,000 }
  
  elseif popup == 9 then vb.views['PEST_BT_GR_COLOR'].color = { 255,168,227 }
  elseif popup ==10 then vb.views['PEST_BT_GR_COLOR'].color = { 255,000,170 }
  elseif popup ==11 then vb.views['PEST_BT_GR_COLOR'].color = { 128,255,149 }
  elseif popup ==12 then vb.views['PEST_BT_GR_COLOR'].color = { 255,000,000 }
  
  elseif popup ==13 then vb.views['PEST_BT_GR_COLOR'].color = { 000,203,255 }
  elseif popup ==14 then vb.views['PEST_BT_GR_COLOR'].color = { 140,000,255 }
  elseif popup ==15 then vb.views['PEST_BT_GR_COLOR'].color = { 255,255,255 }
  elseif popup ==16 then vb.views['PEST_BT_GR_COLOR'].color = { 255,255,000 }
  end
end


--Checkbox to insert specific group
PEST_CB_GR_INSERT = vb:vertical_aligner { mode = 'distribute',
  vb:checkbox { id = 'PEST_CB_GR_INSERT', value = true, tooltip = 'Include group parent for all tracks.',
    notifier = function()
      if vb.views['PEST_CB_GR_INSERT'].value == false and vb.views['PEST_BT_TR_CONFIG'].value == 0 then
        vb.views['PEST_BT_GR_CONFIG'].color = { 0x40,0x00,0x00 }
        vb.views['PEST_BT_GR_CONFIG'].active = false
      else
        vb.views['PEST_BT_GR_CONFIG'].color = { 0x00,0x40,0x70 }
        vb.views['PEST_BT_GR_CONFIG'].active = true
      end
    end
  }
}

--Textfield for change the name of group
PEST_TF_GR_CONFIG = vb:textfield { id ='PEST_TF_GR_CONFIG', align = 'center', width = 157, height = 22, 
  text ='GROUP', notifier = function() group.config.name = vb.views['PEST_TF_GR_CONFIG'].text end, tooltip = 'Rename specific group with tracks son to insert.'
}

--Textfield for change the name of son tracks
PEST_TF_TR_CONFIG = vb:textfield { id ='PEST_TF_TR_CONFIG', align = 'center', width = 125, height = 22, 
  text ='Track', notifier = function() track.config.name = vb.views['PEST_TF_TR_CONFIG'].text end, tooltip = 'Rename specific tracks son to insert.'
}

--Checkbox to insert tracks inside empty group
PEST_CB_EMPTY_GR_INSERT = vb:vertical_aligner { mode = 'distribute',
  vb:checkbox { id = 'PEST_CB_EMPTY_GR_INSERT', value = true, tooltip = 'Insert tracks inside empty group parent.'
  }
}

--Insert specific group
group.config = { name = ""..vb.views['PEST_TF_GR_CONFIG'].text.."" , color = PEST_CR_AQ_CFG, color_blend = 30 }

function pest_fn_in_sp_gr( sti , group_setting )
  local song = renoise.song()
  local sti = song.selected_track_index + 1
  song:insert_group_at( sti )
  for parameter_name , parameter_value in pairs( group_setting ) do
    song:track( sti )[ parameter_name ] = parameter_value
  end
end


--Insert track with specific characteristics
track.config = { name = ""..vb.views['PEST_TF_TR_CONFIG'].text.."" , color_blend = 15 }

function pest_fn_in_sp_tr( sti , track_setting )
  local song = renoise.song()
  local sti = song.selected_track_index + 1
  song:insert_track_at( sti ) --insert a track
  local tr = song:track( sti ) --define "tr"
  tr.visible_note_columns, tr.volume_column_visible, tr.panning_column_visible, tr.delay_column_visible, tr.sample_effects_column_visible, tr.visible_effect_columns = 1, T, F, F, F, 0  --config global parameters tr (checkboxes)
  for parameter_name, parameter_value in pairs( track_setting ) do -- config specific parameters tr ( name, color, color_blend )
    song:track( sti )[ parameter_name ] = parameter_value
  end
  local column_names = { 'Note 01' , 'Note 02' , 'Note 03' , 'Note 04' , 'Note 05' , 'Note 06' , 'Note 07' , 'Note 08' , 'Note 09' , 'Note 10' , 'Note 11' , 'Note 12' }
  for note_column = 1 , 12 do
    tr:set_column_name( note_column , column_names[ note_column ] )
  end
end 


--Hidden Popup for select specific color of group
PEST_PP_GR_COLOR = vb:popup { id = 'PEST_PP_GR_COLOR', width = 50, height = 22, value = 1, tooltip = 'List of main colors.',
  notifier = function (popup) pest_fn_select_clr(popup) group.config.color = vb.views['PEST_BT_GR_COLOR'].color end,
  items = {' AQ',' BK',' BL',' BR',' GL',' GY',' GR',' OR',' PL',' PN',' PS',' RD',' SK',' VL',' WH',' YL', }
} 

--Select number of son tracks
PEST_BT_TR_CONFIG = vb:valuebox { id = 'PEST_BT_TR_CONFIG', width = 50, height = 22, min = 0, max = 8, value = 2,
  tooltip = "Number of tracks son to insert.\n[Range = 0 to 8]\n Value '0' only insert a group parent if checkbox is enabled.",
  notifier = function()
    if vb.views['PEST_CB_GR_INSERT'].value == false and vb.views['PEST_BT_TR_CONFIG'].value == 0 then
      vb.views['PEST_BT_GR_CONFIG'].color = { 0x40,0x00,0x00 }
      vb.views['PEST_BT_GR_CONFIG'].active = false
    else
      vb.views['PEST_BT_GR_CONFIG'].color = { 0x00,0x40,0x70 }
      vb.views['PEST_BT_GR_CONFIG'].active = true
    end
  end
}

--Select color track (gradient color)
function pest_fn_select_clr_tr( i )
      if vb.views['PEST_PP_GR_COLOR'].value == 1 then return { 044-05*i, 178-18*i, 162-18*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 2 then return { 000+10*i, 000+10*i, 000+10*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 3 then return { 000-00*i, 096-11*i, 255-24*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 4 then return { 173-10*i, 092-11*i, 017-02*i }
  
  elseif vb.views['PEST_PP_GR_COLOR'].value == 5 then return { 255-24*i, 181-16*i, 035-03*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 6 then return { 128-12*i, 128-12*i, 128-12*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 7 then return { 000-00*i, 255-26*i, 000-00*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value == 8 then return { 255-22*i, 128-12*i, 000-00*i }
  
  elseif vb.views['PEST_PP_GR_COLOR'].value == 9 then return { 255-26*i, 168-17*i, 227-23*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==10 then return { 255-26*i, 000-00*i, 170-17*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==11 then return { 128-09*i, 255-25*i, 149-16*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==12 then return { 255-26*i, 000-00*i, 000-00*i }
  
  elseif vb.views['PEST_PP_GR_COLOR'].value ==13 then return { 000-00*i, 203-20*i, 255-25*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==14 then return { 140-12*i, 000-00*i, 255-26*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==15 then return { 255-22*i, 255-22*i, 255-22*i }
  elseif vb.views['PEST_PP_GR_COLOR'].value ==16 then return { 255-26*i, 255-26*i, 000-00*i }
  end
end

--Insert group parent and tracks son with gradient color
function pest_fn_in_tr_gr( song, sti, n )
  song = renoise.song()
  sti = song.selected_track_index + 1
  n = vb.views['PEST_BT_TR_CONFIG'].value
    pest_fn_in_sp_gr( sti, group.config )
  for i = 1, n do --n<=8
    pest_fn_in_sp_tr(sti, track.config)
    song:track(sti).name = ""..track.config.name.." "..i.."" --name track for iterate
    song:track(sti).color = pest_fn_select_clr_tr( i ) --color track for iterate
    song:add_track_to_group( sti, sti + i )
  end
  song.selected_track_index = sti + n
  if vb.views['PEST_CB_GR_INSERT'].value == true then
    if vb.views['PEST_BT_TR_CONFIG'].value > 0 then
      coll_gr()
    end
  else
    song:delete_track_at( song.selected_track_index )
    if vb.views['PEST_CB_EMPTY_GR_INSERT'].value == true then
      if song.tracks[ sti - 1 ].type == renoise.Track.TRACK_TYPE_GROUP then
        if #song.tracks[ sti - 1 ].members == 0 then
          for i = 1, n do
            song:add_track_to_group( sti - 1 + i, sti - 2 + i )
          end
          coll_gr()
          song.selected_track_index = song.selected_track_index - 1
        end
      end
    end
  end
end

--Button insert
function pest_fn_bt_in()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
    pest_fn_in_tr_gr()
    renoise.app():show_status( STATUS2 )
    else renoise.app():show_status( WARTING )
  end
end

PEST_BT_GR_CONFIG = vb:button {
  id = 'PEST_BT_GR_CONFIG',
  tooltip = 'Insert specific Group',
  text = '+',
  color = { 0x00,0x40,0x70 },
  width = 22,
  height = 22,
  notifier = function() pest_fn_bt_in() end
}  



--------------------------------------------------------------------------------
-- PRINCIPAL BUTTONS
--------------------------------------------------------------------------------
--Red
  PEST_CR_BT_RD = { 0x40,0x00,0x00 }
--Blue
  PEST_CR_BT_BL = { 0x00,0x40,0x70 }

--Group A
PEST_BT_A01 = vb:button {
  id = 'PEST_BT_A01',
  tooltip = 'Insert A01',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_A01() end
}
PEST_BT_A02 = vb:button {
  id = 'PEST_BT_A02',
  tooltip = 'Insert A02',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_A02() end
}
PEST_BT_A03 = vb:button {
  id = 'PEST_BT_A03',
  tooltip = 'Insert A03',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_A03() end
}

--Group B
PEST_BT_B01 = vb:button {
  id = 'PEST_BT_B01',
  tooltip = 'Insert B01',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_B01() end
}
PEST_BT_B02 = vb:button {
  id = 'PEST_BT_B02',
  tooltip = 'Insert B02',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_B02() end
}
PEST_BT_B03 = vb:button {
  id = 'PEST_BT_B03',
  tooltip = 'Insert B03',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_B03() end
}

--Group C
PEST_BT_C01 = vb:button {
  id = 'PEST_BT_C01',
  tooltip = 'Insert C01',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_C01() end
}
PEST_BT_C02 = vb:button {
  id = 'PEST_BT_C02',
  tooltip = 'Insert C02',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_C02() end
}
PEST_BT_C03 = vb:button {
  id = 'PEST_BT_C03',
  tooltip = 'Insert C03',
  text = '+',
  color = PEST_CR_BT_RD,
  active = false,
  width = 24,
  height = 24,
  notifier = function()pest_C03() end
}


--------------------------------------------------------------------------------
-- GUI PEST TOOL
--------------------------------------------------------------------------------
PEST =
vb:column {
  vb:horizontal_aligner {
    width = 678,
    mode = 'right',
    vb:bitmap {
      bitmap = 'icons/pattern-editor-ico.bmp',
      mode = 'body_color',
      height = 22
    },
    vb:text { font = 'bold', text = 'PEST: Pattern Editor Specific Templates', height = 22 },
    vb:text { text = '   v1.0b', height = 22 },
    vb:horizontal_aligner { width = 20 },
    PEST_BT_EXPAND_PATT_EDITOR,
    vb:horizontal_aligner { width = 5 },
    PEST_CB_JUMP,
    PEST_TEXTFIELD_RENAME,
    vb:bitmap { bitmap = 'icons/label-tr-ico.bmp', mode = 'body_color', height = 22, tooltip = 'Name of Track.' },
    vb:horizontal_aligner { width = 5 },
    PEST_BT_CLONE_TRACK,
    vb:horizontal_aligner { width = 5 },
    DEFAULT_PEST_PARAM
  },
  vb:horizontal_aligner { height = 4 },
    vb:column {
      style = 'panel',
      margin = 5,
    vb:horizontal_aligner {
      vb:horizontal_aligner {
        mode = 'center',
        width = 185,
        vb:text { text = 'Individual Instruments' }
      },
      vb:horizontal_aligner {
        mode = 'center',
        width = 265,
        vb:text { text = 'Instruments Sections' }
      },
      vb:horizontal_aligner {
        mode = 'center',
        width = 185,
        vb:text { text = 'Templates Styles' }
      }
    },
    vb:horizontal_aligner {
      PEST_PP_A01, PEST_BT_A01,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_A02, PEST_BT_A02,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_A03, PEST_BT_A03
    },
    --- ---
    vb:horizontal_aligner { height = 4 },
    vb:horizontal_aligner {
      PEST_PP_B01, PEST_BT_B01,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_B02, PEST_BT_B02,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_B03, PEST_BT_B03
    },
    --- ---
    vb:horizontal_aligner { height = 4 },
    vb:horizontal_aligner {
      PEST_PP_C01, PEST_BT_C01,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_C02, PEST_BT_C02,
      vb:horizontal_aligner { width = 6 },
      PEST_PP_C03, PEST_BT_C03
    }
  },
  --- ---
  vb:horizontal_aligner { height = 4 },
  vb:horizontal_aligner {
    vb:column {
      style = 'panel',
      margin = 6,
      vb:horizontal_aligner {
        PEST_BT_GR_COLORS,
        vb:horizontal_aligner { width = 4 },
        PEST_BT_GR_COLOR,
        vb:horizontal_aligner { width = 4 },
        vb:column {
          vb:horizontal_aligner { height = 2 },
          vb:row {
            --PEST_PP_GR_COLOR,
            PEST_CB_GR_INSERT,
            PEST_TF_GR_CONFIG,
            vb:bitmap { bitmap = 'icons/label-gr-ico.bmp', mode = 'body_color', height = 22, tooltip = 'Name of group parent.' },
            vb:horizontal_aligner { width = 4 },
            PEST_BT_GR_CONFIG
          },
          vb:horizontal_aligner { height = 7 },
          vb:row {
            PEST_BT_TR_CONFIG,
            PEST_TF_TR_CONFIG,
            vb:bitmap { bitmap = 'icons/label-tr-ico.bmp', mode = 'body_color', height = 22, tooltip = 'Name of tracks son.' },
            vb:horizontal_aligner { width = 6 },
            PEST_CB_EMPTY_GR_INSERT
          }
        }
      }
    },
    vb:horizontal_aligner { width = 6 },
    vb:column {
      vb:column {
        style = 'panel',
        margin = 5,
        vb:row {
          vb:bitmap { bitmap = 'icons/nt-ico.bmp', mode = 'body_color', height = 22 },
          VALUEBOX_PEST_TRNTC,
          vb:horizontal_aligner { width = 4 },
          vb:bitmap { bitmap = 'icons/columns-ico.bmp', mode = 'body_color', height = 22 },
          BUTTONCHECK_PEST_TRVOL,
          BUTTONCHECK_PEST_TRPAN,
          BUTTONCHECK_PEST_TRDLY,
          BUTTONCHECK_PEST_TRSFX,
          vb:horizontal_aligner { width = 4 },
          VALUEBOX_PEST_TRFXT,
          vb:bitmap { bitmap = 'icons/fx-ico.bmp', mode = 'body_color', height = 22 }
        }
      },
      vb:horizontal_aligner { height = 4 },
      vb:column {
        style = 'panel',
        margin = 5,
        vb:row {
          vb:bitmap { bitmap = 'icons/cblend-ico.bmp', mode = 'body_color', height = 22 },
          PEST_VB_CBLEND_TRACK,
          PEST_VB_CBLEND_SGROUP,
          PEST_VB_CBLEND_GROUP,
          vb:horizontal_aligner { width = 4 },
          PEST_CB_RTIME,
          PEST_BT_CBLEND
        }
      }
    }
  }
}
