--------------------------------------------------------------------------------
-- Module Tool: Tool_02.lua
-- Name: PMSS: Pattern Matrix Specific Sequencer
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- OBSERVABLE
--------------------------------------------------------------------------------
function section_name( song )
  song = renoise.song()
  local function name()
    if song.sequencer:sequence_section_name( song.selected_sequence_index ) ~= 'Untitled Section' then -- avoid default rename 'Untitled Section'
      vb.views['PMSS_TF_SEC'].text = ( "%s" ):format( song.sequencer:sequence_section_name( song.selected_sequence_index ) ) -- vb.views name section (renoise --> tool)
    end
    vb.views['PMSS_TF_PATT'].text = ( "%s" ):format( song.patterns[ song.sequencer.pattern_sequence[song.selected_sequence_index] ].name ) -- vb.views name pattern (renoise --> tool)
  --vb.views['PMSS_TF_PATT'].text = ( "%s" ):format( song.patterns[ song.selected_sequence_index ].name ) --incorrect put "pattern index", the correct is the "sequence index"!!!
    vb.views['PMSS_TX_NUM'].text = ( "%s" ):format( song.selected_sequence_index ) --vb.views number pattern sequence (renoise --> tool)
  end
  song.selected_sequence_index_observable:add_notifier( name ) -- _observable notifier selected pattern
  song.patterns[ song.sequencer.pattern_sequence[song.selected_sequence_index] ].name_observable:add_notifier( name ) -- _observable name pattern (renoise --> tool)
  song.sequencer:sequence_section_name_observable(song.selected_sequence_index):add_notifier( name ) -- _observable name section (renoise --> tool)
end
renoise.tool().app_new_document_observable:add_notifier( section_name ) -- document_observable function


--------------------------------------------------------------------------------
-- INSERT AND CLONE
--------------------------------------------------------------------------------

------------------------------------------
---- Functions
------------------------------------------
--Number of Lines
function pmss_number_of_lines( song, i )
  song = renoise.song()
  if vb.views['PMSS_CB_NO_LINES'].value == true then
    local pattern = song:pattern( song.selected_sequence_index )    
    pattern.number_of_lines = vb.views['PMSS_VB_NO_LINES'].value --96
  end
end

--Insert sequence
function pmss_insert_sequence( song, sid, section_name, i, m, n )
  song = renoise.song()
  m = vb.views['PMSS_VB_MULTIPLY'].value --value of multiplier
  n = vb.views['PMSS_VB_NUMBER'].value --value of number
  for i = 1, m do  
    sid = song.selected_sequence_index
    if vb.views['PMSS_CB_SECTION'].value == true then --include name of section
      section_name = vb.views['PMSS_TF_SEC'].text
      song.sequencer:set_sequence_is_start_of_section( sid, true ) --start of section
      song.sequencer:set_sequence_section_name(sid, section_name ) --name of section
      else
    end
    if #song.sequencer.pattern_sequence + m * n <= 1000 then --limit for 1000 patterns
      for i = 1, n do --number of patterns for section
        i = sid + 1
        song.sequencer:insert_new_pattern_at( i ) --insert 'n' patterns
        song.selected_sequence_index = song.selected_sequence_index + 1 -- #song.sequencer.pattern_sequence --jump last sequence
        pmss_number_of_lines()
      end
      else
      renoise.app():show_status( "GT16-Colors PMSS:  only support until 1000 patterns. Reduce the operation to insert patterns & do not exceed the limit!" )
    end
  end
  song.sequencer:sort() --sort sequence
  if vb.views['PMSS_VB_NUMBER'].value == 0 then --Number of Lines in selected pattern
    pmss_number_of_lines()
  end
end

--Clone sequence
function pmss_clone_sequence( song, sid, m, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  m = vb.views['PMSS_VB_MULTIPLY_2'].value --value of multiplier_2
  n = vb.views['PMSS_VB_NUMBER_2'].value --value of number_2
  if #song.sequencer.pattern_sequence + m * n <= 1000 then --limit for 1000 patterns
    if sid >= n then
      for i = 1, m do
        i = i + 1
        song.sequencer:clone_range( sid , sid - n + 1 )
      end
      song.selected_sequence_index = sid + n * m
      song.sequencer:sort() --sort sequence
      renoise.app():show_status( 'GT16-Colors, AMIC:  previous '..n..' patterns cloned.' )
      else
      renoise.app():show_status( '⚠ GT16-Colors, AMIC:  please, select the last block pattern to clone x'..n..'!' )
    end
    else
      renoise.app():show_status( "GT16-Colors PMSS:  only support until 1000 patterns. Reduce the operation to clone patterns & do not exceed the limit!" )
  end
end

--Total Insert Patterns
function pmss_fn_total()
  vb.views['PMSS_BT_INSERT'].text = 'Insert\nSequence!\n('.. vb.views['PMSS_VB_MULTIPLY'].value * vb.views['PMSS_VB_NUMBER'].value..')'
end

--Total Clone Patterns
function pmss_fn_total_2()
  vb.views['PMSS_BT_CLONE'].text = 'Clone\nSequence!\n('.. vb.views['PMSS_VB_MULTIPLY_2'].value * vb.views['PMSS_VB_NUMBER_2'].value..')'
end


--Show/Hide Matrix Pattern
function pmss_fn_open_matrix( app )
  app = renoise.app()
  if app.window.pattern_matrix_is_visible == false then
    app.window.pattern_matrix_is_visible = true
    else
    app.window.pattern_matrix_is_visible = false
  end
end

--Name of pattern
function pmss_fn_name_patt( song, ssi, sps, name, play_mode )
  song = renoise.song()
  ssi = song.selected_sequence_index
  sps = song.sequencer.pattern_sequence[ song.selected_sequence_index ]
  name = song.patterns[ sps ].name
  --print( 'name: ', name )
  song.patterns[ sps ].name = vb.views['PMSS_TF_PATT'].text
  if name ~= song.patterns[ sps ].name then
    if song.transport.playing == false then
      if ssi < #song.sequencer.pattern_sequence then
        song.selected_sequence_index = ssi + 1
      end
    end
  end  
end

--Sort Sequence of Patterns
function pmss_fn_sort( song )
  song = renoise.song()
  for i = 1, #song.sequencer.pattern_sequence do --#song.patterns do
    --print ("i: ", i)
    song.selected_sequence_index = i
    song.selected_pattern_index = song.selected_sequence_index
  end
end

--Default Values
function pmss_fn_default()
  vb.views['PMSS_VB_NUMBER'].value = 4    vb.views['PMSS_VB_NUMBER_2'].value = 4
  vb.views['PMSS_VB_MULTIPLY'].value = 1  vb.views['PMSS_VB_MULTIPLY_2'].value = 1
  vb.views['PMSS_PP_SECTION'].value = 1
  vb.views['PMSS_VB_NO_LINES'].value = 96
  vb.views['PMSS_CB_SECTION'].value = true
  vb.views['PMSS_CB_NO_LINES'].value = false
  vb.views['PMSS_TF_SEC'].text = 'Name of Section.'
  vb.views['PMSS_TF_PATT'].text = 'Name of Pattern.'
  vb.views['PMSS_VB_JUMP'].value = 0
end

--Delete Unused Patterns (liberate the hidden patterns already used) = Edit/Delete Unused Patters
function pmss_fn_del_unused( song, indices, min, max, patt )
  song = renoise.song()
  indices, min, max = {}
  for i = 1,#song.sequencer.pattern_sequence do
    table.insert( indices, song.sequencer.pattern_sequence[ i ] )
  end
  for i = 1,#song.patterns do
    if not table.find( indices, i ) then
      --print( "clear this pattern:", i )
      patt = song.patterns[ i ]
      if patt and not patt.is_empty then
        patt:clear()
      end
    end
  end
  song.sequencer:sort() --sort sequence
end

--Name of section through 'number' (insert)
function pmss_fn_number( value, m, n )
  m = vb.views['PMSS_VB_MULTIPLY'].value --value of multiplier
  n = vb.views['PMSS_VB_NUMBER'].value --value of number
  value = vb.views['PMSS_VB_NUMBER'].value
  if value == 0 then
    vb.views['PMSS_TF_SEC'].text = "'00' only change name of section!"
  end
  if value >= 1 then
    vb.views['PMSS_TF_SEC'].text = 'SECTION x'..value..' Patterns'
  end
end

--Name of section through 'number' (clone)
function pmss_fn_number_2( song, sid, m, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  m = vb.views['PMSS_VB_MULTIPLY_2'].value --value of multiplier
  n = vb.views['PMSS_VB_NUMBER_2'].value --value of number
  if (song.selected_sequence_index <= 16 and n <= #song.sequencer.pattern_sequence ) then
  song.selected_sequence_index = n
  end
end


--Name of section through 'label'
function pmss_fn_section( value )
  value = vb.views['PMSS_PP_SECTION'].value
  if value == 1 then vb.views['PMSS_TF_SEC'].text = 'START SONG' end
  if value == 2 then vb.views['PMSS_TF_SEC'].text = 'INTRODUCTION' end
  if value == 3 then vb.views['PMSS_TF_SEC'].text = 'CLOSING' end
  if value == 4 then vb.views['PMSS_TF_SEC'].text = 'END SOUND' end
  if value == 5 then vb.views['PMSS_TF_SEC'].text = 'MAIN THEME' end
  if value == 6 then vb.views['PMSS_TF_SEC'].text = 'SECONDARY THEME' end
  if value == 7 then vb.views['PMSS_TF_SEC'].text = 'TERTIARY THEME' end
  if value == 8 then vb.views['PMSS_TF_SEC'].text = 'ALTERNATIVE THEME' end
  if value == 9 then vb.views['PMSS_TF_SEC'].text = 'CHANGE OF COMPASS' end
  if value ==10 then vb.views['PMSS_TF_SEC'].text = 'MARKER' end
  if value ==11 then vb.views['PMSS_TF_SEC'].text = 'REPEAT' end
  if value ==12 then vb.views['PMSS_TF_SEC'].text = 'CRESCENT' end
  if value ==13 then vb.views['PMSS_TF_SEC'].text = 'DECREASING' end
  if value ==14 then vb.views['PMSS_TF_SEC'].text = 'CALM' end
  if value ==15 then vb.views['PMSS_TF_SEC'].text = 'FORCE' end
  if value ==16 then vb.views['PMSS_TF_SEC'].text = 'VERSE' end
  if value ==17 then vb.views['PMSS_TF_SEC'].text = 'CHORUS' end
  if value ==18 then vb.views['PMSS_TF_SEC'].text = 'BRIDGE' end
  if value ==19 then vb.views['PMSS_TF_SEC'].text = 'FUSION' end
  if value ==20 then vb.views['PMSS_TF_SEC'].text = 'JUMP' end
  if value ==21 then vb.views['PMSS_TF_SEC'].text = 'CUT' end
  if value ==22 then vb.views['PMSS_TF_SEC'].text = '' end
end


------------------------------------------
---- Objects
------------------------------------------
--Show/Hide Matrix Pattern
PMSS_BT_MATRIX = vb:button { id = 'PMSS_BT_MATRIX', width = 30, height = 22, color = { 0x70,0x20,0xB0 }, bitmap = 'icons/show-matrix-ico.bmp', notifier = function() pmss_fn_open_matrix() end,
  tooltip = 'Show/Hide the Pattern Matrix Pane'
}

--Number sequence
PMSS_TX_NUM = vb:column { style = 'panel', tooltip = 'Number ordered pattern sequence',
  vb:text { id = 'PMSS_TX_NUM', width = 30, height = 22, text = '000', font = 'bold', align = 'center' }
}

--Name of Pattern
PMSS_TF_PATT = vb:textfield { id = 'PMSS_TF_PATT', width = 166, height = 22, text = 'Name of Pattern.', align = 'center', notifier = function() pmss_fn_name_patt() end, tooltip = 'Modify the Name of Pattern manually.' }

--Button Default
PMSS_BT_DEFAULT =
  vb:button { id = 'PMSS_BT_DEFAULT', width = 30, height = 22, color = { 0x00,0x20,0x50 }, text = 'DF', notifier = function() pmss_fn_default() end,
  tooltip = 'Default Values.\n[Number = 4], both\n[Multiplier = 1], both\n[Label = First, enabled]\n[Number of Lines = 96, disabled]\n[Jump = 0]' }

PMSS_BT_SORT = vb:horizontal_aligner { width = 55, mode = 'right',
  vb:button { id = 'PMSS_BT_SORT', width = 45, height = 22, color = { 0x60,0x20,0x00 }, text = 'SORT', notifier = function() pmss_fn_sort() end,
  tooltip = 'Sort sequence of patterns.\n[number of pattern (right) = number of sequence (left)]' }
}

--Number (Insert)
PMSS_VB_NUMBER = vb:valuebox { id = 'PMSS_VB_NUMBER', width = 54, height = 22, min = 0, max = 16, value = 4,
  notifier = function() pmss_fn_number() pmss_fn_total() end, tooltip ="Number of patterns for the section to insert.\n[Range = 0-16. Default Value = 4]\n'00' Value only change the name of section, does not insert patterns!"
}
PMSS_BT_02 = vb:button { id = 'PMSS_BT_02', width = 26, height = 22, text = '2', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 2 end, tooltip = '2 Patterns.' }
PMSS_BT_04 = vb:button { id = 'PMSS_BT_04', width = 26, height = 22, text = '4', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 4 end, tooltip = '4 Patterns.' }
PMSS_BT_06 = vb:button { id = 'PMSS_BT_06', width = 26, height = 22, text = '6', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 6 end, tooltip = '6 Patterns.' }
PMSS_BT_08 = vb:button { id = 'PMSS_BT_08', width = 26, height = 22, text = '8', notifier = function() vb.views['PMSS_VB_NUMBER'].value = 8 end, tooltip = '8 Patterns.' }

--Name of Section (Label)
PMSS_PP_SECTION = vb:popup { id = 'PMSS_PP_SECTION', width = 124, height = 22, value = 1, notifier = function() pmss_fn_section() end, tooltip = 'Select a predefined name of section.',
  items = { ' Start Song',' Introduction',' Closing',' End Sound',' Main Theme',' Secondary Theme',' Tertiary Theme',' Alternative Theme',' Change of Compass',
            ' Marker',' Repeat',' Crescent',' Decreasing',' Calm',' Force',' Verse',' Chorus',' Bridge',' Fusion',' Jump', ' Cut', ' * Empty'
  }
}
PMSS_CB_SECTION = vb:vertical_aligner { mode = 'distribute', vb:checkbox { id = 'PMSS_CB_SECTION', value = true, tooltip = 'Enable/disable the insertion of the Name of Section.\n[Default = Enabled]' } }
PMSS_TF_SEC = vb:textfield { id = 'PMSS_TF_SEC', width = 166, height = 22, text = 'Name of Section.', align = 'center', tooltip = 'Modify the Name of Section manually.' }

--Multiplier
PMSS_VB_MULTIPLY = vb:valuebox { id = 'PMSS_VB_MULTIPLY', width = 54, height = 22, min = 1, max = 16, value = 1, notifier = function() pmss_fn_total() end, tooltip = 'Multiplier for section.\n[Range = x1-x16. Default Value = x1]' }
PMSS_BT_X02 = vb:button { id = 'PMSS_BT_X02', width = 32, height = 22, text = 'x2', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 2 end, tooltip = 'Multiplier = x2.' }
PMSS_BT_X04 = vb:button { id = 'PMSS_BT_X04', width = 32, height = 22, text = 'x4', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 4 end, tooltip = 'Multiplier = x4.' }
PMSS_BT_X06 = vb:button { id = 'PMSS_BT_X06', width = 32, height = 22, text = 'x6', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 6 end, tooltip = 'Multiplier = x6.' }
PMSS_BT_X08 = vb:button { id = 'PMSS_BT_X08', width = 32, height = 22, text = 'x8', notifier = function() vb.views['PMSS_VB_MULTIPLY'].value = 8 end, tooltip = 'Multiplier = x8.' }
PMSS_BT_X10 = vb:button { id = 'PMSS_BT_X10', width = 32, height = 22, text ='x10' ,notifier = function() vb.views['PMSS_VB_MULTIPLY'].value =10 end, tooltip = 'Multiplier = x10.' }
PMSS_BT_X12 = vb:button { id = 'PMSS_BT_X12', width = 32, height = 22, text ='x12' ,notifier = function() vb.views['PMSS_VB_MULTIPLY'].value =12 end, tooltip = 'Multiplier = x12.' }

--Number of Lines
PMSS_CB_NO_LINES = vb:vertical_aligner { mode = 'distribute', vb:checkbox { id = 'PMSS_CB_NO_LINES', value = false, tooltip = 'Enable/disable the Number of Lines per pattern.\n[Default = Disabled]' } }
PMSS_VB_NO_LINES = vb:valuebox { id = 'PMSS_VB_NO_LINES', width = 54, height = 22, min = 1, max = 512, value = 96, notifier = function() end, tooltip = 'Number of Lines per pattern.\n[Rangue = 1-512. Default Value = 96]' }

--Button Insert
PMSS_BT_INSERT = vb:horizontal_aligner { width = 73, mode = 'right',
  vb:button { id = 'PMSS_BT_INSERT', width = 70, height = 54, color = { 0x00,0x40,0x70 }, text = 'Insert\nSequence!\n(patterns)', notifier = function() pmss_fn_del_unused() pmss_insert_sequence() end, tooltip = "Insert selected Secuence or modify the Name of Section or change the Number of Lines.\nThis operation include the 'Delete Unused Patterns'." }
}

--Number_2 (Clone)
PMSS_VB_NUMBER_2 = vb:valuebox { id = 'PMSS_VB_NUMBER_2', width = 54, height = 22, min = 1, max = 16, value = 4,
  notifier = function() pmss_fn_number_2() pmss_fn_total_2() end, tooltip ="Number of patterns for the section to clone.\n[Range = 1-16. Default Value = 4]"
}
PMSS_BT_02_2 = vb:button { id = 'PMSS_BT_02_2', width = 26, height = 22, text = '2', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value = 2 end, tooltip = '2 Patterns.' }
PMSS_BT_04_2 = vb:button { id = 'PMSS_BT_04_2', width = 26, height = 22, text = '4', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value = 4 end, tooltip = '4 Patterns.' }
PMSS_BT_06_2 = vb:button { id = 'PMSS_BT_06_2', width = 26, height = 22, text = '6', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value = 6 end, tooltip = '6 Patterns.' }
PMSS_BT_08_2 = vb:button { id = 'PMSS_BT_08_2', width = 26, height = 22, text = '8', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value = 8 end, tooltip = '8 Patterns.' }
PMSS_BT_10_2 = vb:button { id = 'PMSS_BT_10_2', width = 26, height = 22, text ='10', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value =10 end, tooltip = '10 Patterns.' }
PMSS_BT_12_2 = vb:button { id = 'PMSS_BT_12_2', width = 26, height = 22, text ='12', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value =12 end, tooltip = '12 Patterns.' }
PMSS_BT_14_2 = vb:button { id = 'PMSS_BT_14_2', width = 26, height = 22, text ='14', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value =14 end, tooltip = '14 Patterns.' }
PMSS_BT_16_2 = vb:button { id = 'PMSS_BT_16_2', width = 26, height = 22, text ='16', notifier = function() vb.views['PMSS_VB_NUMBER_2'].value =16 end, tooltip = '16 Patterns.' }

--Multiplier_2
PMSS_VB_MULTIPLY_2 = vb:valuebox { id = 'PMSS_VB_MULTIPLY_2', width = 54, height = 22, min = 1, max = 16, value = 1, notifier = function() pmss_fn_total_2() end, tooltip = 'Multiplier for clone.\n[Range = x1-x16. Default Value = x1]' }
PMSS_BT_X02_2 = vb:button { id = 'PMSS_BT_X02_2', width = 32, height = 22, text = 'x2', notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value = 2 end, tooltip = 'Multiplier = x2.' }
PMSS_BT_X04_2 = vb:button { id = 'PMSS_BT_X04_2', width = 32, height = 22, text = 'x4', notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value = 4 end, tooltip = 'Multiplier = x4.' }
PMSS_BT_X06_2 = vb:button { id = 'PMSS_BT_X06_2', width = 32, height = 22, text = 'x6', notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value = 6 end, tooltip = 'Multiplier = x6.' }
PMSS_BT_X08_2 = vb:button { id = 'PMSS_BT_X08_2', width = 32, height = 22, text = 'x8', notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value = 8 end, tooltip = 'Multiplier = x8.' }
PMSS_BT_X10_2 = vb:button { id = 'PMSS_BT_X10_2', width = 32, height = 22, text ='x10' ,notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value =10 end, tooltip = 'Multiplier = x10.' }
PMSS_BT_X12_2 = vb:button { id = 'PMSS_BT_X12_2', width = 32, height = 22, text ='x12' ,notifier = function() vb.views['PMSS_VB_MULTIPLY_2'].value =12 end, tooltip = 'Multiplier = x12.' }

--Button Clone
PMSS_BT_CLONE = vb:horizontal_aligner { width = 73, mode = 'right',
  vb:button { id = 'PMSS_BT_CLONE', width = 70, height = 54, color = { 0x00,0x40,0x70 }, text = 'Clone\nSequence!\n(patterns)', notifier = function() pmss_fn_del_unused() pmss_clone_sequence() end, tooltip = "Clone selected Secuence.\nThis operation include the 'Delete Unused Patterns'." }
}

--Icons

PMSS_ICO_LABEL_PT = vb:bitmap { bitmap = 'icons/label-pt-ico.bmp', mode = 'body_color', width = 16, height = 22, tooltip = 'Name of Pattern'  }
PMSS_ICO_LABEL_SC = vb:bitmap { bitmap = 'icons/label-sc-ico.bmp', mode = 'body_color', width = 16, height = 22, tooltip = 'Name of Section'  }

PMSS_ICO_INSERT = vb:bitmap { bitmap = 'icons/insert-pt-ico.bmp', mode = 'body_color', width = 18, height = 54, tooltip = 'Insert Patterns Pane'  }
PMSS_ICO_CLONE  = vb:bitmap { bitmap = 'icons/clone-pt-ico.bmp',  mode = 'body_color', width = 18, height = 54, tooltip = 'Clone Patterns Pane' }
PMSS_ICO_CLEAR  = vb:bitmap { bitmap = 'icons/clear-pt-ico.bmp',  mode = 'body_color', width = 18, height = 54, tooltip = 'Clear Tracks/Patterns Pane' }
PMSS_ICO_JUMP   = vb:bitmap { bitmap = 'icons/multi-jump-ico.bmp',mode = 'body_color', height = 22 }

--------------------------------------------------------------------------------
-- DELETE, CLEAR AND JUMP
--------------------------------------------------------------------------------

------------------------------------------
---- Functions
------------------------------------------
--Delete Selected Track and Jump 
function pmss_fn_del_tr( song, sti, j )
  song = renoise.song()
  sti = song.selected_track_index
  j = vb.views['PMSS_VB_JUMP'].value --jump
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER or song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    if ( song.sequencer_track_count > 1 and song.selected_track_index + j < #song.tracks  ) then --song.sequencer_track_count (tracks only) -- #song.tracks (all)
      song:delete_track_at( sti ) --delete track/group
      song.selected_track_index = sti + j --select new trak with jump
    end
  end
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then --song.send_track_count
    song:delete_track_at( sti ) --delete send
    if song.send_track_count >=1 then
      song.selected_track_index = #song.tracks - song.send_track_count + 1
    end
  end  
end

--Delete Selected Pattern and Jump
function pmss_fn_del_pt( song, ssi, j )
  song = renoise.song()
  ssi = song.selected_sequence_index
  j = vb.views['PMSS_VB_JUMP'].value --jump
  song.sequencer:delete_sequence_at( ssi )
  if ssi + j <= #song.sequencer.pattern_sequence then
    song.selected_sequence_index = ssi + j
  end
end

--Clear Selected Track and Jump
function pmss_fn_clr_tr(song, ssi, sti, j )
  song = renoise.song()
  ssi = song.selected_sequence_index
  sti = song.selected_track_index
  j = vb.views['PMSS_VB_JUMP'].value --jump
  song.patterns[ ssi ].tracks[ sti ]:clear()
  if ssi + j <= #song.sequencer.pattern_sequence then
    song.selected_sequence_index = ssi + j
  end
end

--Clear Selected Pattern and Jump
function pmss_fn_clr_pt( song, ssi, j )
  song = renoise.song()
  ssi = song.selected_sequence_index
  j = vb.views['PMSS_VB_JUMP'].value --jump
  song.patterns[ssi]:clear()
  if ssi + j <= #song.sequencer.pattern_sequence then
    song.selected_sequence_index = ssi + j
  end
end

--Repeat Delete Selected Track and Jump
function pmss_repeat_del_tr( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_del_tr ) then
      pmss_fn_del_tr()
      renoise.tool():remove_timer( pmss_repeat_del_tr )
      renoise.tool():add_timer( pmss_fn_del_tr, 40 )
    else
      pmss_fn_del_tr()
      renoise.tool():add_timer( pmss_repeat_del_tr, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_del_tr ) then
      renoise.tool():remove_timer( pmss_repeat_del_tr )
    elseif renoise.tool():has_timer( pmss_fn_del_tr ) then
      renoise.tool():remove_timer( pmss_fn_del_tr )
    end
  end  
end

--Repeat Delete Selected Pattern and Jump
function pmss_repeat_del_pt( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_del_pt ) then
      pmss_fn_del_pt()
      renoise.tool():remove_timer( pmss_repeat_del_pt )
      renoise.tool():add_timer( pmss_fn_del_pt, 40 )
    else
      pmss_fn_del_pt()
      renoise.tool():add_timer( pmss_repeat_del_pt, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_del_pt ) then
      renoise.tool():remove_timer( pmss_repeat_del_pt )
    elseif renoise.tool():has_timer( pmss_fn_del_pt ) then
      renoise.tool():remove_timer( pmss_fn_del_pt )
    end
  end  
end

--Repeat Clear Selected Track and Jump
function pmss_repeat_clr_tr( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_clr_tr ) then
      pmss_fn_clr_tr()
      renoise.tool():remove_timer( pmss_repeat_clr_tr )
      renoise.tool():add_timer( pmss_fn_clr_tr, 40 )
    else
      pmss_fn_clr_tr()
      renoise.tool():add_timer( pmss_repeat_clr_tr, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_clr_tr ) then
      renoise.tool():remove_timer( pmss_repeat_clr_tr )
    elseif renoise.tool():has_timer( pmss_fn_clr_tr ) then
      renoise.tool():remove_timer( pmss_fn_clr_tr )
    end
  end  
end

--Repeat Clear Selected Pattern and Jump
function pmss_repeat_clr_pt( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_clr_pt ) then
      pmss_fn_clr_pt()
      renoise.tool():remove_timer( pmss_repeat_clr_pt )
      renoise.tool():add_timer( pmss_fn_clr_pt, 40 )
    else
      pmss_fn_clr_pt()
      renoise.tool():add_timer( pmss_repeat_clr_pt, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_clr_pt ) then
      renoise.tool():remove_timer( pmss_repeat_clr_pt )
    elseif renoise.tool():has_timer( pmss_fn_clr_pt ) then
      renoise.tool():remove_timer( pmss_fn_clr_pt )
    end
  end  
end

------------------------------------------
---- Objects
------------------------------------------
--Jump valuebox
PMSS_VB_JUMP = vb:valuebox { id = 'PMSS_VB_JUMP', width = 54, height = 22, min = 0, max = 16, value = 0,
  tooltip = 'Jump next pattern or next track\n[Rangue = 0-16. Default Value = 0]'
}

PMSS_BT_DELETE_TR = vb:button { id = 'PMSS_BT_DELETE_TR', width = 53, height = 22, color = { 0x40,0x00,0x00 }, text = 'DEL TR',
  pressed = function() pmss_repeat_del_tr() end,
  released = function() pmss_repeat_del_tr(true) end,
  --notifier = function() pmss_fn_del_tr() end,
  tooltip = 'Delete selected track/group and jump next.\nDelete selected send.'
}
PMSS_BT_DELETE_PT = vb:button { id = 'PMSS_BT_DELETE_PT', width = 53, height = 22, color = { 0x40,0x00,0x00 }, text = 'DEL PT',
  pressed = function() pmss_repeat_del_pt() end,
  released = function() pmss_repeat_del_pt(true) end,
  --notifier = function() pmss_fn_del_pt() end,
  tooltip = 'Delete selected pattern and jump next.'
}
PMSS_BT_CLEAR_TR =  vb:button { id = 'PMSS_BT_CLEAR_TR',  width = 53, height = 22, color = { 0x60,0x00,0x00 }, text = 'CLR TR',
  pressed = function() pmss_repeat_clr_tr() end,
  released = function() pmss_repeat_clr_tr(true) end,
  --notifier = function() pmss_fn_clr_tr() end,
  tooltip = 'Clear selected track/group and jump next.\nClear selected send.'
}
PMSS_BT_CLEAR_PT =  vb:button { id = 'PMSS_BT_CLEAR_PT',  width = 53, height = 22, color = { 0x60,0x00,0x00 }, text = 'CLR PT',
  pressed = function() pmss_repeat_clr_pt() end,
  released = function() pmss_repeat_clr_pt(true) end,
  --notifier = function() pmss_fn_clr_pt() end,
  tooltip = 'Clear selected pattern and jump next.'
}





--------------------------------------------------------------------------------
-- AUTOPATTERN BUTTON
--------------------------------------------------------------------------------
--AutoPattern Live
--[[
function autopattern( song )
  song = renoise.song()
  local function autopattern_enable()
    if song.transport.edit_mode == true and  --(5)
       song.transport.follow_player == true and --(4)
       song.transport.playing == true --(3)
      then
      if song.selected_pattern_index == #song.patterns then --#song.sequencer.pattern_sequence then --(2)
        --no_lines = song.patterns[ song.sequencer.pattern_sequence[song.selected_pattern_index] ].number_of_lines --number of lines selected pattern (1)
        --print ('no_lines: ', no_lines)
        song.sequencer:insert_new_pattern_at( song.selected_pattern_index + 1 ) --insert new patterns automatically
        --song.patterns[ song.sequencer.pattern_sequence[ song.selected_pattern_index + 1 ] ].number_of_lines = no_lines --copy number_of_lines next pattern (1)
        song.sequencer:sort() --sort sequence automatically
      end
    end
  end
  song.transport.edit_mode_observable:add_notifier( autopattern_enable ) --(5)
  song.transport.follow_player_observable:add_notifier( autopattern_enable ) --(4)
  song.transport.playing_observable:add_notifier( autopattern_enable ) --(3)
  song.selected_pattern_index_observable:add_notifier( autopattern_enable ) --(2)
  --song.patterns[ song.sequencer.pattern_sequence[song.selected_pattern_index] ].number_of_lines_observable:add_notifier( autopattern_enable ) --(1)
end
renoise.tool().app_new_document_observable:add_notifier( autopattern )
]]

--[[
function autopattern( song )
  song = renoise.song()
  local function autopattern_enable()
    if song.transport.edit_mode == true and  --(5)
       song.transport.follow_player == true and --(4)
       song.transport.playing == true --(3)
      then
      if song.selected_sequence_index == #song.sequencer.pattern_sequence then --(2)
        no_lines = song.patterns[ song.sequencer.pattern_sequence[song.selected_sequence_index] ].number_of_lines --number of lines selected pattern (1)
        print ('no_lines: ', no_lines)
        song.sequencer:insert_new_pattern_at( song.selected_sequence_index + 1 ) --insert new patterns automatically
        song.patterns[ song.sequencer.pattern_sequence[ song.selected_sequence_index + 1 ] ].number_of_lines = no_lines --copy number_of_lines next pattern (1)
        song.sequencer:sort() --sort sequence automatically
      end
    end
  end
  song.transport.edit_mode_observable:add_notifier( autopattern_enable ) --(5)
  song.transport.follow_player_observable:add_notifier( autopattern_enable ) --(4)
  song.transport.playing_observable:add_notifier( autopattern_enable ) --(3)
  song.selected_sequence_index_observable:add_notifier( autopattern_enable ) --(2)
  song.patterns[ song.sequencer.pattern_sequence[song.selected_sequence_index] ].number_of_lines_observable:add_notifier( autopattern_enable ) --(1)
end
renoise.tool().app_new_document_observable:add_notifier( autopattern )
--]]

--[[
--=====================================
function indexobser()
  local song = renoise.song()
  song.sequencer:insert_new_pattern_at( song.selected_pattern_index + 1 )
end

function autopattern( song )
  song = renoise.song()
  song.selected_pattern_index_observable:add_notifier( indexobser )
end

renoise.tool().app_new_document_observable:add_notifier( autopattern )
--=====================================
]]





--------------------------------------------------------------------------------
-- NAVIGATION PATTERNS BUTTONS
--------------------------------------------------------------------------------

------------------------------------------
---- Functionss
------------------------------------------
function pmss_repeat_navs_up( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_navs_up ) then
      pmss_navs_up()
      renoise.tool():remove_timer( pmss_repeat_navs_up )
      renoise.tool():add_timer( pmss_navs_up, 30 )
    else
      pmss_navs_up()
      renoise.tool():add_timer( pmss_repeat_navs_up, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_navs_up ) then
      renoise.tool():remove_timer( pmss_repeat_navs_up )
    elseif renoise.tool():has_timer( pmss_navs_up ) then
      renoise.tool():remove_timer( pmss_navs_up )
    end
  end  
end
function pmss_repeat_navs_down( release )
  if not release then
    if renoise.tool():has_timer( pmss_repeat_navs_down ) then
      pmss_navs_down()
      renoise.tool():remove_timer( pmss_repeat_navs_down )
      renoise.tool():add_timer( pmss_navs_down, 30 )
    else
      pmss_navs_down()
      renoise.tool():add_timer( pmss_repeat_navs_down, 400 )
    end
  else
    if renoise.tool():has_timer( pmss_repeat_navs_down ) then
      renoise.tool():remove_timer( pmss_repeat_navs_down )
    elseif renoise.tool():has_timer( pmss_navs_down ) then
      renoise.tool():remove_timer( pmss_navs_down )
    end
  end  
end
function pmss_navs_up( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if song.selected_sequence_index > 1 then
    song.selected_sequence_index = sid - 1 --select next pattern
    renoise.app():show_status( "GT16-Colors, PMSS:  previous pattern." )
  end
end
function pmss_navs_down( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if #song.sequencer.pattern_sequence > ( sid ) then
    song.selected_sequence_index = sid + 1 --select next pattern
    renoise.app():show_status( "GT16-Colors, PMSS:  next pattern." )
  end
end

function pmss_repeat_navs_first( song )
  song = renoise.song()
  song.selected_sequence_index = 1
  renoise.app():show_status( "GT16-Colors, PMSS:  first pattern." )
end
function pmss_repeat_navs_last( song )
  song = renoise.song()
  song.selected_sequence_index = #song.sequencer.pattern_sequence
  renoise.app():show_status( "GT16-Colors, PMSS:  last pattern." )
end

------------------------------------------
---- Objects
------------------------------------------
PMSS_BT_UP = vb:button { id = 'PMSS_BT_UP', width = 28, height = 20, color = { 0x40,0x00,0x80 }, bitmap = 'icons/up-ico.bmp',
  pressed = function() pmss_repeat_navs_up() end,
  released = function() pmss_repeat_navs_up(true) end,
  --notifier = function() pmss_fn_del_tr() end,
  tooltip = 'Up Pattern Sequence.'
}

PMSS_BT_DOWN = vb:button { id = 'PMSS_BT_DOWN', width = 28, height = 20, color = { 0x40,0x00,0x80 }, bitmap = 'icons/down-ico.bmp', 
  pressed = function() pmss_repeat_navs_down() end,
  released = function() pmss_repeat_navs_down(true) end,
  --notifier = function() pmss_fn_del_tr() end,
  tooltip = 'Down Pattern Sequence.'
}

PMSS_BT_TOP = vb:button { id = 'PMSS_BT_TOP', width = 28, height = 15, color = { 0x40,0x00,0x80 }, bitmap = 'icons/top-ico.bmp',
  notifier = function() pmss_repeat_navs_first() end,
  tooltip = 'First Pattern.'
}

PMSS_BT_BOTTOM = vb:button { id = 'PMSS_BT_BOTTOM', width = 28, height = 15, color = { 0x40,0x00,0x80 }, bitmap = 'icons/bottom-ico.bmp',
  notifier = function() pmss_repeat_navs_last() end,
  tooltip = 'Last Pattern.'
}

PMSS_NAVS_PTT = vb:column { PMSS_BT_TOP, PMSS_BT_UP, PMSS_BT_DOWN, PMSS_BT_BOTTOM }



--------------------------------------------------------------------------------
-- GUI - PMSS
--------------------------------------------------------------------------------
PMSS =
vb:column {
  vb:horizontal_aligner {
    width = 678,
    mode = 'right',
    vb:bitmap {
      bitmap = 'icons/insert-clone-ico.bmp',
      mode = 'body_color',
      height = 22,
    },
    vb:text { font = 'bold', text = 'PMSS: Pattern Matrix Specific Sequencer', height = 22 },
    vb:text { text = '   v1.0b', height = 22 },
    vb:horizontal_aligner { width = 22 },
    PMSS_BT_MATRIX,
    vb:horizontal_aligner { width = 5 },
    PMSS_TX_NUM, PMSS_TF_PATT,PMSS_ICO_LABEL_PT, PMSS_BT_SORT, PMSS_BT_DEFAULT
  },
  vb:horizontal_aligner { height = 5 },
  vb:column { style = 'panel', margin = 8,
    vb:row{
      PMSS_ICO_INSERT,
      vb:column { style = 'panel', margin = 5,
        vb:row{      
          vb:column {
            vb:text { text = 'Number', height = 22 }, PMSS_VB_NUMBER
          },
          vb:column {
            PMSS_BT_02, PMSS_BT_04
          },
          vb:column {
            PMSS_BT_06, PMSS_BT_08
          }
        }
      },
      vb:column { style = 'panel', margin = 5,
        vb:row { 
          vb:text { text = 'Change Label', width = 78 },
          PMSS_PP_SECTION }, vb:row { PMSS_CB_SECTION, PMSS_TF_SEC, PMSS_ICO_LABEL_SC }
        },
        vb:column { style = 'panel', margin = 5,
          vb:row{
            vb:column {
              vb:text { text = 'Multiplier', height = 22 }, PMSS_VB_MULTIPLY
            },
            vb:column {
              PMSS_BT_X02, PMSS_BT_X04
            },
            vb:column {
              PMSS_BT_X06, PMSS_BT_X08
            },
            vb:column {
              PMSS_BT_X10, PMSS_BT_X12
            }
          }
        },
        vb:column { style = 'panel', margin = 5,
        vb:text { text = 'Lines', height = 22 },
        vb:row { PMSS_CB_NO_LINES, PMSS_VB_NO_LINES }
      },
      PMSS_BT_INSERT,
    }
  },  
  vb:horizontal_aligner { height = 5 },
  vb:row {
    vb:column { style = 'panel', margin = 8,
      vb:row{
        PMSS_ICO_CLONE,
        vb:column { style = 'panel', margin = 5,
          vb:row{
            vb:column {
              vb:text { text = 'Number', height = 22 }, PMSS_VB_NUMBER_2
            },
            vb:column {
              PMSS_BT_02_2, PMSS_BT_04_2
            },
            vb:column {
              PMSS_BT_06_2, PMSS_BT_08_2
            },
            vb:column {
              PMSS_BT_10_2, PMSS_BT_12_2
            },
            vb:column {
              PMSS_BT_14_2, PMSS_BT_16_2
            }
          }
        },
        vb:column { style = 'panel', margin = 5,
          vb:row{
            vb:column {
              vb:text { text = 'Multiplier', height = 22 }, PMSS_VB_MULTIPLY_2
            },
            vb:column {
              PMSS_BT_X02_2, PMSS_BT_X04_2
            },
            vb:column {
              PMSS_BT_X06_2, PMSS_BT_X08_2
            },
            vb:column {
              PMSS_BT_X10_2, PMSS_BT_X12_2
            }
          }
        },
        PMSS_BT_CLONE,
      }
    },
    vb:horizontal_aligner { width = 5 },
    vb:column { style = 'panel', margin = 8,
      vb:row{
        PMSS_ICO_CLEAR,
        vb:column { style = 'panel', margin = 5,
          vb:row{
            vb:column {
              PMSS_ICO_JUMP, PMSS_VB_JUMP
            },
            vb:column {
              PMSS_BT_DELETE_TR, PMSS_BT_DELETE_PT
            },
            vb:column {
            PMSS_BT_CLEAR_TR, PMSS_BT_CLEAR_PT
            }
          }
        } 
      }
    },
    vb:horizontal_aligner { width = 5 },
    PMSS_NAVS_PTT
  }
}
