--------------------------------------------------------------------------------
-- Module Tool: Tool_04.lua
-- Name: GTC: Groups & Tracks Control
-- Version: 1.1
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- DEACTIVATED FUNCTIONS 
--------------------------------------------------------------------------------

--[[
function tool_01_02() end
function tool_01_03() end

function tool_01_13() end -- out
function tool_01_14() end
function tool_01_15() end
function tool_01_20() end

--]]


--------------------------------------------------------------------------------
-- FUNCTION FOR CHECKBOX (SHOW or HIDE +INFO...)
--------------------------------------------------------------------------------
function show_cbox_gtc( idx )
  LOG( 'show_cbox_gtc()' , idx )
  vb.views.cbox_gtc_t.visible = ( idx == true )
  vb.views.cbox_gtc_f.visible = ( idx == false )
end

checkbox_gtc_info = vb:checkbox { id = 'cbox_gtc_info', notifier = function(new_idx) show_cbox_gtc(new_idx) end }

gtc_info = vb:text { text = "The GTC tool is designed to work primarily with Groups. It also serves to Tracks...\n"..
                          "  ⚫ Select any Group with Tracks. Control especific options/values together inside the Group...  ⚠ Affect all Tracks within the Group.\n"..
                          "  ⚫ Select any Track. Control especific options/values inside this Track...  ⚠ Affect only inside this Track.\n"..
                  "  ⚫ ⚠ Caution: red buttons clean the values depending of the selected Group or Track, in Group also!!!\n"..
                  "  ⚫ Use the navigation violet buttons to move between tracks and groups.\n"..
                  "  ⚫ ⚠ The three valuebox are limited until 64 members!"
                   }
               
--------------------------------------------------------------------------------
-- FUNCTIONS FOR OPTIONS (SHOW, HIDE, EXPAND, COLLAPSE...)
--------------------------------------------------------------------------------

-- [VALUEBOX] tool_01_01: Show or Hide all Note Columns Tracks in the Group Selected
function tool_01_01( new_index ) -- Increase/Decrease number Note Columns, 1 to 12, min = 1
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( sel_mb <= 64 and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].visible_note_columns > 0 ) then ---- LIMIT = 64 ---------|***
        song.tracks[i].visible_note_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  show/hide all Note Columns inside Group/s selected." )
      end
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.visible_note_columns > 0 ) then
      selected_track.visible_note_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  show/hide all Note Columns of Track selected." )
    end
  end
  ---  
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show/hide Note Columns, select before a Group or Track!" )
  end
end


-- [VALUEBOX] tool_01_08: Increase or Hide all Effect Columns Tracks in the Group Selected
function tool_01_08( new_index ) -- Increase/Hide Effect Columns Tr, 0 to 8, hide = 0
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( sel_mb <= 64 and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].visible_effect_columns >= 0 ) then  ---- LIMIT = 64 ---------|***
      song.tracks[i].visible_effect_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  append/hide all Effect Columns inside Group/s selected." )
      end
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.visible_effect_columns >= 0 ) then
      selected_track.visible_effect_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  append/hide all Effect Columns of Track selected." )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for append/hide Note Columns, select before a Group or Track!" )
  end
end


-- [VALUEBOX] tool_01_10: Increase/Decrease all Effect Columns of Group Selected
function tool_01_10( new_index ) -- Increase/Hide Effect Columns Gr, 1 to 8, min = 1
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index  
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do  
      if ( sel_mb <= 128 and song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP and song.tracks[i].visible_effect_columns > 0 ) then ---- LIMIT = 64 ---------|***
        song.tracks[i].visible_effect_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  append/hide all Effect Columns of all Groups inside Group/s selected." )
      end
  end
  end
  ---
  local function filter_Mt_Sd( sel_tr )
    sel_tr = song.selected_track_index  
    if ( selected_track.visible_effect_columns > 0 ) then ---- LIMIT = 64 ---------|***
      selected_track.visible_effect_columns = new_index
    renoise.app():show_status( "GT16-Colors, GTC:  append/hide all Effect Columns of Master/Send Track selected." )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_MASTER ) or ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then
    filter_Mt_Sd()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for append/hide Effect Columns, select before a Group/Master/Send!" )
  end
end


-- [BUTTONS] tool_01_04 & tool_01_16: Show or Hide all Volume Tracks in the Group Selected
function tool_01_04() -- Show Volume
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].volume_column_visible == F ) then
      song.tracks[i].volume_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Volume Columns of Tracks inside Group/s displayed." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Volume Columns of Tracks insidde Group/s are already displayed!" )
      end
  end
  end
  ---
  local function filter_Tr()
    if ( selected_track.volume_column_visible == F ) then 
      selected_track.volume_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Volume Columns of Track displayed." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Volume Columns of Track are already displayed!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show Volume Columns select before a Group or Track!" )
  end
end
--- ---
function tool_01_16() -- Hide Volume
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].volume_column_visible == T ) then
      song.tracks[i].volume_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Volume Columns of Tracks inside Group/s hidden." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Volume Columns of Tracks inside Group/s are already hidden!" )
      end
  end
  end
  ---
  local function filter_Tr()
    if ( selected_track.volume_column_visible == T ) then
    selected_track.volume_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Volume Columns of Track hidden." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Volume Columns of Track are already hidden!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for hide Volume Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_05 & tool_01_17: Show or Hide all Panning Tracks in the Group Selected
function tool_01_05() -- Show Panning
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]  
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].panning_column_visible == F ) then
        song.tracks[i].panning_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Panning Columns of Tracks inside Group/s displayed." )
      else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Panning Columns of Tracks inside Group/s are already displayed!" )
      end
  end
  end
  local function filter_Tr()
    if ( selected_track.panning_column_visible == F ) then
    selected_track.panning_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Panning Columns of Track displayed." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Panning Columns of Track are already displayed!" )
  end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show Panning Columns select before a Group or Track!" )
  end
end
--- ---
function tool_01_17() -- Hide Panning
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].panning_column_visible == T ) then
        song.tracks[i].panning_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Panning Columns of Tracks inside Group/s hidden." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Panning Columns of Tracks inside Group/s are already hidden!" )
      end
  end
  end
  ---
  local function filter_Tr()
    if ( selected_track.panning_column_visible == T ) then
    selected_track.panning_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Panning Columns of Track hidden." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Panning Columns of Track are already hidden!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for hide Panning Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_06 & tool_01_18: Show or Hide all Delay Tracks in the Group Selected
function tool_01_06() -- Show Delay
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].delay_column_visible == F ) then
      song.tracks[i].delay_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Delay Columns of Tracks inside Group/s displayed." )
      else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Delay Columns of Tracks inside Group/s are already displayed!" )
      end
  end
  end
  ---
  local function filter_Tr()
    if ( selected_track.delay_column_visible == F ) then
    selected_track.delay_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Delay Columns of Track displayed." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Delay Columns of Track are already displayed!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show Panning Columns select before a Group or Track!" )
  end
end
--- ---
function tool_01_18() -- Hide Delay
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].delay_column_visible == T ) then
      song.tracks[i].delay_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Delay Columns of Tracks inside Group/s hidden." )
      else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Delay Columns of Tracks inside Group/s are already hidden!" )
      end
  end
  end
  ---
  local function filter_Tr()
    if ( selected_track.delay_column_visible == T ) then
      selected_track.delay_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Delay Columns of Track hidden." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Delay Columns of Track are already hidden!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for hide Delay Columns select before a Group or Track!" )
  end
end


-- [BUTTONS] tool_01_07 & tool_01_19: Show or Hide all Sample Effects Tracks in the Group Selected
function tool_01_07() -- Show Sample Effects
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].sample_effects_column_visible == F ) then
        song.tracks[i].sample_effects_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Sample Effects of Tracks inside Group/s displayed." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Sample Effects of Tracks inside Group/s are already displayed!" )
    end
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.sample_effects_column_visible == F ) then
      selected_track.sample_effects_column_visible = T
    renoise.app():show_status( "GT16-Colors, GTC:  Sample Effects of Track displayed." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Sample Effects of Track are already displayed!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show Sample Effects select before a Group or Track!" )
  end
end
--- ---
function tool_01_19() -- Hide Sample Effects
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].sample_effects_column_visible == T ) then
        song.tracks[i].sample_effects_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Sample Effects of Tracks inside Group/s hidden." )
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Sample Effects of Tracks inside Group/s are already hidden!" )
    end
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.sample_effects_column_visible == T ) then
    selected_track.sample_effects_column_visible = F
    renoise.app():show_status( "GT16-Colors, GTC:  Sample Effects of Track hidden." )
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  Sample Effects of Track are already hidden!" )
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for hide Sample Effects select before a Group or Track!" )
  end
end


-- [BUTTONS] tool_01_09 & tool_01_21: Show or Hide All in Tracks in the Group Selected
function tool_01_09() -- Show All in Tracks
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].volume_column_visible == F )         then song.tracks[i].volume_column_visible = T end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].panning_column_visible == F )        then song.tracks[i].panning_column_visible = T end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].delay_column_visible == F )          then song.tracks[i].delay_column_visible = T end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].sample_effects_column_visible == F ) then song.tracks[i].sample_effects_column_visible = T end
      renoise.app():show_status( "GT16-Colors, GTC:  all Parameter Columns of Tracks inside Group/s displayed." )
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.volume_column_visible == F )         then selected_track.volume_column_visible = T end
    if ( selected_track.panning_column_visible == F )        then selected_track.panning_column_visible = T end
    if ( selected_track.delay_column_visible == F )          then selected_track.delay_column_visible = T end
    if ( selected_track.sample_effects_column_visible == F ) then selected_track.sample_effects_column_visible = T end
    renoise.app():show_status( "GT16-Colors, GTC:  all Parameter Columns of Track displayed." )
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
    elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for show all Parameter Columns select before a Group or Track!" ) 
  end
end
---
function tool_01_21() -- Hide All in Tracks
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].volume_column_visible == T )       then song.tracks[i].volume_column_visible = F end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].panning_column_visible == T )        then song.tracks[i].panning_column_visible = F end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].delay_column_visible == T )          then song.tracks[i].delay_column_visible = F end
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER and song.tracks[i].sample_effects_column_visible == T ) then song.tracks[i].sample_effects_column_visible = F end
      renoise.app():show_status( "GT16-Colors, GTC:  all Parameter Columns of Tracks inside Group/s hidden." )
    end
  end
  ---
  local function filter_Tr()
    if ( selected_track.volume_column_visible == T )         then selected_track.volume_column_visible = F end
    if ( selected_track.panning_column_visible == T )        then selected_track.panning_column_visible = F end
    if ( selected_track.delay_column_visible == T )          then selected_track.delay_column_visible = F end
    if ( selected_track.sample_effects_column_visible == T ) then selected_track.sample_effects_column_visible = F end
    renoise.app():show_status( "GT16-Colors, GTC:  all Parameter Columns of Track hidden." )
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
    elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for hide all Parameter Columns select before a Group or Track!" )  
  end
end


-- [BUTTONS] tool_01_11 & tool_01_22: Show or Hide all Columns Tracks in the Group Selected
function tool_01_11( A ) -- Show All Gr
  local song = renoise.song()
  if song.transport.single_track_edit_mode == T then
    song.transport.single_track_edit_mode = F
  end
  local selected_track = song.tracks[ song.selected_track_index ]
  if ( selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    for i = 1, #selected_track.members do
      A = selected_track.members[ i ]
      if ( A.collapsed == T ) then A.collapsed = F
        renoise.app():show_status( "GT16-Colors, GTC:  all inside selected Group expanded." )
        else renoise.app():show_status( "GT16-Colors, GTC:  the group is already expanded." )
      end
    end
  end
  if ( selected_track.type ~= renoise.Track.TRACK_TYPE_GROUP ) then
    renoise.app():show_status( "⚠ GT16-Colors, GTC: please, for expand all select before a Group!" )
  end
end
---
function tool_01_23( A ) -- Hide All Gr
  local song = renoise.song()
  if song.transport.single_track_edit_mode == T then
    song.transport.single_track_edit_mode = F
  end
  local selected_track = song.tracks[ song.selected_track_index ]
  if ( selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    for i = 1, #selected_track.members do
      A = selected_track.members[ i ]
      if ( A.collapsed == F ) then A.collapsed = T
        renoise.app():show_status( "GT16-Colors, GTC:  all inside selected Group collapsed." )
        else renoise.app():show_status( "GT16-Colors, GTC:  the group is already collapsed." )
      end
    end
  end
  if ( selected_track.type ~= renoise.Track.TRACK_TYPE_GROUP ) then
    renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for collapse all select before a Group!" )
  end
end

-- [BUTTON] tool_01_12: Show & Hide all the Group Selected
function tool_01_12( A )
  local song = renoise.song()
  if song.transport.single_track_edit_mode == T then
    song.transport.single_track_edit_mode = F
  end
  local selected_track = song.tracks[ song.selected_track_index ]
  if ( selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    A = selected_track
    if ( A.group_collapsed == T ) then A.group_collapsed = F
      renoise.app():show_status( "GT16-Colors, GTC:  selected Group expanded." )
      elseif ( A.group_collapsed == F ) then A.group_collapsed = T
      renoise.app():show_status( "GT16-Colors, GTC:  selected Group collapsed." )
    end
  end
  if ( selected_track.type ~= renoise.Track.TRACK_TYPE_GROUP ) then
    renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for expand or collapse the Group select before a Group!" )
  end
end

-- [BUTTON] tool_01_24: Show & Hide all Columns Tracks inside the Group Selected
function tool_01_24( A ) -- Show/Hide All Gr
  local song = renoise.song()
  if song.transport.single_track_edit_mode == T then
    song.transport.single_track_edit_mode = F
  end
  local selected_track = song.tracks[ song.selected_track_index ]
  if ( selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    for i = 1, #selected_track.members do
      A = selected_track.members[ i ]
      if ( A.collapsed == T ) then A.collapsed = F
        elseif ( A.collapsed == F ) then A.collapsed = T
        renoise.app():show_status( "GT16-Colors, GTC:  all inside selected Group expanded & collapsed." )    
      end
    end
  end
  if ( selected_track.type ~= renoise.Track.TRACK_TYPE_GROUP ) then
    renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for expand & collapse all select before a Group!" )
  end
end

-- [BUTTON] tool_01_22: Show/Hide all Effect Columns of Group Selected
function tool_01_22() -- Increase/Hide Effect Columns Gr, 1 to 8
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ] -- object (Track or Group)
  ---
  local function filter( sel_tr , sel_mb )
    sel_tr = song.selected_track_index -- nº Group (or Track) selected
    sel_mb = #selected_track.members   -- nº of members (include Groups & Tracks)
    for i = sel_tr , sel_tr - sel_mb  , - 1 do  
      if ( song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP ) then 
        if ( song.tracks[i].collapsed == T ) then song.tracks[i].collapsed = F
          renoise.app():show_status( "GT16-Colors, GTC:  all Effect Columns of Groups inside selected Group expanded." )
          elseif ( song.tracks[i].collapsed == F ) then song.tracks[i].collapsed = T
          renoise.app():show_status( "GT16-Colors, GTC:  all Effect Columns of Groups inside selected Group collapsed." )
        end
      end
    end
  end
  ---  
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter()
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for expand/collapse Effect Columns of Group/s, select before a Group!" )
  end
end



--------------------------------------------------------------------------------
-- FUNCTIONS FOR VALUES (CLEAN VALUES INSIDE ESPECIFIC COLUMNS FOR PATTERN ONLY)
--------------------------------------------------------------------------------

-- [BUTTON] tool_01_26: Clean all values in Note Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_26()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.note_value >= 0 ) then
        note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Note Columns inside selected Group/s are cleaned." )
      end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.note_value >= 0 ) then    
          note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Note Columns inside selected Track are cleaned." )
    end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Note Columns select before a Group or Track!" )
  end
end

-- [BUTTON] tool_01_27: Clean all values in Instrument Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_27()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.instrument_value >= 0 ) then
        note_column.instrument_value = 255 -- 0-254, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Instrument Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.instrument_value >= 0 ) then
      note_column.instrument_value = 255 -- 0-254, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Instrument Columns inside selected Track are cleaned." )
      end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Instrument Columns select before a Group or Track!" )  
  end
end


-- [BUTTON] tool_01_28: Clean all values in Volume Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_28()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.volume_value >= 0 ) then
        note_column.volume_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Volume Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.volume_value >= 0 ) then
      note_column.volume_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Volume Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Volume Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_29: Clean all values in Panning Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_29()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.panning_value >= 0 ) then
        note_column.panning_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Panning Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.panning_value >= 0 ) then
          note_column.panning_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Panning Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Panning Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_30: Clean all values in Delay Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_30()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.delay_value >= 0 ) then
        note_column.delay_value = 0 -- 0-255, 0==Empty
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Delay Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
  --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.delay_value >= 0 ) then
          note_column.delay_value = 0 -- 0-255, 0==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Delay Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Delay Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_31: Clean all values in Sample Effect Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_31()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if ( note_column.effect_number_value >= 0 ) then
        note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
      end
        if ( note_column.effect_number_value >= 0 ) then
        note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Sample Effects inside selected Group/s are cleaned." )
        end
        end
      end
  end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if ( note_column.effect_number_value >= 0 ) then
      note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
    end
      if ( note_column.effect_number_value >= 0 ) then
      note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Sample Effects inside selected Track are cleaned." )
      end
      end
  end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()

  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Sample Effects select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_32: Clean all values in Effect Columns of Track/s inside Selected Group, for selected Pattern only
function tool_01_32()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    for i = sel_tr , sel_tr - sel_mb  , - 1 do
    --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
      local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , i , true )
      for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( effect_column.number_value >= 0 ) then
            effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
          end
          if( effect_column.number_value >= 0 ) then
            effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
            renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns inside selected Group/s are cleaned." )
          end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( sel_tr , true)
    local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , sel_tr , true )
    for pos, effect_column in pattern_iterator_effects do
      if ( not effect_column.is_empty ) then
        if( effect_column.number_value >= 0 ) then
          effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then
          effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
          renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
    elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
      filter_Tr()
    else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Effect Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_33: Clean all values in Track/s inside Selected Group, for selected Pattern only
function tool_01_33()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
    --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
      for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      end
          if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
        end
          if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
        end    
          if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
          end
    end
    end
    --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
    local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , i , true )
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track/s in selected Group are cleaned." )
          end
    end
      end
    end
  end
  ---
  local function filter_Tr( sel_pn , sel_tr )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
  --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , sel_tr , true )
    for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
      if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
    end
        if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
      end
        if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
      end
        if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
      end
        if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
      end    
        if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
      end
      if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        end
      end
  end
  --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( sel_tr , true)
  local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , sel_tr , true )
  for pos, effect_column in pattern_iterator_effects do
      if ( not effect_column.is_empty ) then
        if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
      end
      if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track selected are cleaned." )
    end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values inside Track/s select before a Group or Track!" )
  end
end

-- [BUTTON] tool_01_34: Clean all values Effect Columns in Groups inside Selected Group, this included, for selected Pattern only
function tool_01_34()
  local song = renoise.song()
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    local selected_track = song.tracks[ song.selected_track_index ]
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true) -- for Effects Columns of Track (8 Columns)
      local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , sel_tr , true )
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP then
        if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns of Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values of Effect Columns in Group/s select before a Group!" )
  end
end


-- [BUTTON] tool_01_35: Clean all values in Track/s and Groups inside Selected Group, this included, for selected Pattern only
function tool_01_35()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_pn , sel_tr , sel_mb )
    sel_pn = song.selected_sequence_index
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      --local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_pattern_track( sel_pn , i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      end
          if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
        end
          if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
        end    
          if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
          end
    end
      end
      --local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
      local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_pattern_track( sel_pn , i , true )
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER or song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP then
      if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track/s & Group/s are cleaned." )
          end
    end
      end
  end 
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values inside Track/s & Group/s select before a Group!" )
  end
end


--------------------------------------------------------------------------------
-- FUNCTIONS FOR VALUES (CLEAN VALUES INSIDE ESPECIFIC COLUMNS FOR ALL GROUP/TRACK)
--------------------------------------------------------------------------------

-- [BUTTON] tool_01_36: Clean all values in Note Columns of Track/s inside Selected Group, for all Track/Group
function tool_01_36()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.note_value >= 0 ) then
        note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Note Columns inside selected Group/s are cleaned." )
      end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.note_value >= 0 ) then    
          note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Note Columns inside selected Track are cleaned." )
    end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Note Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_37: Clean all values in Instrument Columns of Track/s inside Selected Group
function tool_01_37()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.instrument_value >= 0 ) then
        note_column.instrument_value = 255 -- 0-254, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Instrument Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.instrument_value >= 0 ) then
      note_column.instrument_value = 255 -- 0-254, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Instrument Columns inside selected Track are cleaned." )
      end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Instrument Columns select before a Group or Track!" )  
  end
end


-- [BUTTON] tool_01_38: Clean all values in Volume Columns of Track/s inside Selected Group
function tool_01_38()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.volume_value >= 0 ) then
        note_column.volume_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Volume Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.volume_value >= 0 ) then
      note_column.volume_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Volume Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Volume Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_39: Clean all values in Panning Columns of Track/s inside Selected Group
function tool_01_39()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.panning_value >= 0 ) then
        note_column.panning_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Panning Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.panning_value >= 0 ) then
          note_column.panning_value = 255 -- 0-127, 255==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Panning Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Panning Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_40: Clean all values in Delay Columns of Track/s inside Selected Group
function tool_01_40()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( note_column.delay_value >= 0 ) then
        note_column.delay_value = 0 -- 0-255, 0==Empty
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Delay Columns inside selected Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
  local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if( note_column.delay_value >= 0 ) then
          note_column.delay_value = 0 -- 0-255, 0==Empty
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Delay Columns inside selected Track are cleaned." )
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Delay Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_41: Clean all values in Sample Effect Columns of Track/s inside Selected Group
function tool_01_41()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if ( note_column.effect_number_value >= 0 ) then
        note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
      end
        if ( note_column.effect_number_value >= 0 ) then
        note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Sample Effects inside selected Group/s are cleaned." )
        end
        end
      end
  end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
  for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
        if ( note_column.effect_number_value >= 0 ) then
      note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
    end
      if ( note_column.effect_number_value >= 0 ) then
      note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Sample Effects inside selected Track are cleaned." )
      end
      end
  end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()

  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Sample Effects select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_42: Clean all values in Effect Columns of Track/s inside Selected Group
function tool_01_42()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
    local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( effect_column.number_value >= 0 ) then
        effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
      end
        if( effect_column.number_value >= 0 ) then
        effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns inside selected Group/s are cleaned." )
        end
        end
      end
  end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
  local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( sel_tr , true)
  for pos, effect_column in pattern_iterator_effects do
      if ( not effect_column.is_empty ) then
        if( effect_column.number_value >= 0 ) then
      effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
      if( effect_column.number_value >= 0 ) then
      effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns inside selected Track are cleaned." )
      end
      end
  end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean values of Effect Columns select before a Group or Track!" )
  end
end


-- [BUTTON] tool_01_43: Clean all values in Track/s inside Selected Group
function tool_01_43()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
    local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
      for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      end
          if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
        end
          if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
        end    
          if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
          end
    end
    end
    local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
          if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track/s in selected Group are cleaned." )
          end
    end
      end
    end
  end
  ---
  local function filter_Tr( sel_tr )
    sel_tr = song.selected_track_index
  local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( sel_tr , true )
    for pos, note_column in pattern_iterator_notes do
      if ( not note_column.is_empty ) then
      if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
    end
        if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
      end
        if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
      end
        if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
      end
        if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
      end    
        if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
      end
      if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        end
      end
  end
  local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( sel_tr , true)
  for pos, effect_column in pattern_iterator_effects do
      if ( not effect_column.is_empty ) then
        if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
      end
      if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
      renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track selected are cleaned." )
    end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  elseif ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    filter_Tr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values inside Track/s select before a Group or Track!" )
  end
end

-- [BUTTON] tool_01_44: Clean all values Effect Columns in Groups inside Selected Group, this included
function tool_01_44()
  local song = renoise.song()
  local function filter_Gr( sel_tr , sel_mb )
    local selected_track = song.tracks[ song.selected_track_index ]
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true) -- for Effects Columns of Track (8 Columns)
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP then
        if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values of Effect Columns of Group/s are cleaned." )
        end
        end
      end
    end
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values of Effect Columns in Group/s select before a Group!" )
  end
end

-- [BUTTON] tool_01_45: Clean all values in Track/s and Groups inside Selected Group, this included
function tool_01_45()
  local song = renoise.song()
  local selected_track = song.tracks[ song.selected_track_index ]
  ---
  local function filter_Gr( sel_tr , sel_mb )
    sel_tr = song.selected_track_index
    sel_mb = #selected_track.members
    --loop
  for i = sel_tr , sel_tr - sel_mb  , - 1 do
      local pattern_iterator_notes = song.pattern_iterator:note_columns_in_track( i , true )
    for pos, note_column in pattern_iterator_notes do
        if ( not note_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        if( note_column.note_value >= 0 ) then note_column.note_value = 121 -- 0-119, 120=Off, 121=Empty
      end
          if( note_column.instrument_value >= 0 ) then note_column.instrument_value = 255 -- 0-254, 255==Empty
        end
          if( note_column.volume_value >= 0 ) then note_column.volume_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.panning_value >= 0 ) then note_column.panning_value = 255 -- 0-127, 255==Empty
        end
          if( note_column.delay_value >= 0 ) then note_column.delay_value = 0 -- 0-255, 0==Empty
        end    
          if( note_column.effect_number_value >= 0 ) then note_column.effect_number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( note_column.effect_number_value >= 0 ) then note_column.effect_amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
          end
    end
      end
      local pattern_iterator_effects = song.pattern_iterator:effect_columns_in_track( i , true)
    for pos, effect_column in pattern_iterator_effects do
        if ( not effect_column.is_empty ) and song.tracks[i].type == renoise.Track.TRACK_TYPE_SEQUENCER or song.tracks[i].type == renoise.Track.TRACK_TYPE_GROUP then
      if( effect_column.number_value >= 0 ) then effect_column.number_value = 0 -- 0-65535 ???, 0==Empty
        end
        if( effect_column.number_value >= 0 ) then effect_column.amount_value = 0 -- 0-255 ???, 0==Empty (0 & 0, both together)
        renoise.app():show_status( "GT16-Colors, GTC:  all values inside Track/s & Group/s are cleaned." )
          end
    end
      end
  end 
  end
  ---
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    filter_Gr()
  else renoise.app():show_status( "⚠ GT16-Colors, GTC:  please, for clean all values inside Track/s & Group/s select before a Group!" )
  end
end


--------------------------------------------------------------------------------
-- FUNCTIONS FOR NAVIGATE (SUPERIOR GROUPS, SUBGROUPS & TRACKS)
--------------------------------------------------------------------------------

-- [BUTTONS] tool_01_36 to tool_01_41: Jump Navigate per Superior Groups, SubGroups & Tracks; Previous, Next
function tool_01_46( A , B , C ) -- jump to previous Superior Group
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C - 1
    A = song.tracks[ C ]
    B = song.tracks[ C - 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_GROUP ) and B and ( B.type == renoise.Track.TRACK_TYPE_GROUP ) ) --&-- or B.type == renoise.Track.TRACK_TYPE_SEQUENCER
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  previous superior Group is selected." )
  end
end
--- ---
function tool_01_47( A , B , C ) -- jump to next Superior Group
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C + 1
    A = song.tracks[ C ]
    B = song.tracks[ C - 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_GROUP ) and B and ( B.type == renoise.Track.TRACK_TYPE_GROUP ) ) --&-- or B.type == renoise.Track.TRACK_TYPE_SEQUENCER
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  next superior Group is selected." )
  end
end


function tool_01_48( A , B , C ) -- jump to previous SubGroup (with sequencer track)
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C - 1
    A = song.tracks[ C ]
    B = song.tracks[ C - 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_GROUP ) and B and ( B.type == renoise.Track.TRACK_TYPE_SEQUENCER ) )
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  previous SubGroup is selected." )
  end
end
--- ---
function tool_01_49( A , B , C ) -- jump to next SubGroup (with sequencer track)
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C + 1
    A = song.tracks[ C ]
    B = song.tracks[ C - 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_GROUP ) and B and ( B.type == renoise.Track.TRACK_TYPE_SEQUENCER ) )
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  next SubGroup is selected." )
  end
end


function tool_01_50( A , B , C ) -- jump to previous Track (with sequencer track)
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C - 1
    A = song.tracks[ C ]
    B = song.tracks[ C + 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_SEQUENCER ) and B and ( B.type == renoise.Track.TRACK_TYPE_SEQUENCER ) or 
      A and ( A.type == renoise.Track.TRACK_TYPE_SEQUENCER ) and B and ( B.type == renoise.Track.TRACK_TYPE_GROUP ) )
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  previous Track is selected." )
  end
end
--- ---
function tool_01_51( A , B , C ) -- jump to next Track (with sequencer track)
  local song = renoise.song()
  C = song.selected_track_index
  repeat 
    C = C + 1
    A = song.tracks[ C ]
    B = song.tracks[ C + 1 ]    
  until ( A and ( A.type == renoise.Track.TRACK_TYPE_SEQUENCER ) and B and ( B.type == renoise.Track.TRACK_TYPE_SEQUENCER ) or
      A and ( A.type == renoise.Track.TRACK_TYPE_SEQUENCER ) and B and ( B.type == renoise.Track.TRACK_TYPE_GROUP ) )
  or not B
  if A and B then
    song.selected_track_index = C
  renoise.app():show_status( "GT16-Colors, GTC:  next Track is selected." )
  end
end



--------------------------------------------------------------------------------
-- GUI - TOOL 01
--------------------------------------------------------------------------------
GTC = 
vb:column {
  vb:horizontal_aligner {
    ----  
    vb:column {
      width = 574,
      vb:horizontal_aligner {
        vb:horizontal_aligner {
          mode = 'center',
          width = 506,
          vb:text { font = 'bold', text = '♛ GTC: Groups & Tracks Control' },
          vb:text { text = '   v1.2' }
        },
        vb:horizontal_aligner {
          mode = 'right',
          width = 60,
          vb:text { text = '+ info ' },
          checkbox_gtc_info
        }
      },
      vb:horizontal_aligner { height = 4 },
      vb:horizontal_aligner {
        vb:text {
          text = '┏━━━━━━━━━━━━━━  Tracks inside Group/s  (MGr, Gr or SGr)   |   or Track only  (Tr)  ━━━━━━━━━━━━━┳━━  Group/s  ━━━┓'
        }
      },  
      vb:horizontal_aligner {
        mode = 'left',
        vb:column {
          vb:horizontal_aligner {
            vb:horizontal_aligner {
              mode = 'right',
              width = 38,
              vb:text { text = 'Show: ' }
            },
            ---
            vb:valuebox { 
              id = '01',
              tooltip = '01: Append/Hide Note Columns of all Tracks inside selected Group.\n[MOUSE CLICK/WHEEL]\n⚠ Limited until 64 members!',
              width = 50,
              height = 24,
              min = 1,
              max = 12,
              value = 1,
              notifier = function(new_index) tool_01_01(new_index) end
            },
            ---
            vb:button {
              active = false,
              color = { 0x06,0x0B,0x40 },
              text = 'NOT',
              id = '02',
              tooltip = '02: Deactivated!',
              height = 24,
              width = 40,
              notifier = function()tool_01_02() end
            },
            vb:button {
              active = false,
              color = { 0x06,0x0B,0x40 },
              text = 'INS',
              id = '03',
              tooltip = '03: Deactivated!',
              height = 24,
              width = 40,
              notifier = function()tool_01_03() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'VOL',
              id = '04',
              tooltip = '04: Show Volume Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_04() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'PAN',
              id = '05',
              tooltip = '05: Show Panning Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_05() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'DLY',
              id = '06',
              tooltip = '06: Show Delay Columns of all Tracks inside selected Group.  \n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_06() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'sFX',
              id = '07',
              tooltip = '07: Show Sample Effects of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_07() end
            },
            ---
            vb:valuebox { 
              id = '08',
              tooltip = '08: Append/Hide Effect Columns of all Tracks inside selected Group.\n[MOUSE CLICK/WHEEL]\n⚠ Limited until 64 members!',
              width = 50,
              height = 24,
              min = 0,
              max = 8,
              value = 0,
              notifier = function(new_index) tool_01_08(new_index) end
            },
            ---
            vb:horizontal_aligner {
              mode = 'right',
              width = 57,
              vb:text { text = 'Show All: '},
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'CLt',
              id = '09',
              tooltip = '09: Show all Parameter Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_09() end
            },
            vb:valuebox { 
              id = '10',
              tooltip = '10: Append/Hide Effect Columns of all Groups inside selected Group.\n[MOUSE CLICK/WHEEL]\n⚠ Limited until 128 members!',
              width = 50,
              height = 24,
              min = 1,
              max = 8,
              value = 1,
              notifier = function(new_index) tool_01_10(new_index) end
            }
          },
          ----
          vb:horizontal_aligner {
            mode = 'left',
            vb:horizontal_aligner {
            mode = 'right',
              width = 38,
              vb:text { text = 'Hide: '},
            },
            vb:button {
              active = false,
              color = { 0x06,0x2B,0x50 },
              text = 'NOTc ┛',
              id = '13',
              tooltip = '13: Control Note Columns above.\nDeactivated!',
              height = 24,
              width = 50,
              notifier = function()tool_01_13() end
            },
            vb:button {
              active = false,
              color = { 0x06,0x0B,0x40 },
              text = 'NOT',
              id = '14',
              tooltip = '14: Deactivated!',
              height = 24,
              width = 40,
              notifier = function()tool_01_14() end
            },
            vb:button {
              active = false,
              color = { 0x06,0x0B,0x40 },
              text = 'INS',
              id = '15',
              tooltip = '15: Deactivated!',
              height = 24,
              width = 40,
              notifier = function()tool_01_15() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'VOL',
              id = '16',
              tooltip = '16: Hide Volume Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_16() end
            },
              vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'PAN',
              id = '17',
              tooltip = '17: Hide Panning Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_17() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'DLY',
              id = '18',
              tooltip = '18: Hide Delay Columns of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_18() end
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'sFX',
              id = '19',
              tooltip = '19: Hide Sample Effects of all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_19() end
            },
            vb:button {
              active = false,
              color = { 0x06,0x2B,0x50 },
              text = 'FXt ┛',
              id = '20',
              tooltip = '20: Control Effect Columns above.\nDeactivated!',
              height = 24,
              width = 50,
              notifier = function()tool_01_20() end
            },
            vb:horizontal_aligner {
              mode = 'right',
              width = 57,
              vb:text { text = 'Hide All: '}
            },
            vb:button {
              color = { 0x06,0x3B,0x70 },
              text = 'CLt',
              id = '21',
              tooltip = '21: Hide all Parameter Columns all Tracks inside selected Group.\n[MOUSE CLICK]',
              height = 24,
              width = 40,
              notifier = function()tool_01_21() end
            },
            vb:button {
              color = { 0x5F,0x00,0x34 },
              text = 'FXg ┛',
              id = '22',
              tooltip = '22: Expand/Collapse Effect Columns of all Groups inside selected Group.\n[MOUSE CLICK]',
              width = 50,
              height = 24,
              notifier = function()tool_01_22() end
            }
          }
        }, --vb:column
        vb:column {
          vb:horizontal_aligner {
            mode = 'right',
            vb:vertical_aligner {
              vb:button {
                color = { 0x7F,0x05,0x54 },
                text = 'Gr',
                id = '11',
                tooltip = '11: Expand all Tracks inside selected Group.\n[MOUSE CLICK]',
                height = 24,
                width = 30,
                notifier = function()tool_01_11() end
              },
              vb:button {
                color = { 0x7F,0x05,0x54 },
                text = 'Gr',
                id = '23',
                tooltip = '23: Collapse all Tracks inside selected Group.\n[MOUSE CLICK]',
                height = 24,
                width = 30,
                notifier = function()tool_01_23() end
              }
            },
            vb:vertical_aligner {
              vb:button {
                color = { 0x7F,0x05,0x54 },
                text = '',
                id = '12',
                tooltip = '12: Expand/Collapse entire Group Selected.\n[MOUSE CLICK]',
                height = 16,
                width = 10,
                notifier = function()tool_01_12() end
              },
              vb:button {
              color = { 0x7F,0x05,0x54 },
                text = '',
                id = '24',
                tooltip = '24: Expand & Collapse at the same time all Tracks inside selected Group.\n[MOUSE CLICK]',
                height = 30,
                width = 10,
                notifier = function()tool_01_24() end
              }
            }
          }
        }
      },
      -----------------------------------------
      vb:horizontal_aligner { height = 5 },
      vb:horizontal_aligner {
        vb:column {
          width = 88,
          vb:horizontal_aligner { height = 7 },
          vb:horizontal_aligner {
            mode = 'right',
            vb:text { text = 'Cleaning Values: ' },
          }
        },
        vb:column {
          vb:horizontal_aligner {
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'NOT',
              id = '26',
              tooltip = '26: Clean Note Columns in pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_26() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'INS',
              id = '27',
              tooltip = '27: Clean Instrument Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_27() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'VOL',
              id = '28',
              tooltip = '28: Clean Volume Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_28() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'PAN',
              id = '29',
              tooltip = '29: Clean Panning Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_29() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'DLY',
              id = '30',
              tooltip = '30: Clean Delay Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_30() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'sFX',
              id = '31',
              tooltip = '31: Clean Sample Effects in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_31() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'FXt',
              id = '32',
              tooltip = '32: Clean Effect Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 50,
              notifier = function()tool_01_32() end
            }
          },
          vb:horizontal_aligner {
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'NOT',
              id = '36',
              tooltip = '36: Clean entire Note Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_36() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'INS',
              id = '37',
              tooltip = '37: Clean entire Instrument Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_37() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'VOL',
              id = '38',
              tooltip = '38: Clean entire Volume Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_38() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'PAN',
              id = '39',
              tooltip = '39: Clean entire Panning Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_39() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'DLY',
              id = '40',
              tooltip = '40: Clean entire Delay Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_40() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'sFX',
              id = '41',
              tooltip = '41: Clean entire Sample Effects all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_41() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'FXt',
              id = '42',
              tooltip = '42: Clean entire Effect Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 50,
              notifier = function()tool_01_42() end
            },
          }
        },
        vb:column{
          width = 57,
          vb:horizontal_aligner { height = 7 },
          vb:horizontal_aligner {
            mode = 'right',
            vb:text { text = 'Clear All: ' }
          }
        },
        vb:column {
          vb:horizontal_aligner {
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'CLt',
              id = '33',
              tooltip = '33: Clean all Parameter Columns in Pattern, all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 22,
              width = 40,
              notifier = function()tool_01_33() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'FXg',
              id = '34',
              tooltip = '34: Clean all Effect Columns in Pattern, all Groups inside selected Group (selected Group included).\n[MOUSE CLICK]',
              height = 22,
              width = 50,
              notifier = function()tool_01_34() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              text = 'CLg ',
              id = '35',
              tooltip = '35: Clean all Parameter Columns in Pattern, selected Group. All included.\n[MOUSE CLICK]',
              height = 22,
              width = 42,
              notifier = function()tool_01_35() end
            }
          },
          vb:horizontal_aligner {
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'CLM',
              id = '43',
              tooltip = '43: Clean all Parameter Columns all Tracks inside selected Group or Track.\n[MOUSE CLICK]',
              height = 12,
              width = 40,
              notifier = function()tool_01_43() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'FXg',
              id = '44',
              tooltip = '44: Clean all Effect Columns all Groups inside selected Group (selected Group included).\n[MOUSE CLICK]',
              height = 12,
              width = 50,
              notifier = function()tool_01_44() end
            },
            vb:button {
              color = { 0x66,0x00,0x00 },
              --text = 'Gr ',
              id = '45',
              tooltip = '45: Clean all Parameter Columns selected Group. All included.\n[MOUSE CLICK]',
              height = 12,
              width = 42,
              notifier = function()tool_01_45() end
            }
          }
        }    
      }
    },
    vb:column {
      vb:vertical_aligner {
        vb:horizontal_aligner {
          vb:button {
            color = { 0x4F,0x0C,0x89 }, -- 0x00,0x60,0x00 green
            id = '46',
            tooltip = '46: Previous Superior Group (Gr/MGr)\n[MOUSE CLICK]',
            width = 52,
            height = 12,
            notifier = function()tool_01_46() end
          },
          vb:button {
            color = { 0x4F,0x0C,0x89 },
            id = '47',
            tooltip = '47: Next Superior Group (Gr/MGr)\n[MOUSE CLICK]',
            width = 52,
            height = 12,
            notifier = function()tool_01_47() end
          }
        },
        vb:horizontal_aligner {
          vb:button {
            color = { 0x4F,0x0C,0x89 },
            text = '◄  SGr',
            id = '48',
            tooltip = '48: Previous SubGroup (SGr with Track/s)\n[MOUSE CLICK]',
            width = 52,
            height = 24,
            notifier = function()tool_01_48() end
          },
          vb:button {
            color = { 0x4F,0x0C,0x89 },
            text = 'SGr  ►',
            id = '49',
            tooltip = '49: Next SubGroup (SGr with Track/s)\n[MOUSE CLICK]',
            width = 52,
            height = 24,
            notifier = function()tool_01_49() end
          }
        },
        vb:horizontal_aligner {
          vb:button {
            color = { 0x4F,0x0C,0x89 },
            id = '50',
            tooltip = '50: Previous Track (Tr)\n[MOUSE CLICK]',
            width = 52,
            height = 12,
            notifier = function()tool_01_50() end
          },
          vb:button {
            color = { 0x4F,0x0C,0x89 },
            id = '51',
            tooltip = '51: Next Track (Tr)\n[MOUSE CLICK]',
            width = 52,
            height = 12,
            notifier = function()tool_01_51() end
          }
        },
        vb:horizontal_aligner { height = 8 },
        vb:horizontal_aligner {
          mode = 'center',
          vb:column {
            style = 'group',
            tooltip = 'Hierarchy between Groups and Tracks...\nThree levels Groups (Main Group, Groups & SubGroups).',
            margin = 5,
            vb:horizontal_aligner {
            height = 58,
              mode = 'justify',
              vb:column{
                width = 60,
                vb:text { text = ' ━━━━━━━━\n ━━━━━━━\n ━━━━━━\n ━━ ━━' }
              },
              vb:column{
                width = 32,
                vb:text { text = 'MGr\nGr\nSGr\nTr' }
              }
            }
          }
        }
      }
    }
  },
  vb:column {
    id ='cbox_gtc_f',
    visible = false,
  },  
  vb:column {
    id = 'cbox_gtc_t',
    visible = false,
    width = 678,
    vb:horizontal_aligner { height = 8 },
    vb:horizontal_aligner {
      mode = 'right',
      gtc_info
    }
  }
}

-- ⊢━━━━━━━━━━━━━━━━━━━━ ━━━━━━━━━━━━━━━━━━━⊣  ┗ ┏━━━━━━━━━━━ Tracks inside the Group ━━━━━━━━━━━┓ ┛  ┻  ┳ ┏┓ ⚠ ♬ ▦ ♛
