--------------------------------------------------------------------------------
-- Module Tool: Tool_06.lua
-- Name: SPNO: Sort Pitches of Notes per Octaves
-- Version: 1.1
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- SWITCH & COLOR BUTTONS
--------------------------------------------------------------------------------
swi_cl_tls01 = vb:switch { items = { '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' , '' } , id = 'tls_switch_cl' , width = 420 , height = 12 , value = 8, tooltip = 'Switch Color Selector of Tool SPNO' }

but_tls = {}
  but_tls.aq = vb:button { active = F , width = 27 , height = 10 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  but_tls.bk = vb:button { active = F , width = 26 , height = 10 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  but_tls.bl = vb:button { active = F , width = 26 , height = 10 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  but_tls.br = vb:button { active = F , width = 26 , height = 10 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  but_tls.gl = vb:button { active = F , width = 26 , height = 10 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  but_tls.gy = vb:button { active = F , width = 26 , height = 10 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  but_tls.gr = vb:button { active = F , width = 26 , height = 10 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  but_tls.og = vb:button { active = F , width = 26 , height = 10 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  but_tls.pl = vb:button { active = F , width = 26 , height = 10 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale_Pink pl
  but_tls.pn = vb:button { active = F , width = 26 , height = 10 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  but_tls.ps = vb:button { active = F , width = 26 , height = 10 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  but_tls.rd = vb:button { active = F , width = 26 , height = 10 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  but_tls.sk = vb:button { active = F , width = 26 , height = 10 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  but_tls.vl = vb:button { active = F , width = 26 , height = 10 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  but_tls.wh = vb:button { active = F , width = 26 , height = 10 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  but_tls.yl = vb:button { active = F , width = 28 , height = 10 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl  



--------------------------------------------------------------------------------
-- FUNCTION FOR CHECKBOX (SHOW or HIDE +INFO...)
--------------------------------------------------------------------------------
function show_cbox_spno( idx )
  LOG( 'show_cbox_spno()' , idx )
  vb.views.cbox_spno_t.visible = ( idx == true )
  vb.views.cbox_spno_f.visible = ( idx == false )
end

checkbox_spno_info = vb:checkbox { id = 'cbox_spno_info', notifier = function(new_idx) show_cbox_spno(new_idx) end }

spno_info = vb:text { text =  "The SPNO tool is designed to sort the pitches of notes inside a SubGroup formed by until 10 tracks with 12 Note Columns...\n"..
                            "  ⚫ First, select a Track (the 'Original Track') and write a complex melody directly or live with a instrument MIDI.\n"..
                  "      Then, use the tool. Select a color and proceed with sort the pitches ('Process SPNO').\n"..
                  "  ⚫ Initially, SPNO process the selected Track, distributing the pitches inside these 10 Tracks ('Octave Tracks').\n"..
                  "      ⚠ Caution: during the process, all Effect Columns are ignored.\n"..
                  "      After the process, if exist Octave Tracks empty, these are automatically erased.\n"..
                  "      Also the original track is muted, collapsed and painted in red color.\n"..
                  "  ⚫ You can compare the final result with the Original Track processed and delete it manually...\n"..
                  "      Finally, you can better understand the melody and make arrangements in the ordered melody more comfortably."
                  }



--------------------------------------------------------------------------------
-- PRINCIPAL FUNCTION: Sort Pitches of Notes per Octaves
--------------------------------------------------------------------------------
function tool_02( switch )

----
  local C = {}
    if switch ==  1 then C = 'Aqua'
  elseif switch ==  2 then C = 'Black'
  elseif switch ==  3 then C = 'Blue'
  elseif switch ==  4 then C = 'Brown'
  elseif switch ==  5 then C = 'Gold'
  elseif switch ==  6 then C = 'Gray'
  elseif switch ==  7 then C = 'Green'
  elseif switch ==  8 then C = 'Orange'
  elseif switch ==  9 then C = 'Pale_Pink'
  elseif switch == 10 then C = 'Pink'
  elseif switch == 11 then C = 'Pistachio'
  elseif switch == 12 then C = 'Red'
  elseif switch == 13 then C = 'Sky_Blue'
  elseif switch == 14 then C = 'Violet'
  elseif switch == 15 then C = 'White'
  elseif switch == 16 then C = 'Yellow'
  end
  local ZERO = _G[ C..'_zero' ]
  local ONE  = _G[ C..'_one' ]
  local TWO  = _G[ C..'_two' ]
  
  local group_settings = {
  ten_octaves = {
    name = 'Octaves '..C..' SubGroup',
    collapsed = false,
    color_blend = 27,
  color = ZERO,
    tracks = {
    { name = "empty" }, -- track empty aux. to select first track always NOTE:1
    { name = "0 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = ONE, color_blend = 10 },
    { name = "1 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = TWO, color_blend = 10 },
    { name = "2 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = ONE, color_blend = 10 },
    { name = "3 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = TWO, color_blend = 10 },
    { name = "4 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = ONE, color_blend = 10 },
    { name = "5 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = TWO, color_blend = 10 },
    { name = "6 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = ONE, color_blend = 10 },
    { name = "7 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = TWO, color_blend = 10 },
    { name = "8 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = ONE, color_blend = 10 },
    { name = "9 Octave "..C.." Track", volume_column_visible = true, delay_column_visible = true, collapsed = true, color = TWO, color_blend = 10 },
    },
    },
  }
  local column_names = { "C  do", "C#", "D  re", "D#", "E  mi", "F  fa", "F#", "G  sol", "G#", "A  la", "A#", "B  si" }
  
  --------- insert_track
  local function insert_track(track_index, group_index, track_setting)
    renoise.song():insert_track_at(track_index)
    local track = renoise.song():track(track_index)
    track.visible_effect_columns, track.visible_note_columns = 0, 12  -- track.volume_column_visible == false
    for parameter_name, parameter_value in pairs(track_setting) do
     track[parameter_name] = parameter_value
    end
    for note_column = 1, 12 do
      track:set_column_name(note_column, column_names[note_column])
    end
    renoise.song():add_track_to_group(track_index, group_index)
  end
  --------- insert_gr
  
  local function insert_gt(group_setting)
    local song = renoise.song()
    local i, group_index, group_setting = 1, song.selected_track_index + 1, group_settings[group_setting]
    song:insert_group_at(group_index)
    for parameter_name, parameter_value in pairs(group_setting) do
      if not (parameter_name == "tracks") then
        song:track(group_index)[parameter_name] = parameter_value
      end
    end
    for _, track_setting in ipairs(group_setting.tracks) do
      local group_index = group_index + i
      i = i + 1
      insert_track(song.selected_track_index, group_index, track_setting)
    end
    song.tracks[song.selected_track_index + 1].group_parent.collapsed = true  -- collapse FX in Group
  end
    
  ----------------------------------------------------------

  
  -- search_table. Search in table a note, return {pattern, column, line} if result one or {0,0,0} if result not neither
  local function search_table(notes,i)
    for j, note in ipairs(notes) do
      if notes[j].note_column.note_value == notes[i].note_column.note_value --igual nota
    and notes[j].column ~= notes[i].column -- distinta columna
    and notes[j].pattern >= notes[i].pattern -- igual p�gina o superior

      and ((notes[j].line > notes[i].line and notes[j].pattern == notes[i].pattern) -- l�nea de abajo y misma p�gina
    or (notes[j].pattern > notes[i].pattern))                  -- o siguientes p�ginas
    and((notes[j].line < notes[i+1].line and notes[j].pattern == notes[i+1].pattern)
    or notes[j].pattern < notes[i+1].pattern)
    then
      return {notes[j].pattern,notes[j].column,notes[j].line}
      end
    end
    return {0,0,0} 
  end
  
  -- explode_pitches
  local function explode_pitches(track_index, first_octave_track_index)
    local song = renoise.song()
    local track = song:track(song.selected_track_index)
    local pattern_iterator = song.pattern_iterator:note_columns_in_track(track_index, true)
    local notes = { }
    local sort_per_column = function(a,b)
    if a.column > b.column then return true -- <
    elseif a.column < b.column then return false -- >
    elseif a.pattern < b.pattern then return true -- <
    elseif a.pattern > b.pattern then return false -- >
    elseif a.line < b.line then return true -- <
    elseif a.line > b.line then return false -- >
    end
  end

  local last_note = {"---","---","---","---","---","---","---","---","---","---","---","---"} --columns
  for pos, note_column in pattern_iterator do
    if not note_column.is_empty then
    
    -- note_column C-0002020406000 (C-000 20 20 40 6000) -- C-X: C NOTE,  X OCTAVE, 
    
    -- print('-----------------------------------------------------')
    -- print(note_column)
    -- print('NOTE: '.. note_column.note_string .. 
       -- ' INS: ' .. note_column.instrument_string ..
     -- ' VOL ' .. note_column.volume_string ..
     -- ' PAN ' .. note_column.panning_string ..
     -- ' DLY ' .. note_column.delay_string ..
     -- ' FX ' .. note_column.effect_number_string ..
     -- ' FA ' .. note_column.effect_amount_string ..
     -- ' P�gina: '.. pos.pattern ..
     -- ' Track: '.. pos.track ..
     -- ' Columna: '.. pos.column ..
     -- ' L�nea: '.. pos.line)
    -- print(last_note[pos.column])
  
  
    -- Table notes: note_column, pattern, track, column, line
      table.insert(notes, { note_column = note_column, note_above = last_note[pos.column], pattern = pos.pattern, track = pos.track, column = pos.column, line = pos.line })
    if(note_column.note_value < 120) then
      last_note[pos.column] = note_column
    end
    end
  end
  
  table.sort(notes, sort_per_column)
  
  for i, note in ipairs(notes) do
    --print(notes[i].note_column)
    --print('C:' .. notes[i].column .. ' L:' .. notes[i].line)
    local dest_track , dest_column, offs
  offs=false

  if note.note_column.note_value > 119 then
    if note.note_above.note_value ~= 120 and note.note_above.note_value ~= 121 and note.note_above.note_value ~= nil then -- have note
      dest_track = first_octave_track_index + math.floor(note.note_above.note_value/12)
      dest_column = (note.note_above.note_value % 12) + 1 --print(dest_column)
        song:pattern(note.pattern):track(dest_track):line(note.line):note_column(dest_column):copy_from(song:pattern(note.pattern):track(note.track):line(note.line):note_column(note.column))
      offs=true
    end
    else
      dest_track = first_octave_track_index + math.floor(note.note_column.note_value/12)
    dest_column = (note.note_column.note_value % 12) + 1 --print(dest_column)
    song:pattern(note.pattern):track(dest_track):line(note.line):note_column(dest_column):copy_from(song:pattern(note.pattern):track(note.track):line(note.line):note_column(note.column))
    offs=true
    end
    
    
    -- (121 -- / 120 OFF)
    -- Write OFF's
    -----------------------------------------------------------
      if notes[i+1] and offs==true then
  
        local n_value = notes[i].note_column.note_value --current
      local n_value1 = notes[i+1].note_column.note_value --next
    -- Note above
    if(notes[i].note_column.note_value == 121) then n_value = notes[i].note_above.note_value end
    if(notes[i+1].note_column.note_value == 121) then n_value1 = notes[i+1].note_above.note_value end
    
        if (notes[i].column == notes[i+1].column) and (song:pattern(notes[i+1].pattern):track(dest_track):line(notes[i+1].line):note_column(dest_column).note_value == 121) 
    and (n_value ~= n_value1 and n_value1 ~= 120 and n_value  ~= 120 ) then
            
      local exist = search_table(notes,i)
      if exist[1] == 0  then -- if pattern == 0
        local next_note = song:pattern(notes[i+1].pattern):track(dest_track):line(notes[i+1].line):note_column(dest_column)
      next_note.note_value = 120
          --*** print('Note of P: '..notes[i].pattern..' C: ' .. notes[i].column .. ' L: ' .. notes[i].line-1 .. ' --- Linea off: '.. notes[i+1].line-1)
        --..' --- Duplicate note in: P'..exist[1]..' C'..exist[2]..' L'..exist[3]-1)        
      end
        end
      end
    --print('  ')
    end
  end
  --------- explode_pitches
  
  local function delete_tracks_empty()
    local song = renoise.song()
    local tindex = song.selected_track_index
    song:track(tindex).collapsed = true  -- original track
    song:track(tindex).color_blend = 10
    song:track(tindex).color = { 0xFF,0x00,0x00 } -- Red Color
    song.tracks[tindex]:mute()

    local first_octave_track = tindex + 1
    for group_index = first_octave_track + 10, first_octave_track, - 1 do -- range in group: for 10+1, 1, -1 do (11 octaves, the first track is the track empty aux)
      local was_empty = false
      for _, pattern in ipairs(song.patterns) do
        if not pattern:track(group_index).is_empty then
          was_empty = true
        end
      end
      if not was_empty then
        song:delete_track_at(group_index)
      end
    end
    song:track(tindex + 1).collapsed = false  -- select first track
  end
  --------- delete_tracks_empty
  local song = renoise.song()
  insert_gt("ten_octaves") explode_pitches(song.selected_track_index, song.selected_track_index + 2) delete_tracks_empty()
----
end


function process_02()
  local song = renoise.song()
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then
    tool_02 ( swi_cl_tls01.value )
    renoise.app():show_status( "GT16-Colors, SPNO:  track selected is Processed. Octave Group that contains Octave Tracks (12 Note Columns) is inserted." )
    else renoise.app():show_status( "⚠ GT16-Colors, SPNO:  to process select above a Track with Notes in Pattern Editor!" )
  end
end



--------------------------------------------------------------------------------
-- GUI - TOOL 02
--------------------------------------------------------------------------------
SPNO = 
vb:column {
  vb:horizontal_aligner {
    vb:horizontal_aligner {
      mode = 'center',
      width = 618,
      vb:text { font = 'bold', text = '♬ SPNO: Sort Pitches of Notes per Octaves' },
      vb:text { font = 'normal', text = '   v1.1' }
    },
    vb:horizontal_aligner {
      mode = 'right',
      width = 59,
      vb:text { text = '+ info ' },
      checkbox_spno_info
    }
  },
  vb:horizontal_aligner { height = 10 },
  vb:horizontal_aligner {
    mode = 'justify',
    vb:column {
      width = 440,
      height = '100%',
      swi_cl_tls01,
      vb:horizontal_aligner {
        but_tls.aq, but_tls.bk, but_tls.bl, but_tls.br, but_tls.gl, but_tls.gy, but_tls.gr, but_tls.og, but_tls.pl, but_tls.pn, but_tls.ps, but_tls.rd, but_tls.sk, but_tls.vl, but_tls.wh, but_tls.yl
      }
    },
    vb:column {
      width = 238,
      height = '100%',
      vb:horizontal_aligner {
        mode = 'center',
        vb:button {
          color = { 0x00,0x60,0x00 },
          text = 'Process SPNO',
          id = 'tool_02',
          tooltip = 'Sort Pitches of Notes per Octaves\n[ALT + RETURN]',
          height = 24,
          width = '55%',
          notifier = function()process_02() end
        }
      }
    }
  },
  vb:column {
    id ='cbox_spno_f',
  visible = false,
  },  
  vb:column {
    id = 'cbox_spno_t',
    visible = false,
    width = 678,
    vb:horizontal_aligner { height = 10 },
    vb:horizontal_aligner {
      mode = 'right',
      spno_info
    }  
  }  
}

-- ≡◄ ▲ ▼  ◄ ◄◄ ►► ► ◂ ⏯ ⏵⏸⏴ ⏪ ⏩ ⏮ ⏭ ☚ ☛ ↩ ↪ ↶ ↷ 🎹 ⚒ ☠ ☢ ☣ ⚠ ☺ ⧗ 🗗 🗕 ⇱ ⇲ ☊ ↹ ♬
